/* Data records.
 *
 * PegSoft databases library (c) 2005 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <system/headers.h>

#include <misc/misc.h>

#include "databases/record.h"

using namespace std;

/*************************************************************************/

namespace databases
{

/*************************************************************************/

bool NameRecord::matches(char const *pattern) const
{
	return misc::match(pattern, name()); 
}

/*************************************************************************/

Record &Record::operator=(Record const &right)
{
	if (this != &right)
	{
		m_id = 0;
		m_db_status = 0;
	}
	
	return *this;
}

/*************************************************************************/

void Record::begin_update()
{ 
	m_db_status |= (dbsInsert | dbsUpdating);
}

/*************************************************************************/

bool Record::end_update()
{ 
	m_db_status &= ~dbsUpdating;
	
	if (m_db_status & dbsUpdateError)
	{
		m_db_status &= ~dbsUpdateError;
		return false;
	}
	
	return true;
}

/*************************************************************************/

Record::identifier_type Record::id(identifier_type id)
{
	if (m_id == 0)
		m_id = id;
	return m_id;
}

/*************************************************************************/

} /* namespace databases */

/*************************************************************************/
