/* stat() wrappers.
 *
 * PegSoft miscellaneous library (c) 2004 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software (the COPYING file); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 */

#include <system/headers.h>

#if HAVE_SYS_STAT_H
# include <sys/stat.h>
#endif

#include "misc/misc.h"

using namespace std;

/*************************************************************************/

namespace misc
{

/*************************************************************************/

bool dir_exists(char const *dirname)
{
	struct stat st;
	
	if (stat(dirname, &st) == -1)
		return false;
	
	if (S_ISDIR(st.st_mode))
		return true;
	
#if ENOTDIR
	errno = ENOTDIR;
#endif
	return false;
}

/*************************************************************************/

bool file_exists(char const *filename)
{
	struct stat st;
	
	if (stat(filename, &st) == -1)
		return false;
	
	if (S_ISREG(st.st_mode))
		return true;
	
#if EISDIR
	if (S_ISDIR(st.st_mode))
		errno = EISDIR;
#endif

	return false;
}

/*************************************************************************/

} /* namespace misc */

/*************************************************************************/
