/* String-related treasures.
 *
 * PegSoft miscellaneous library (c) 2004 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software (the COPYING file); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 */

#include <system/headers.h>

#include "misc/uri.h"

using namespace std;

/*************************************************************************/

namespace misc
{

/*************************************************************************/

void URI::clear()
{
	m_scheme.clear();
	m_contents.clear();
	
	m_authority.clear();
	m_path.clear();
	m_query.clear();
	
	m_hostname.clear();
	m_port = 0;
	m_username.clear();
	m_password.clear();
	
	m_parameters.clear();
}

/*************************************************************************/

URI &URI::operator=(URI const &right)
{
	if (this != &right)
	{
		m_uri = right.m_uri;
		
		m_scheme = right.m_scheme;
		m_contents = right.m_contents;
		
		m_authority = right.m_authority;
		m_path = right.m_path;
		m_query = right.m_query;
		
		m_hostname = right.m_hostname;
		m_port = right.m_port;
		m_username = right.m_username;
		m_password = right.m_password;
		
		m_parameters = right.m_parameters;
	}
	
	return *this;
}

/*************************************************************************/

} /* namespace misc */

/*************************************************************************/
