/* Configuring modules.
 *
 * PegSoft modules subsystem library (c) 2005 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software (the COPYING file); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 */

#include <system/headers.h>

#include "modules/conf.h"

using namespace std;
using namespace conf;

/*************************************************************************/

#define CHECK_ADD(x, x2, y) if (!(x).add((y))) { \
	(x2).errorf("Can't add directive %s: out of memory?", (y).name().c_str()); \
	return false; }

/*************************************************************************/

namespace modules
{

/*************************************************************************/

ConfModule::ConfModule(std::string const &name, bool reloadable) :
	ConfBlock(name, reloadable), mname("name", true, 1, PATH_MAX, ""),
	config("config", true, 1, INT_MAX, "")
{
	
}

/*************************************************************************/

bool ConfModule::add(conf::Conf &conf, conf::Conf &new_conf)
{
	CHECK_ADD(new_conf, conf, mname);
	CHECK_ADD(new_conf, conf, config);
	
	return true;
}

/*************************************************************************/

ConfModuleA::ConfModuleA() :
		conf::ConfArray<ConfModule, std::vector<ConfModule> >("module",
		container_type(), true)
{
	
}

/*************************************************************************/

LoadModule::LoadModule() : ConfStrCharA("load-module", container_type(), false)
{
	
} 

/*************************************************************************/

} /* namespace modules */

/*************************************************************************/
