/* A brick.
 *
 * PegSoft modules subsystem library (c) 2005 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software (the COPYING file); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 */

#include <system/headers.h>

#include "modules/module.h"

using namespace std;

/*************************************************************************/

namespace modules
{

/*************************************************************************/

bool Module::load(Core &core)
{
	m_state |= msLoaded;
	return true;
}

/*************************************************************************/

void Module::start(Core &core)
{
	m_state |= msStarted;
}

/*************************************************************************/

bool Module::stop(Core &core)
{
	m_state &= ~msStarted;
	return true;
}

/*************************************************************************/

void Module::unload(Core &core)
{
	m_state &= ~msLoaded;
}

/*************************************************************************/

} /* namespace modules */

/*************************************************************************/
