/* select()-based monitor class.
 *
 * PegSoft sockets library (c) 2007 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef MY_SELECT_H
#define MY_SELECT_H

/*************************************************************************/

#include <set>

#if HAVE_SYS_SELECT_H
# include <sys/select.h>
#endif

#include "sockets/monitor.h"

/*************************************************************************/

namespace sockets
{

/*************************************************************************/

class Select : public Monitor
{
	public:
		/// Constructor.
		Select(size_t hint);
	protected:
		virtual void do_events(time_t wait);
		virtual bool add(Socket *s, int fd, unsigned int events);
		virtual bool update(Socket *s, int fd, unsigned int events);
		virtual void remove(Socket *s, int fd);
	private:
		typedef std::set<int> fds_list;
		fds_list m_rfds;
		fds_list m_wfds;
		
		fd_set m_rds;
		fd_set m_wds;
		
		int last_fd() const;
};

/*************************************************************************/

} /* namespace sockets */

/*************************************************************************/

#endif /* MY_SELECT_H */
