/* Blacklist header file.
 *
 * Epona (c) 2000-2002, 2004 PegSoft
 * Contact us at epona@pegsoft.net
 *
 * Based on the original code of Services by Andy Church.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef BLACKLIST_H
#define BLACKLIST_H

/*************************************************************************/

#include <containers/hashlist.h>

#include "netbans.h"
#include "services.h"

/*************************************************************************/

/* Proxy stuff */

class BLHost
{	
	public:
		typedef containers::HashList<BLHost *, char const *, 1024> list_type;
	
		BLHost();
		~BLHost();
		
		char const *mask() { return m_mask; }
		
		bool mask(char const *mask);
	private:
		NetBan *m_ban;
		misc::cstring m_mask;  /// Our own mask representation.
		list_type::iterator m_iter;
};

/*************************************************************************/

extern void get_blacklist_stats(long *nrec, long *memuse);
extern void blacklist_init();
extern void blacklist_update();

extern void do_blacklist(User *u);

/*************************************************************************/

#endif /* BLACKLIST_H */
