/* SHA1 module.
 *
 * SHA1 module (c) 2006 PegSoft
 * Contact us at pegsoft@pegsoft.net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef MODULE_H
#define MODULE_H

/*************************************************************************/

#include <modules/module.h>

#include "password.h"

/*************************************************************************/

namespace modules { class Core; }

/*************************************************************************/

namespace sha1 
{

/*************************************************************************/

/// SHA1 module version
static int const sha1_version = 0x01000000;

/// The sha1 module class
class SHA1 : public modules::Module
{
	public:
		/// Constructor.
		SHA1(modules::Core &core);
		
		/// Implements Module::version().
		virtual int version() const { return sha1_version; }
		
		/// Overrides Module::interface().
		virtual modules::Interface *interface(modules::PSIID iid);
		
		/// Returns the core module.
		modules::Core &core() { return *m_core; }
	private:
		modules::Core *m_core;
		Encrypter m_encrypter;
};

/*************************************************************************/

} /* namespace sha1 */

/*************************************************************************/

#endif /* MODULE_H */
