# German language file.
#
# Epona (c) 2000-2002, 2004 PegSoft
# Contact us at epona@pegsoft.net
#
# This program is free but copyrighted software; see the file COPYING for
# details.
#
# Based on the original code of Services by Andy Church.

# When translating this file to another language, keep in mind that the
# order of parameters for sprintf() is fixed in the source code, so your
# messages need to take the same parameters in the same order as the
# English messages do.  (Obviously, this doesn't hold for the strftime()
# format lines immediately below.)  If you can't get a natural translation
# of a message without changing the order of the parameters, let me know
# (achurch@dragonfire.net) which message is causing a problem and I'll see
# what I can do.
#
# In help messages, "%S" (capital S, not lowercase) refers to the name of
# the service sending the message; for example, in NickServ help messages,
# "%S" is replaced by "NickServ" (or whatever it is renamed to in
# config.h).  The %S's do not count as sprintf() parameters, so they can be
# rearranged, removed, or added as necessary.
#
# Also in help messages, please try to limit line lengths to 60 characters
# of text (not including the leading tab).  This length was chosen because
# it does not cause line wrap under default settings on most current IRC
# clients.  Remember that format characters (control-B, control-_) are not
# included in that 60-character limit (since they don't show on the user's
# screen).  Also remember that format specifiers (%S, etc.) will expand
# when displayed, so remember to take this into account; you can assume
# that the length of a pseudoclient name (%S replacement) will be eight
# characters, so reduce the maximum line length by 6 for every %S on a
# line.
#
# Finally, remember to put a tab at the beginning of every line of text
# (including empty lines).  This has to be a tab, not spaces.
# 
# Translation by:
# Phantomal (phantomal@solidirc.com)
# phrozen77 (phrozen77@solidirc.com)
# PChaos    (pchaos@solidirc.com)
#
# For Translation Mistakes or Suggestions write a mail to Phantomal




###########################################################################
#
# Name of this language
#
###########################################################################

# For languages other than English, this string should have the following
# format:
#     language-name-in-language (language-name-in-English)
# For example, "Espaol (Spanish)" or "Franais (French)".

LANG_NAME
	Deutsch (German)

###########################################################################
#
# General messages
#
###########################################################################

# strftime() format strings.  man 3 strftime for information on the
# meanings of the format specifiers.  Short version:
#	%a = weekday name (short)	%H = hour
#	%b = month name (short)		%M = minute
#	%d = day of month		%S = second
#	%Y = year			%Z = time zone

# This is used as the format string for strftime() for a date and time
# together.
STRFTIME_DATE_TIME_FORMAT
	%d.%b.%Y, %H:%M:%S %Z
# This is used as the format string for strftime() for a date alone in long
# format (English: including weekday).
STRFTIME_LONG_DATE_FORMAT
	%a, %d.%B.%Y
# This is used as the format string for strftime() for a date alone in
# short format (English: without weekday).
STRFTIME_SHORT_DATE_FORMAT
	%d.%b.%Y

# These tell our strftime() what the names of months and days are.  If you
# don't use %a, %A, %b, or %B in your strftime() strings above, you can
# leave these empty.  However, if you enter names, they MUST stay in order,
# one per line, and the list MUST be complete!

# %a
STRFTIME_DAYS_SHORT
	Son
	Mon
	Die
	Mit
	Don
	Fre
	Sam
# %A
STRFTIME_DAYS_LONG
	Sonntag
	Montag
	Dienstag
	Mittwoch
	Donnerstag
	Freitag
	Samstag
# %b
STRFTIME_MONTHS_SHORT
	Jan
	Feb
	Mr
	Apr
	Mai
	Jun
	Jul
	Aug
	Sep
	Okt
	Nov
	Dez
# %B
STRFTIME_MONTHS_LONG
	Januar
	Februar
	Mrz
	April
	Mai
	Juni
	Juli
	August
	September
	Oktober
	November
	Dezember


# This is used in ChanServ/NickServ INFO displays.
COMMA_SPACE
	, 


# Various error messages.
USER_RECORD_NOT_FOUND
	Interner Fehler - kann Anfrage nicht verarbeiten.
UNKNOWN_COMMAND
	Unbekannter Befehl %s.
UNKNOWN_COMMAND_HELP
	Unbekannter Befehl %s.  "/msg %s HELP" fr Hilfe.
SYNTAX_ERROR
	Syntax: %s
MORE_INFO
	/msg %s HELP %s fr weitere Informationen.
NO_HELP_AVAILABLE
	Keine Hilfe fr %s verfgbar.
OBSOLETE_COMMAND
	Dieser Befehl ist veraltet; benutze stattdessen %s.
REMOVED_COMMAND
	Dieser Befehl wurde entfernt; benutze von nun an %s %s.
BAD_USERHOST_MASK
	Maske sollte in dieser Form sein: user@host.
BAD_EXPIRY_TIME
	Ungltige Ablaufzeit.
USERHOST_MASK_TOO_WIDE
	%s ist zu allgemeingltig; bitte benutze eine genauere Hostmaske.
SERVICE_OFFLINE
	%s ist derzeit nicht verfgbar, bitte versuche es spter
	noch einmal.
READ_ONLY_MODE
	Hinweis: Die Services befinden sich im nur-lesen-Modus;
	nderungen werden nicht bernommen!
PASSWORD_INCORRECT
	Das Passwort ist ungltig.

# What's the difference between "Access denied" and "Permission denied"?
# Very little; you can safely make them the same message with no real loss
# of meaning.  If you want to make a distinction, "Access denied" is
# usually used more generally; for example, a non-oper trying to access
# OperServ gets "Access denied", while a non-Services admin trying to use
# NickServ SET NOEXPIRE gets "Permission denied".
ACCESS_DENIED
	Zugriff verweigert.
PERMISSION_DENIED
	Berechtigung nicht ausreichend.

MORE_OBSCURE_PASSWORD
	Bitte versuche es nochmal mit einem besseren Passwort. 
	Passwrter sollten mindestens 5 Zeichen lang sein und nichts
	mit deinem Nick- oder Realnamen zu tun haben. Weiterhin darf
	keine Leer- oder Tabulatortaste enthalten sein.
PASSWORD_TRUNCATED
	Achtung: Dein Passwort wurde auf %d Zeichen gekrzt.
NICK_NOT_REGISTERED
	Dein Nick ist nicht registriert.
NICK_NOT_REGISTERED_HELP
	Dein Nick ist nicht registriert.  Benutze /msg %s HELP
	fr weitere Hilfe, wie du deinen Nick registrieren kannst.
NICK_X_NOT_REGISTERED
	Nick %s ist nicht registriert.
NICK_X_NOT_IN_USE
	Nick %s wird derzeit nicht verwendet.
NICK_X_NOT_ON_CHAN
	%s befindet sich derzeitig nicht im Channel %s.
CHAN_X_NOT_REGISTERED
	Channel %s ist nicht registriert.
CHAN_X_NOT_IN_USE
	Channel %s existiert nicht.
NICK_IDENTIFY_REQUIRED
	Um diesen Befehl nutzen zu knnen, musst du dich identifizieren.
	Versuch es erneut nach /msg %s IDENTIFY Passwort.
CHAN_IDENTIFY_REQUIRED
	Um diesen Befehl nutzen zu knnen, musst du dich identifizieren.
	Versuch es erneut nach /msg %s IDENTIFY Passwort.
MAIL_DISABLED
	Das Senden von eMails durch die Services wurde abgeschaltet.
MAIL_INVALID
	eMail-Adresse fr %s ist ungltig.
MAIL_X_INVALID
	%s ist keine gltige eMail-Adresse.
MAIL_LATER
	Die Services knnen gerade keine eMail verschicken; bitte
	versuche es spter noch einmal.
MAIL_DELAYED
	Bitte warte noch %d Sekunden und versuche es dann erneut.
	
NO_REASON
	Kein Grund
UNKNOWN
	<unbekannt>

# Duration system
DURATION_DAY
	1 Tag
DURATION_DAYS
	%d Tage
DURATION_HOUR
	1 Stunde
DURATION_HOURS
	%d Stunden
DURATION_MINUTE
	1 Minute
DURATION_MINUTES
	%d Minuten
DURATION_SECOND
	1 Sekunde
DURATION_SECONDS
	%d Sekunden
	
# Human readable expiration
NO_EXPIRE
	luft nicht aus
EXPIRES_SOON
	verfllt beim nchsten Datenbank-Update
EXPIRES_M
	verfllt in %d Minuten
EXPIRES_1M
	verfllt in %d Minute
EXPIRES_HM
	verfllt in %d Stunden, %d Minuten
EXPIRES_H1M
	verfllt in %d Stunden, %d Minute
EXPIRES_1HM
	verfllt in %d Stunde, %d Minuten
EXPIRES_1H1M
	verfllt in %d Stunde, %d Minute
EXPIRES_D
	verfllt in %d Tagen
EXPIRES_1D
	verfllt in %d Tag

###########################################################################
#
# NickServ messages
#
###########################################################################

# Automatic messages
NICK_IS_REGISTERED
	Dieser Nick gehrt schon jemand anderem. Bitte whle einen anderen.
	(Wenn der Nick dir gehrt, tippe /msg %s IDENTIFY Passwort.)
NICK_IS_SECURE
	Dieser Nickname ist registriert and geschtzt.  Wenn es dein Nick
	ist, tippe /msg %s IDENTIFY Passwort. Ansonsten whle bitte
	einen anderen Nick.
FORCENICKCHANGE_IN_1_MINUTE
	Wenn du ihn nicht innerhalb einer Minute identifizierst, wird er automatisch gendert.
FORCENICKCHANGE_IN_20_SECONDS
	Wenn du ihn nicht innerhalb von 20 Sekunden identifizierst, wird er automatisch gendert.
FORCENICKCHANGE_NOW
	Dieser Nickname ist registriert, du kannst ihn nicht benutzen.
FORCENICKCHANGE_CHANGING
	Dein Nickname wird gendert in %s

# REGISTER responses
NICK_REGISTER_SYNTAX
	REGISTER Passwort [eMail]
NICK_REGISTER_SYNTAX_EMAIL
	REGISTER Passwort eMail
NICK_REGISTRATION_DISABLED
	Sorry, das Registrieren von Nicknames ist derzeit deaktiviert.
NICK_REGISTRATION_FAILED
	Sorry, Registrierung fehlgeschlagen.
NICK_REG_PLEASE_WAIT
	Bitte warte %d Sekunden, bevor der du den REGISTER Befehl wieder verwenden kannst.
NICK_CANNOT_BE_REGISTERED
	Nickname %s darf nicht registriert werden.
NICK_ALREADY_REGISTERED
	Nickname %s ist bereits registriert!
NICK_REGISTERED
	Nickname %s ist unter deinem Host registriert worden: %s
NICK_PASSWORD_IS
	Dein Passwort ist %s - behalte es fr sptere Benutzung.

# GROUP responses
NICK_GROUP_SYNTAX
	GROUP Ziel Passwort
NICK_GROUP_DISABLED
	Sorry, das Gruppieren von Nicknames ist derzeit deaktiviert.
NICK_GROUP_PLEASE_WAIT
	Bitte warte %d Sekunden, bevor du den GROUP Befehl wieder verwenden kannst.
NICK_GROUP_CHANGE_DISABLED
	Der Nick ist bereits registriert. Du musst ihn erst mit /msg %s DROP lschen.
NICK_GROUP_SAME
	Du bist bereits Mitglieder der Nickgruppe von %s.
NICK_GROUP_NOT_AUTH
	Du kannst keiner Gruppe beitreten, deren Emailadresse noch nicht besttigt wurde.
NICK_GROUP_TOO_MANY
	Der Gruppe %s gehren bereits zu viele Nicks an. Schaue sie dir an,
	und lsche einige davon. Gib /msg %s HELP GLIST und /msg %s HELP DROP
	ein, um weitere Informationen zu erhalten.
NICK_GROUP_FAILED
	Sorry, Gruppieren fehlgeschlagen.
NICK_GROUP_JOINED
	Du bist nun Mitglied der Gruppe %s.

# IDENTIFY responses
NICK_IDENTIFY_SYNTAX
	IDENTIFY Passwort
NICK_IDENTIFY_NOT_AUTH
	Du kannst dich nicht fr einen Nick anmelden, dessen eMail-Adresse nicht besttigt wurde.
NICK_IDENTIFY_NOT_AUTH_HOWTO
	Gib /msg %s HELP AUTH ein, um weitere Informationen zum Besttigungsprozess zu erhalten.
NICK_IDENTIFY_SUCCEEDED
	Passwort akzeptiert - Du bist nun angemeldet.
NICK_IDENTIFY_EMAIL_REQUIRED
	Du musst eine eMail-Adresse fr deinen Nick angeben.
	Mit dieser eMail-Adresse kannst du dein Kennwort erhalten wenn du es
	vergessen haben solltest.
NICK_IDENTIFY_EMAIL_HOWTO
	Gib /msg %s SET EMAIL eMail ein, wenn du deine eMail-Adresse
	einstellen willst. Deine Privatsphre wird respektiert; diese
	eMail-Adresse ist Dritten nicht zugnglich.

# LOGOUT responses
NICK_LOGOUT_SYNTAX
	LOGOUT
NICK_LOGOUT_SUCCEEDED
	Du wurdest abgemeldet.
NICK_LOGOUT_X_SUCCEEDED
	Nick %s wurde abgemeldet.

# AUTH responses
NICK_AUTH_SYNTAX
	AUTH [Code | PASS | CANCEL] [Code Neues-Passwort]
NICK_AUTH_UNAVAILABLE
	Sorry, aber die eMail-Besttigung ist deaktiviert.
NICK_AUTH_DISABLED
	Sorry, aber die eMail-Besttigung ist im Moment leider nicht verfgbar.
NICK_AUTH_NOT_IN_PROGRESS
	Derzeitig luft keine eMail-Besttigung fr diesen Nick.
NICK_AUTH_START_EMAIL_MISSING
	Du musst zuerst eine eMail-Adresse fr diesen Nick festlegen.
	Gib /msg %s HELP SET EMAIL ein, um weitere Informationen zu erhalten.
NICK_AUTH_START_AUTHENTIFIED
	Deine eMail-Adresse ist bereits Besttigt.
NICK_AUTH_START_ALREADY
	Es luft bereits ein Versuch deine eMail-Adresse zu besttigen.
NICK_AUTH_START_FAILED
	Sorry, aber der Vorgang der eMail-Besttigung konnte nicht gestartet werden.
	Bitte versuche es spter erneut.
NICK_AUTH_START_REQUIRED
	Bitte besttige die Echtheit deiner eMail-Adresse
NICK_AUTH_START_REQUIRED_NO_IDENTIFY
	Du musst die Echtheit deiner eMail-Adresse besttigen, bevor du deinen Nick verwenden kannst.
NICK_AUTH_START_DONE
	Die Informationen, wie die eMail-Besttigung durchgefhrt werden kann, wurden an %s gesendet.
NICK_AUTH_START_DONE_PRIVATE
	Die Informationen, wie die eMail-Besttigung durchgefhrt werden kann, wurden dir per eMail zugeschickt.
NICK_AUTH_END_BAD_CODE
	%s ist nicht der richtige Besttigungscode.
NICK_AUTH_END_TOO_MANY
	Die eMail-Besttigung wurde aufgrund zu vieler Fehlversuche abgebrochen.
NICK_AUTH_END_FAILED
	Sorry, dass Abschlieen der eMail-Besttigung schlug leider fehl. Bitte versuche es spter erneut.
NICK_AUTH_END_DONE
	Die Echtheit deiner eMail-Adresse ist jetzt besttigt. Vielen Dank.
NICK_AUTH_PASS_UNAVAILABLE
	Der AUTH PASS Befehl ist fr deinen Nick nicht verfgbar.
NICK_AUTH_CANCEL_DONE
	Die eMail-Besttigung wurde abgebrochen.
NICK_AUTH_MAIL_SUBJECT
	Besttigung der Echtheit der Mailadresse fr den Nick: %s
NICK_AUTH_MAIL_HEAD
	Hallo,
NICK_AUTH_MAIL_LINE_1
	Diese Nachricht ist Teil der eMail-Besttigungsprozedur von %s.
	Durch die Besttigung deiner eMail-Adresse verringerst du das Risiko
	des Missbrauchs deines Nicknamens.
NICK_AUTH_MAIL_LINE_2
	Um den Besttigungsprozess abzuschlieen, gib bitte den folgenden Befehl
	im IRC ein, whrend du im Besitz deines richtigen Nicks bist:
	
	/msg %s AUTH %X
	
	(Wichtig ist dass du den richtigen Nick hast, whrend du den Befehl
	 ausfhrst, da er ansonsten fehlschlagen wird.)
NICK_AUTH_MAIL_LINE_2_WEB
	Um den Besttigungsprozess abzuschlieen, klicke bitte auf den folgenden Link:
	<%s>
NICK_AUTH_MAIL_LINE_3
	Wenn du nicht der Besitzer des Nicks %s bist, oder du nicht weisst worum es in
	dieser eMail geht, ignoriere sie bitte.
NICK_AUTH_MAIL_LINE_4
	Falls du Fragen bezglich unserer Datenschutz- oder Sicherheitsrichtlinien,
	oder dem Emailbesttigungsprozess im allgemeinen hast, joine einfach den
	Channel %s.
NICK_AUTH_MAIL_LINE_5
	Deine %s Netzwerkbetreuung.

# DROP responses
NICK_DROP_DISABLED
	Sorry, aber das Lschen von Nicknamen ist im Moment deaktiviert.
NICK_DROP_FAILED
	Sorry, aber der Versuch deinen Nicknamen zu lschen, schlug fehl.
NICK_DROPPED
	Dein Nickname wurde gelscht.
NICK_X_DROPPED
	Nickname %s wurde gelscht.

# SET responses
NICK_SET_SYNTAX
	SET Option Parameter
NICK_SET_SERVADMIN_SYNTAX
	SET [=Nick] Option Parameter
NICK_SET_DISABLED
	Sorry, aber dass Verndern von Nickname-Einstellungen ist im Moment deaktiviert.
NICK_SET_UNKNOWN_OPTION
	Unknown SET option %s.
NICK_SET_OPTION_DISABLED
	Die Einstellung %s ist deaktiviert und kann daher nicht verndert werden.

# SET GNAME responses
NICK_SET_GNAME_INVALID
	Der neue Name muss einem in der Gruppe vorhandenen Nicknamen entsprechen!
NICK_SET_GNAME_CHANGED
	Die Gruppe heit nun %s.
NICK_SET_SERVADMIN_GNAME_CHANGED
	Der name der Gruppe von %s wurde in %s gendert.

# SET PASSWORD responses
NICK_SET_PASSWORD_FAILED
	Sorry, aber die Passwortnderung ist fehlgeschlagen.
NICK_SET_PASSWORD_CHANGED
	Das Passwort wurde gendert.
NICK_SET_SERVADMIN_PASSWORD_CHANGED
	Das Passwort von %s wurde gendert.
NICK_SET_PASSWORD_CHANGED_TO
	Das Passwort wurde zu %s gendert.
NICK_SET_SERVADMIN_PASSWORD_CHANGED_TO
	Das Passwort von %s wurde in %s gendert.

# SET LANGUAGE responses
NICK_SET_LANGUAGE_SYNTAX
	SET LANGUAGE Nummer
NICK_SET_LANGUAGE_UNKNOWN
	Die Sprach-Nummer %d ist nicht vergeben. Gib /msg %s HELP SET LANGUAGE ein
	um eine Liste der verfgbaren Sprachen zu erhalten.
NICK_SET_LANGUAGE_CHANGED
	Die Sprache wurde in Deutsch gendert.
NICK_SET_SERVADMIN_LANGUAGE_CHANGED
	Die Sprache von %s wurde zu Deutsch gendert.
# SET URL responses
NICK_SET_URL_CHANGED
	Deine neue URL (%s) wurde gespeichert.
NICK_SET_SERVADMIN_URL_CHANGED
	Die URL von %s wurde zu %s gendert.
NICK_SET_URL_UNSET
	Deine URL wurde gelscht.
NICK_SET_SERVADMIN_URL_UNSET
	Die URL von %s wurde gelscht.

# SET EMAIL responses
NICK_SET_EMAIL_CHANGED
	Deine neue eMail-Adresse (%s) wurde gespeichert.
NICK_SET_SERVADMIN_EMAIL_CHANGED
	Die eMail-Address von %s wurde in %s gendert.
NICK_SET_EMAIL_UNSET
	Deine eMail-Adresse wurde gelscht.
NICK_SET_SERVADMIN_EMAIL_UNSET
	Die eMail-Adresse von %s wurde gelscht.
NICK_SET_EMAIL_UNSET_IMPOSSIBLE
	Du kannst deine eMail-Adresse auf diesem Netzwerk nicht lschen.

# SET IM responses
NICK_SET_IM_SYNTAX
	SET IM [Programmkrzel Mitgliedsname]
NICK_SET_IM_UNSUPPORTED_TYPE
	%s ist kein gltiges Programmkrzel. Mgliche Programme sind: %s.
NICK_SET_IM_CHANGED
	Deine Instant-Messaging Info wurde in %s (%s) gendert.
NICK_SET_SERVADMIN_IM_CHANGED
	Die Instant-Messaging Info von %s wurde zu %s (%s) gendert.
NICK_SET_IM_UNSET
	Deine Instant-Messaging Info wurde gelscht.
NICK_SET_SERVADMIN_IM_UNSET
	Die Instant-Messaging Info von %s wurde gelscht.

# SET GREET responses
NICK_SET_GREET_CHANGED
	Deine Begrungsnachricht wurde in %s gendert.
NICK_SET_SERVADMIN_GREET_CHANGED
	Die Begrungsnachricht von %s wurde zu %s gendert.
NICK_SET_GREET_UNSET
	Deine Begrungsnachricht wurde gelscht.
NICK_SET_SERVADMIN_GREET_UNSET
	Die Begrungsnachricht von %s wurde gelscht.

# SET PROTECT responses
NICK_SET_KILL_SYNTAX
	SET KILL {ON | QUICK | OFF}
NICK_SET_KILL_IMMED_SYNTAX
	SET KILL {ON | QUICK | IMMED | OFF}
NICK_SET_KILL_ON
	Der Nickname Schutz ist jetzt aktiviert.
NICK_SET_SERVADMIN_KILL_ON
	Der Nickname Schutz fr %s ist jetzt aktiviert.
NICK_SET_KILL_QUICK
	Der Nickname Schutz ist jetzt mit kurzer Wartezeit aktiviert.
NICK_SET_SERVADMIN_KILL_QUICK
	Der Nickname Schutz fr %s ist jetzt mit kurzer Wartezeit aktiviert.
NICK_SET_KILL_IMMED
	Der Nickname Schutz ist jetzt ohne Wartezeit aktiviert.
NICK_SET_SERVADMIN_KILL_IMMED
	Der Nickname Schutz fr %s ist jetzt ohne Wartezeit aktiviert.
NICK_SET_KILL_IMMED_DISABLED
	Die IMMED Option ist auf diesem Netzwerk nicht verfgbar.
NICK_SET_KILL_OFF
	Der Nickname Schutz ist jetzt deaktiviert.
NICK_SET_SERVADMIN_KILL_OFF
	Der Nickname Schutz fr %s ist jetzt aktiviert.

# SET SECURE responses
NICK_SET_SECURE_SYNTAX
	SET SECURE {ON | OFF}
NICK_SET_SECURE_ON
	Die Nickname Sicherheit ist jetzt aktiviert.
NICK_SET_SERVADMIN_SECURE_ON
	Die Nickname Sicherheit von %s ist jetzt aktiviert.
NICK_SET_SECURE_OFF
	Die Nickname Sicherheit ist jetzt deaktiviert.
NICK_SET_SERVADMIN_SECURE_OFF
	Die Nickname Sicherheit von %s ist jetzt deaktiviert.

# SET PRIVATE responses
NICK_SET_PRIVATE_SYNTAX
	SET PRIVATE {ON | OFF}
NICK_SET_PRIVATE_ON
	Der Nickname Privatmodus ist jetzt aktiviert.
NICK_SET_SERVADMIN_PRIVATE_ON
	Der Nickname Privatmodus von %s ist jetzt aktiviert.
NICK_SET_PRIVATE_OFF
	Der Nickname Privatmodus ist jetzt deaktiviert.
NICK_SET_SERVADMIN_PRIVATE_OFF
	Der Nickname Privatmodus von %s ist jetzt deaktiviert.

# SET HIDE responses
NICK_SET_HIDE_SYNTAX
	SET HIDE {EMAIL | USERMASK | QUIT} {ON | OFF}
NICK_SET_HIDE_EMAIL_ON
	Deine eMail-Adresse wird jetzt bei %s INFO Anfragen versteckt.
NICK_SET_SERVADMIN_HIDE_EMAIL_ON
	Die eMail-Adresse von %s wird nun in %s INFO Anfragen versteckt.
NICK_SET_HIDE_EMAIL_OFF
	Deine eMail-Adresse wird jetzt bei %s INFO Anfragen angezeigt.
NICK_SET_SERVADMIN_HIDE_EMAIL_OFF
	Die eMail-Adresse von %s wird nun in %s INFO Anfragen angezeigt.
NICK_SET_HIDE_MASK_ON
	Deine zuletzt gesehene user@host Maske wird jetzt bei %s INFO Anfragen versteckt.
NICK_SET_SERVADMIN_HIDE_MASK_ON
	Die zuletzt gesehene user@host Maske von %s wird nun bei %s INFO Anfragen versteckt.
NICK_SET_HIDE_MASK_OFF
	Deine zuletzt gesehene user@host Maske wird jetzt bei %s INFO Anfragen angezeigt.
NICK_SET_SERVADMIN_HIDE_MASK_OFF
	Die zuletzt gesehene user@host Maske von %s wird nun bei %s INFO Anfragen angezeigt.
NICK_SET_HIDE_QUIT_ON
	Deine letzte QUIT Nachricht wird jetzt bei %s INFO Anfragen versteckt.
NICK_SET_SERVADMIN_HIDE_QUIT_ON
	Die letzte QUIT Nachricht von %s wird jetzt bei %s INFO Anfragen versteckt.
NICK_SET_HIDE_QUIT_OFF
	Deine letzte QUIT Nachricht wird jetzt bei %s INFO Anfragen angezeigt.
NICK_SET_SERVADMIN_HIDE_QUIT_OFF
	Die letzte QUIT Nachricht von %s wird jetzt bei %s INFO Anfragen angezeigt.
# SET HOST responses
NICK_SET_HOST_SYNTAX
	SET HOST {ON | OFF}
NICK_SET_HOST_UNSET
	Diesem Nickname ist kein vHost zugeordnet
NICK_SET_HOST_ON
	Dein vHost ist jetzt aktiviert.
NICK_SET_SERVADMIN_HOST_ON
	Der vHost von %s ist jetzt aktiviert.
NICK_SET_HOST_OFF
	Dein vHost ist jetzt deaktiviert.
NICK_SET_SERVADMIN_HOST_OFF
	Der vHost von %s ist jetzt deaktiviert.

# SET NOEXPIRE responses
NICK_SET_NOEXPIRE_SYNTAX
	SET [Nickname] NOEXPIRE {ON | OFF}
NICK_SET_NOEXPIRE_ON
	Nickname %s wird nicht ablaufen.
NICK_SET_NOEXPIRE_OFF
	Nickname %s wird ablaufen.

# ACCESS responses
NICK_ACCESS_SYNTAX
	ACCESS {ADD | DEL | LIST | CLEAR} {Maske | Listeneintrag}
NICK_ACCESS_ADD_SYNTAX
	ACCESS ADD Maske
NICK_ACCESS_DEL_SYNTAX
	ACCESS %s {Maske | Listeneintrag}
NICK_ACCESS_DISABLED
	Sorry, aber dass Verndern der Accessliste ist im Moment deaktiviert.
NICK_ACCESS_EMPTY
	Die Accessliste ist leer.
NICK_ACCESS_MASK_INVALID
	%s ist keine gltige Access-Maske
NICK_ACCESS_MASK_NO_NICK
	Erinnerung: Access-Masken drfen keine Nicknamen enthalten; Bitte stelle sicher dass der Nickname nicht ein Teil der von dir angegebenen Access-Maske ist.
NICK_ACCESS_MASK_TOO_LONG
	Die Access-Maske kann nicht lnger als %u Zeichen sein.
NICK_ACCESS_ALREADY_PRESENT
	Der Eintrag %s existiert bereits in deiner Accessliste.
NICK_ACCESS_REACHED_LIMIT
	Sorry, aber du kannst nur %d Eintrge in deiner Accessliste fr einen Nicknamen haben.
NICK_ACCESS_CREATION_FAILED
	Sorry, die Erstellung eines neuen Eintrags ist fehlgeschlagen.
NICK_ACCESS_ADDED
	%s wurde zur Accessliste hinzugefgt.
NICK_ACCESS_NO_SUCH_ENTRY
	Der Eintrag #%d kann in der Accessliste nicht gefunden werden.
NICK_ACCESS_NOT_FOUND
	%s wurde in der Accessliste nicht gefunden.
NICK_ACCESS_NO_MATCH
	Keine passenden Eintrge auf der Accessliste.
NICK_ACCESS_DELETED
	%s wurde von der Accessliste gelscht.
NICK_ACCESS_DELETED_ONE
	Es wurde ein Eintrag von der Accessliste gelscht.
NICK_ACCESS_DELETED_SEVERAL
	Es wurden %d Eintrge von der Accessliste gelscht.
NICK_ACCESS_LIST_HEADER
	Aktuelle Accessliste
NICK_ACCESS_LIST_COLHEAD
	Nummer  Maske
# Maske, Grund
NICK_ACCESS_LIST_FORMAT
	  %3d    %s
NICK_ACCESS_LISTED_ONE
	Die Liste hat einen Eintrag.
NICK_ACCESS_LISTED_SEVERAL
	Die Liste hat %d Eintrge.
NICK_ACCESS_CLEAR_PARTIALLY
	Die Accessliste wurde teilweise geleert.
NICK_ACCESS_CLEAR
	Die Accessliste wurde geleert.

# INFO responses
NICK_INFO_SYNTAX
	INFO nick [ALL]
NICK_INFO_REALNAME
	%s ist %s
NICK_INFO_SERVICES_OPER
	%s ist ein Services-Operator.
NICK_INFO_SERVICES_ADMIN
	%s ist ein Services-Admin.
NICK_INFO_ADDRESS
	Letzte gesehene Hostmask: %s
NICK_INFO_ADDRESS_ONLINE
	          ist online von: %s
NICK_INFO_ADDRESS_ONLINE_NOHOST
	%s ist derzeit online.
NICK_INFO_TIME_REGGED
	        Registriert seit: %s
NICK_INFO_GROUP_CREATED
	Die Gruppe wurde erstellt am: %s
NICK_INFO_LAST_SEEN
	     Letztes Mal gesehen: %s
NICK_INFO_LAST_QUIT
	   Letzte Quit-Nachricht: %s
NICK_INFO_URL
	                     URL: %s
NICK_INFO_EMAIL
	           eMail-Adresse: %s
NICK_INFO_EMAIL_AUTH
	           eMail-Adresse: %s (Besttigt)
NICK_INFO_IM
	                    %17s: %s
NICK_INFO_GREET
	          Grussnachricht: %s
NICK_INFO_CUSTOM_HOST
	                   vHost: %s
NICK_INFO_CUSTOM_HOST_WHO
	                   vHost: %s (gesetzt von %s am %s)
NICK_INFO_OPTIONS
	       Nickname Optionen: %s
# These strings MUST NOT be empty
NICK_INFO_OPT_KILL
	Schutz
NICK_INFO_OPT_SECURE
	Sicherheit
NICK_INFO_OPT_PRIVATE
	Privat
NICK_INFO_OPT_CUSTOM_HOST
	vHost
NICK_INFO_OPT_NONE
	Keine
NICK_INFO_PENDING_EXPIRE
	Dieser Nickname wird bald ablaufen.
NICK_INFO_NO_EXPIRE
	Dieser Nickname wird nicht ablaufen.
NICK_INFO_FOR_MORE
	Fr detailiertere Informationen gib /msg %s INFO %s ALL ein.

# LIST responses
NICK_LIST_SYNTAX
	LIST [[Schema] [Bereich]]
NICK_LIST_SERVADMIN_SYNTAX
	LIST [[Schema] [Bereich] [NOLIMIT] [NOEXPIRE]]
NICK_LIST_INVALID_RANGE
	%s ist kein gltiger Ergebnis-Bereich.
NICK_LIST_NO_NICKS_MATCH
	%s entspricht keinem registrierten Nicknamen.
NICK_LIST_HEADER
	Liste registrierter Nicknamen die %s entsprechen:
NICK_LIST_HEADER_NO_PATTERN
	List registrierter Nicknamen:
NICK_LIST_RESULTS
	Ende der Liste - %d/%d wurden angezeigt.
NICK_LIST_RESULTS_RANGE
	Ende der Liste - Ergebnisse %d bis %d wurden angezeigt.
NICK_LIST_RESULTS_RANGE_ONE
	Ende der Liste - Ergebnis %d wurde angezeigt.

# GLIST responses
NICK_GLIST_HEADER
	Liste der Nicknamen in deiner Gruppe %s:
	  Nickname             Ablaufdatum:
NICK_GLIST_HEADER_X
	Liste der Nicknamen in der Gruppe %s:
	  Nickname             Ablaufdatum:
NICK_GLIST_ENTRY
	  %-20s %s
NICK_GLIST_ENTRY_PENDING
	  %-20s ausstehend
NICK_GLIST_ENTRY_NOEXPIRE
	  %-20s nie
NICK_GLIST_FOOTER
	%d Nicknamen in der Gruppe.

# RECOVER responses
NICK_RECOVER_SYNTAX
	RECOVER Nickname [Passwort]
NICK_NO_RECOVER_SELF
	Du kannst diesen Befehl nicht auf dich selbst anwenden!
NICK_RECOVERED
	Der Benutzer mit deinem Nicknamen wurde umbenannt und der Nick wurde blockiert.
	Gib /msg %s RELEASE %s ein, um ihn vor dem einmintigen Timeout wieder freizugeben.

# RELEASE responses
NICK_RELEASE_SYNTAX
	RELEASE Nickname [Passwort]
NICK_RELEASE_NOT_HELD
	Nick %s wird derzeitig nicht blockiert.
NICK_RELEASED
	Die Blockierung deines Nicks durch die Services wurde aufgehoben.

# GHOST responses
NICK_GHOST_SYNTAX
	GHOST Nickname [Passwort]
NICK_NO_GHOST_SELF
	Du kannst diesen Befehl nicht auf dich selbst anwenden!
NICK_GHOST_KILLED
	Der Benutzer mit deinem Nicknamen wurde umbenannt und der Nick wurde blockiert.

# HOST responses
NICK_HOST_SYNTAX
	HOST {SET | LIST} [Nick | Maske] [vHost | Bereich]
NICK_HOST_UNAVAILABLE
	Sorry, der HOST Befehl steht auf diesem Netzwerk nicht zur Verfgung.
NICK_HOST_SET_DISABLED
	Sorry, aber das Setzen von vHosts ist im Moment deaktiviert.
NICK_HOST_TOO_LONG
	Der vHost ist zu lang. (Hchstens %d Zeichen).
NICK_HOST_INVALID
	vHosts drfen nur Zahlen und Buchstaben, sowie den Punkt und
	den Bindestrich enthalten. Auerdem muss jeder vHost mindestens
	einen Punkt enthalten.
NICK_HOST_TOO_YOUNG
	Diese Gruppe ist noch zu neu. Du darfst noch keinen vHost erstellen.
NICK_HOST_TOO_FAST
	Der letzte Wechsel des vHosts ist noch nicht lange genug her. Du darfst ihn noch nicht ndern.
NICK_HOST_UNCHANGED
	Dein vHost ist bereits %s.
NICK_HOST_UNCHANGED_X
	Der vHost von %s war bereits %s.
NICK_HOST_SET_FAILED
	Sorry, aber der vHost konnte nicht gendert werden.
NICK_HOST_CHANGED
	Dein vHost wurde in %s gendert.
NICK_HOST_CHANGED_X
	Der vHost von %s wurde in %s gendert.
NICK_HOST_UNSET
	Dein vHost wurde gelscht.
NICK_HOST_UNSET_X
	Der vHost von %s wurde gelscht.
NICK_HOST_INVALID_RANGE
	%s ist kein gltiger Bereich.
NICK_HOST_LIST_HEADER
	Liste der vHosts:
NICK_HOST_LIST_HEADER_MATCH
	Liste der vHosts die %s entsprechen:
NICK_HOST_LIST_ENTRY
	%-15s  %s (von %s am %s)
NICK_HOST_LIST_RESULTS
	Ende der Liste - %d/%d Eintrge wurden angezeigt.
NICK_HOST_LIST_RESULTS_RANGE
	Ende der Liste - Eintrge %d bis %d wurden angezeigt.
NICK_HOST_LIST_RESULTS_RANGE_ONE
	Ende der Liste - Eintrag %d wurde angezeigt.

# GETPASS responses
NICK_GETPASS_SYNTAX
	GETPASS Nickname
NICK_GETPASS_DISABLED
	Sorry, aber der GETPASS Befehl ist im Moment deaktiviert.
NICK_GETPASS_UNAVAILABLE
	Sorry, aber der GETPASS Befehl steht wegen der verwendeten Verschlsselung nicht zur Verfgung.
NICK_GETPASS_PASSWORD_IS
	Das Passwort fr %s lautet: %s.
	
# SENDPASS responses
NICK_SENDPASS_SYNTAX
	SENDPASS Nickname
NICK_SENDPASS_DISABLED
	Sorry, aber der SENDPASS Befehl ist im Moment deaktiviert.
NICK_SENDPASS_UNAVAILABLE
	Sorry, aber der SENDPASS Befehl steht wegen der verwendeten Verschlsselung nicht zur Verfgung.
NICK_SENDPASS_UNCONFIGURED
	Sorry, aber der SENDPASS Befehl ist nicht verfgbar.
NICK_SENDPASS_SUBJECT
	Passwort fr %s
NICK_SENDPASS_HEAD
	Hallo,
NICK_SENDPASS_LINE_1
	du hast das Passwort fr den Nickname %s per eMail angefordert.
NICK_SENDPASS_LINE_2
	Das Passwort lautet: %s. Aus Sicherheitsgrnden solltest du es ndern, sobald du diese eMail erhalten hast.
NICK_SENDPASS_LINE_2_ENCRYPTION
	Aus Sicherheitsgrnden knnen wir dir dein verwendetes Passwort leider nicht mitteilen. Aber du kannst dir ein neues setzen, indem du /msg %s AUTH PASS %X neues-Passwort eingibst.
NICK_SENDPASS_LINE_3
	Wenn du nicht weisst, weswegen du diese eMail erhalten hast, kannst du sie ignorieren.
NICK_SENDPASS_LINE_4
	BITTE ANTWORTE NICHT AUF DIESE EMAIL!
NICK_SENDPASS_LINE_5
	Deine %s Administratoren.
NICK_SENDPASS_FAILURE
	Das Passwort von Nick %s konnte nicht gesendet werden.
NICK_SENDPASS_FAILURE_TEMPORARY
	Das Passwort von Nick %s konnte nicht gesendet werden. Bitte versuche es spter noch einmal.
NICK_SENDPASS_OK
	Das Passwort wurde %s zugeschickt.

###########################################################################
#
# ChanServ messages
#
###########################################################################

# Access level descriptions
CHAN_LEVEL_AUTOOP
	Automatischer Channel-Operator Status
CHAN_LEVEL_AUTOVOICE
	Automatischer Voice-Modus +v
CHAN_LEVEL_AUTOHALFOP
	Automatischer HalfOp-Modus +h
CHAN_LEVEL_AUTOPROTECT
	Automatischer Autoprotect-Modus +a
CHAN_LEVEL_AUTODEOP
	Channel-Operator Status ist nicht erlaubt
CHAN_LEVEL_NOJOIN
	Der Channel kann nicht betreten werden, da er RESTRICTED ist
CHAN_LEVEL_INVITE
	Der INVITE Befehl ist erlaubt
CHAN_LEVEL_AKICK
	Darf den AKICK Befehl benutzen
CHAN_LEVEL_SET
	Darf den SET Befehl verwenden (auer fr FOUNDER/PASSWORD)
CHAN_LEVEL_CLEAR
	Darf den CLEAR Befehl verwenden
CHAN_LEVEL_UNBAN
	Darf den UNBAN Befehl verwenden
CHAN_LEVEL_OPDEOP
	Darf die OP/DEOP Befehle verwenden
CHAN_LEVEL_ACCESS_LIST
	Darf die Access-Liste einsehen
CHAN_LEVEL_ACCESS_CHANGE
	Darf die Access-Liste ndern
CHAN_LEVEL_MEMO
	Channel Memos drfen angezeigt/gelesen werden
CHAN_LEVEL_ASSIGN
	Ein Bot darf zugewiesen/entfernt werden
CHAN_LEVEL_BADWORDS
	Der BADWORDS Befehl darf benutzt werden
CHAN_LEVEL_NOKICK
	Wird nicht vom Bot gekicked
CHAN_LEVEL_FANTASIA
	Die Fantasia Befehle drfen benutzt werden
CHAN_LEVEL_SAY
	Die SAY und ACT Befehle drfen benutzt werden
CHAN_LEVEL_GREET
	Begrung wird angezeigt
CHAN_LEVEL_VOICEME
	Darf sich selbst (de)voicen
CHAN_LEVEL_VOICE
	Darf die VOICE/DEVOICE Befehle verwenden
CHAN_LEVEL_GETKEY
	Darf den GETKEY Befehl verwenden
CHAN_LEVEL_OPDEOPME
	Darf sich selbst (de)op'en
CHAN_LEVEL_HALFOPME
	Darf sich selbst (de)halfop'en
CHAN_LEVEL_HALFOP
	Darf die HALFOP/DEHALFOP Befehle verwenden
CHAN_LEVEL_PROTECTME
	Darf sich selbst (de)protect'en
CHAN_LEVEL_PROTECT
	Darf die PROTECT/DEPROTECT Befehle verwenden
CHAN_LEVEL_KICKME
	Darf sich selbst kicken
CHAN_LEVEL_KICK
	Darf den KICK Befehl verwenden
CHAN_LEVEL_SIGNKICK
	Kein signierter Kick wenn SIGNKICK LEVEL verwendet wird
CHAN_LEVEL_BANME
	Darf sich selbst bannen
CHAN_LEVEL_BAN
	Darf den BAN Befehl verwenden
CHAN_LEVEL_TOPIC
	Darf den TOPIC Befehl verwenden
CHAN_LEVEL_INFO
	Darf den INFO Befehl mit der ALL Option verwenden

# Automatic responses
CHAN_IS_REGISTERED
	Dieser Channel wurde mit %s registriert.
CHAN_NOT_ALLOWED_OP
	ChanOp Status ist dir im Channel %s nicht erlaubt.
CHAN_NOT_ALLOWED_TO_JOIN
	Es ist dir nicht erlaubt diesen Channel zu betreten.

# REGISTER responses
CHAN_REGISTER_SYNTAX
	REGISTER Channel Passwort Beschreibung
CHAN_REGISTER_DISABLED
	Sorry, dass Registrieren von Channels ist vorbergehend deaktiviert.
CHAN_REGISTER_NOT_LOCAL
	Lokale Channel knnen nicht registriert werden.
CHAN_MUST_REGISTER_NICK
	Du musst zuerst deinen Nicknamen registrieren.  Tippe /msg %s HELP fr Informationen zur Registrierung von Nicknamen
CHAN_MUST_IDENTIFY_NICK
	Bitte zuerst bei %s mit dem Befehl:
	/msg %s IDENTIFY Passwort
	identifizieren.
CHAN_REGISTER_NOT_AUTH
	Du musst deine eMail-Adresse besttigen um einen Channel zu registrieren.
CHAN_REGISTER_NOT_AUTH_HOWTO
	Tippe /msg %s HELP AUTH um mehr Informationen zum Besttigungsprozess zu erhalten.
CHAN_ALREADY_REGISTERED
	Der Channel %s ist bereits registriert!
CHAN_MUST_BE_CHANOP
	Du musst Channel-Operator sein um den Channel zu registrieren.
CHAN_REACHED_CHANNEL_LIMIT
	Sorry, du hast bereits dein Limit von %d Channel erreicht.
CHAN_EXCEEDED_CHANNEL_LIMIT
	Sorry, du hast bereits dein Limit von %d Channel berschritten.
CHAN_REGISTRATION_FAILED
	Sorry, Registrierung fehlgeschlagen.
CHAN_REGISTERED
	Channel %s mit deinem Nicknamen registriert: %s
CHAN_PASSWORD_IS
	Dein Channel Passwort ist %s - fr spteren Gebrauch gut merken.

# IDENTIFY responses
CHAN_IDENTIFY_SYNTAX
	IDENTIFY Channel Passwort
CHAN_IDENTIFY_NOT_AUTH
	Du musst deine E-Mail Adresse besttigen um dich fr den Channel zu identifizieren.
CHAN_IDENTIFY_NOT_AUTH_HOWTO
	Tippe /msg %s HELP AUTH um mehr Informationen zum Besttigungsprozess zu erhalten.
CHAN_IDENTIFY_SUCCEEDED
	Passwort angenommen - du hast nun Grnder-Level Zugriff fr %s.
# LOGOUT responses
CHAN_LOGOUT_SYNTAX
	LOGOUT Channel Nickname
CHAN_LOGOUT_SERVADMIN_SYNTAX
	LOGOUT Channel [Nickname]
CHAN_LOGOUT_SUCCEEDED
	User %s hat sich aus dem Channel %s ausgeloggt.
CHAN_LOGOUT_ALL_SUCCEEDED
	Alle identifizierten User wurden aus dem Channel %s ausgeloggt.

# DROP responses
CHAN_DROP_SYNTAX
	DROP Channel
CHAN_DROP_DISABLED
	Sorry, Channel de-Registrierung ist vorbergehend deaktiviert.
CHAN_DROP_FAILED
	Sorry, de-Registrierung fehlgeschlagen.
CHAN_DROPPED
	Channel %s wurde geelscht.

# SET responses
CHAN_SET_SYNTAX
	SET Channel Option Parameter
CHAN_SET_DISABLED
	Sorry, das setzen von Channel-Optionen ist vorbergehend deaktiviert.
CHAN_SET_UNKNOWN_OPTION
	Unbekannte SET Option %s.

# SET FOUNDER responses
CHAN_SET_FOUNDER_NOT_AUTH
	%s darf nicht Grnder sein da seine/ihre eMail-Adresse noch nicht besttigt ist.
CHAN_SET_FOUNDER_TOO_MANY_CHANS
	%s hat zu viele Channel registriert.
CHAN_FOUNDER_CHANGED
	Grnder von %s wurde in %s gendert.

# SET SUCCESSOR responses
CHAN_SUCCESSOR_IS_FOUNDER
	%s kann nicht Stellvertreter fr Channel %s sein, da er/sie Grnder ist.
CHAN_SET_SUCCESSOR_NOT_AUTH
	%s darf nicht Stellvertreter sein da seine/ihre eMail-Adresse noch nicht besttigt ist.
CHAN_SUCCESSOR_CHANGED
	Stellvertreter fr %s wurde in %s gendert.
CHAN_SUCCESSOR_UNSET
	Stellvertreter wurde fr %s entfernt.

# SET PASSWORD responses
CHAN_SET_PASSWORD_FAILED
	Sorry, konnte Passwort nicht setzen.
CHAN_PASSWORD_CHANGED
	%s Passwort wurde gendert.
CHAN_PASSWORD_CHANGED_TO
	%s Passwort wurde in %s gendert.

# SET DESC responses
CHAN_DESC_CHANGED
	Beschreibung von %s wurde in %s gendert.

# SET URL responses
CHAN_URL_CHANGED
	URL fr %s wurde in %s gendert.
CHAN_URL_UNSET
	URL fr %s wurde entfernt.

# SET EMAIL responses
CHAN_EMAIL_CHANGED
	eMail-Adresse fr %s wurde in %s gendert.
CHAN_EMAIL_UNSET
	eMail-Adresse fr %s wurde entfernt.

# SET ENTRYMSG responses
CHAN_ENTRY_MSG_CHANGED
	Eingangs Nachricht fr %s wurde gendert.
CHAN_ENTRY_MSG_UNSET
	Eingangs Nachricht fr %s wurde entfernt.

# SET BANTYPE responses
CHAN_SET_BANTYPE_INVALID
	%s ist kein gltiger Ban-Typ.
CHAN_SET_BANTYPE_CHANGED
	Ban-Typ fr Channel %s ist jetzt #%d.

# SET MLOCK responses
CHAN_SET_MLOCK_UNKNOWN_CHAR
	Unbekanntes Modus-Zeichen %c ignoriert.
CHAN_SET_MLOCK_IMPOSSIBLE_CHAR
	Modus %c wurde ignoriert, da er nicht gesperrt werden kann.
CHAN_SET_MLOCK_L_REQUIRED
	Um den Modus +L zu sperren muss auch der Modus +l gesperrt werden.
CHAN_SET_MLOCK_K_REQUIRED
	Um den Modus +K zu sperren muss auch der Modus +i gesperrt werden.
CHAN_MLOCK_CHANGED
	Modus-Sperre fr Channel %s wurde in %s gendert.

# SET KEEPTOPIC responses
CHAN_SET_KEEPTOPIC_SYNTAX
	SET Channel KEEPTOPIC {ON | OFF}
CHAN_SET_KEEPTOPIC_ON
	Option zum Speichern des Topics ist jetzt AN.
CHAN_SET_KEEPTOPIC_OFF
	Option zum Speichern des Topics ist jetzt AUS.

# SET TOPICLOCK responses
CHAN_SET_TOPICLOCK_SYNTAX
	SET Channel TOPICLOCK {ON | OFF}
CHAN_SET_TOPICLOCK_ON
	Option zum Sperren des Topics ist jetzt AN.
CHAN_SET_TOPICLOCK_OFF
	Option zum Sperren des Topics ist jetzt AUS.

# SET PEACE responses
CHAN_SET_PEACE_SYNTAX
	SET Channel PEACE {ON | OFF}
CHAN_SET_PEACE_ON
	Peace Option ist jetzt AN.
CHAN_SET_PEACE_OFF
	Peace Option ist jetzt AUS.

# SET PRIVATE responses
CHAN_SET_PRIVATE_SYNTAX
	SET Channel PRIVATE {ON | OFF}
CHAN_SET_PRIVATE_ON
	Privat Option ist jetzt AN.
CHAN_SET_PRIVATE_OFF
	Privat Option ist jetzt AUS.

# SET SECUREOPS responses
CHAN_SET_SECUREOPS_SYNTAX
	SET Channel SECUREOPS {ON | OFF}
CHAN_SET_SECUREOPS_ON
	Secure Ops Option ist jetzt AN.
CHAN_SET_SECUREOPS_OFF
	Secure Ops Option ist jetzt AUS.
	
# SET SECUREFOUNDER responses
CHAN_SET_SECUREFOUNDER_SYNTAX
	SET Channel SECUREFOUNDER {ON | OFF}
CHAN_SET_SECUREFOUNDER_ON
	Secure Founder Option ist jetzt AN.
CHAN_SET_SECUREFOUNDER_OFF
	Secure Founder Option ist jetzt AUS.

# SET RESTRICTED responses
CHAN_SET_RESTRICTED_SYNTAX
	SET Channel RESTRICTED {ON | OFF}
CHAN_SET_RESTRICTED_ON
	Option fr eingeschrnkten Zugriff ist jetzt AN.
CHAN_SET_RESTRICTED_OFF
	Option fr eingeschrnkten Zugriff ist jetzt AUS.

# SET SECURE responses
CHAN_SET_SECURE_SYNTAX
	SET Channel SECURE {ON | OFF}
CHAN_SET_SECURE_ON
	Secure Option ist jetzt AN.
CHAN_SET_SECURE_OFF
	Secure Option ist jetzt AUS.
	
# SET SIGNKICK responses
CHAN_SET_SIGNKICK_SYNTAX
	SET Channel SIGNKICK {ON | LEVEL | OFF}
CHAN_SET_SIGNKICK_ON
	Option fr signierten Kick ist jetzt AN.
CHAN_SET_SIGNKICK_LEVEL
	Option fr signierten Kick ist jetzt AN, hngt aber vom Level
	des Users ab, der den Befehl verwendet.
CHAN_SET_SIGNKICK_OFF
	Option fr signierten Kick ist jetzt AUS.

# SET OPNOTICE responses
CHAN_SET_OPNOTICE_SYNTAX
	SET Channel OPNOTICE {ON | OFF}
CHAN_SET_OPNOTICE_ON
	Op-Benachrichtigung ist jetzt AN.
CHAN_SET_OPNOTICE_OFF
	Op-Benachrichtigung ist jetzt AUS.

# SET NOEXPIRE responses
CHAN_SET_NOEXPIRE_SYNTAX
	SET Channel NOEXPIRE {ON | OFF}
CHAN_SET_NOEXPIRE_ON
	Channel %s wird nicht erlschen.
CHAN_SET_NOEXPIRE_OFF
	Channel %s wird erlschen.

# ACCESS messages
CHAN_ACCESS_SYNTAX
	ACCESS Channel {ADD | DEL | LIST | CLEAR} [Nick [Level] | Liste]
CHAN_ACCESS_ADD_SYNTAX
	ACCESS Channel ADD Nick Level
CHAN_ACCESS_DEL_SYNTAX
	ACCESS Channel %s {Nick | Liste}
CHAN_ACCESS_DISABLED
	Sorry, dass Bearbeiten der Channel Access-Liste ist vorbergehend deaktiviert.
CHAN_ACCESS_EMPTY
	Die Access-Liste fr %s ist leer.
CHAN_ACCESS_NOT_AUTH
	%s darf nicht in der Access-Liste sein, da seine/ihre eMail-Adresse noch nicht besttigt ist.
CHAN_ACCESS_LEVEL_INVALID
	%s ist kein gltiger Access-Level.
CHAN_ACCESS_LEVEL_NONZERO
	Access-Level darf nicht Null sein.
CHAN_ACCESS_LEVEL_RANGE
	Access-Level mssen zwischen einschlielich %d und %d liegen.
CHAN_ACCESS_NICKS_ONLY
	Die Channel Access-Liste kann nur registrierte Nicknamen enthalten.
CHAN_ACCESS_REACHED_LIMIT
	Sorry, du kannst nur %d Access-Listen Eintrge in einem Channel haben.
CHAN_ACCESS_CREATION_FAILED
	Sorry, Anlegen eines neuen 'bad word' Eintrags ist fehlgeschlagen.
CHAN_ACCESS_LEVEL_UNCHANGED
	Access-Level fr %s in %s wurde nicht von %d gendert.
CHAN_ACCESS_LEVEL_CHANGED
	Access-Level fr %s in %s wurde in %d gendert.
CHAN_ACCESS_ADDED
	%s wurde in der Access-Liste fr %s mit dem Level %d hinzugefgt.
CHAN_ACCESS_NO_SUCH_ENTRY
	Kein solcher Eintrag (#%d) in der Access-Liste fr %s.
CHAN_ACCESS_NOT_FOUND
	%s wurde nicht in der Access-Liste fr %s gefunden.
CHAN_ACCESS_NO_MATCH
	Keine passenden Eintrge in der Access-Liste fr %s.
CHAN_ACCESS_DELETED
	%s wurde von der Access-Liste fr %s gelscht.
CHAN_ACCESS_DELETED_ONE
	Ein (1) Eintrag aus der Access-Liste fr %s gelscht.
CHAN_ACCESS_DELETED_SEVERAL
	%d Eintrge aus der Access-Liste fr %s gelscht.
CHAN_ACCESS_LIST_HEADER
	Access-Liste fr %s:
CHAN_ACCESS_LIST_COLHEAD
	  Num   Lev  Nick
CHAN_ACCESS_LIST_FORMAT
	  %3d  %4d  %s
CHAN_ACCESS_LISTED_ONE
	1 Eintrag aufgelistet.
CHAN_ACCESS_LISTED_SEVERAL
	%d Eintrge aufgelistet.
CHAN_ACCESS_CLEAR_PARTIALLY
	Die Access-Liste fr %s wurde teilweise geleert.
CHAN_ACCESS_CLEAR
	Die Access-Liste fr %s wurde geleert.

# AKICK responses
CHAN_AKICK_SYNTAX
	AKICK Channel {ADD | STICK | UNSTICK | DEL | LIST | VIEW | ENFORCE | CLEAR} [Nick-oder-Usermaske [Begrndung] | Liste]
CHAN_AKICK_ADD_SYNTAX
	AKICK Channel ADD Nick-oder-Usermaske [Begrndung]
CHAN_AKICK_DEL_SYNTAX
	AKICK Channel %s {Maske | Liste}
CHAN_AKICK_STICK_SYNTAX
	AKICK Channel %s Maske
CHAN_AKICK_DISABLED
	Sorry, das Bearbeiten der Channel Autokick-Liste ist vorbergehend deaktiviert.
CHAN_AKICK_EMPTY
	Autokick-Liste f %s  ist leer.
CHAN_AKICK_MASK_TOO_LONG
	Die Maske kann nicht lnger als %u Zeichen sein.
CHAN_AKICK_REASON_TOO_LONG
	Die Begrndung kann nicht lnger als %u Zeichen sein.
CHAN_AKICK_ALREADY_PRESENT
	%s ist bereits auf der Autokick-Liste fr %s.
CHAN_AKICK_REACHED_LIMIT
	Sorry, es sind nur %d Eintrge auf einer Channel Autokick-Liste mglich.
CHAN_AKICK_CREATION_FAILED
	Sorry, Erzeugen eines neuen Autokick Eintrages fehlgeschlagen.
CHAN_AKICK_ADDED
	%s wurde zur Autokick-Liste fr %s hinzugefgt.
CHAN_AKICK_NO_SUCH_ENTRY
	Kein solcher Eintrag (#%d) in der Autokick-Liste fr %s.
CHAN_AKICK_NOT_FOUND
	%s wurde nicht auf der Autokick-Liste fr %s gefunden.
CHAN_AKICK_NO_MATCH
	Keine passenden Eintrge in der Autokick-Liste fr %s.
CHAN_AKICK_STUCK
	%s ist im Channel %s jetzt dauerhaft aktiv.
CHAN_AKICK_UNSTUCK
	%s ist im Channel %s jetzt nicht mehr aktiv.
CHAN_AKICK_DELETED
	%s wurde von der Autokick-Liste fr %s gelscht.
CHAN_AKICK_DELETED_ONE
	1 Eintrag von der Autokick-Liste fr %s gelscht.
CHAN_AKICK_DELETED_SEVERAL
	%d Eintrge von der Autokick-Liste fr %s gelscht.
CHAN_AKICK_LIST_HEADER
	Autokick-Liste fr %s:
CHAN_AKICK_LIST_FORMAT
	  %3d %s (%s)
CHAN_AKICK_VIEW_FORMAT
	%3d %s (durch %s am %s; %s)
	    %s
CHAN_AKICK_VIEW_FORMAT_STUCK
	%3d %s (durch %s am %s; permanent)
	    %s
CHAN_AKICK_LISTED_ONE
	1 Eintrag aufgelistet.
CHAN_AKICK_LISTED_SEVERAL
	%d Eintrge aufgelistet.
CHAN_AKICK_ENFORCE_DONE
	AKICK ENFORCE fr %s vollstndig; %d User sind betroffen.
CHAN_AKICK_CLEAR_PARTIALLY
	Autokick-Liste fr %s wurde teilweise geleert.
CHAN_AKICK_CLEAR
	Autokick-Liste fr %s wurde geleert.

# LEVELS responses
CHAN_LEVELS_SYNTAX
	LEVELS Channel {SET | DIS[ABLE] | LIST | RESET} [Typ [Level]]
CHAN_LEVELS_RANGE
	Level muss zwischen einschlielich %d und %d sein.
CHAN_LEVELS_CHANGED
	Level fr %s im Channel %s wurde in %d gendert.
CHAN_LEVELS_UNKNOWN
	Einstellung %s unbekannt.  Tippe /msg %s HELP LEVELS DESC fr eine Liste gltiger Einstellungen.
CHAN_LEVELS_DISABLED
	%s wurde im Channel %s deaktiviert.
CHAN_LEVELS_LIST_HEADER
	Access-Level Einstellungen fr Channel %s:
CHAN_LEVELS_LIST_DISABLED
	    %-*s  (deaktiviert)
CHAN_LEVELS_LIST_FOUNDER
	    %-*s  (nur Grnder)
CHAN_LEVELS_LIST_NORMAL
	    %-*s  %d
CHAN_LEVELS_RESET
	Access-Level fr %s wurden auf Standardeinstellungen zurckgesetzt.

# INFO responses
CHAN_INFO_SYNTAX
	INFO Channel [ALL]
CHAN_INFO_HEADER
	Informationen fr Channel %s:
CHAN_INFO_FOUNDER
	       Grnder: %s (%s)
CHAN_INFO_NO_FOUNDER
	       Grnder: %s
CHAN_INFO_SUCCESSOR
	       Stellvertreter: %s (%s)
CHAN_INFO_NO_SUCCESSOR
	       Stellvertreter: %s
CHAN_INFO_DESCRIPTION
	       Beschreibung: %s
CHAN_INFO_ENTRYMSG
	       Begrungs Nachricht: %s
CHAN_INFO_TIME_REGGED
	       Registriert: %s
CHAN_INFO_LAST_USED
	       Zuletzt verwendet: %s
CHAN_INFO_LAST_TOPIC
	       Letztes Topic: %s
CHAN_INFO_TOPIC_SET_BY
	       Topic gesetzt von: %s
CHAN_INFO_URL
	       URL: %s
CHAN_INFO_EMAIL
	       eMail-Adresse: %s
CHAN_INFO_BANTYPE
	       Ban Typ: %d
CHAN_INFO_OPTIONS
	       Optionen: %s
CHAN_INFO_OPT_KEEPTOPIC
	Topic Speicherung
CHAN_INFO_OPT_OPNOTICE
	OP Benachrichtigung
CHAN_INFO_OPT_PEACE
	Peace
CHAN_INFO_OPT_PRIVATE
	Privat
CHAN_INFO_OPT_RESTRICTED
	Eingeschrnkter Zugriff
CHAN_INFO_OPT_SECURE
	Sicher
CHAN_INFO_OPT_SECUREOPS
	Sichere Ops
CHAN_INFO_OPT_SECUREFOUNDER
	Sicherer Grnder
CHAN_INFO_OPT_SIGNKICK
	Signierte Kicks
CHAN_INFO_OPT_TOPICLOCK
	Topic Sperre
CHAN_INFO_OPT_NONE
	Keine
CHAN_INFO_MODE_LOCK
	      Modus Sperre: %s
CHAN_INFO_PENDING_EXPIRE
	Dieser Channel knnte bald erlschen.
CHAN_INFO_NO_EXPIRE
	Dieser Channel wird nicht erlschen.

# LIST responses
CHAN_LIST_SYNTAX
	LIST [[Muster] [Bereich]]
CHAN_LIST_SERVADMIN_SYNTAX
	LIST [[Muster] [Bereich] [NOLIMIT] [NOEXPIRE]]
CHAN_LIST_INVALID_RANGE
	%s ist kein gltiger Bereich fr Ergebnisse.
CHAN_LIST_NO_NICKS_MATCH
	Es passen keine registrierten Channel zu %s.
CHAN_LIST_HEADER
	Liste der registrierten Channel die zu %s passen:
CHAN_LIST_HEADER_NO_PATTERN
	Liste der registrierten Channel:
CHAN_LIST_RESULTS
	Ende der Liste - %d/%d Ergebnisse angezeigt.
CHAN_LIST_RESULTS_RANGE
	Ende der Liste - Ergebnisse %d bis %d angezeigt.
CHAN_LIST_RESULTS_RANGE_ONE
	Ende der Liste - Ergebnis %d angezeigt.
	
# CLIST responses
CHAN_CLIST_SYNTAX
	CLIST [Privileg]
CHAN_CLIST_SYNTAX_X
	CLIST [Nickname] [Privileg]
CHAN_CLIST_HEADER
	Liste der Channel-Privilegien:
	   Channel               Level      Beschreibung
CHAN_CLIST_HEADER_X
	Liste der Channel-Privilegien fr %s:
	   Channel               Level      Beschreibung
CHAN_CLIST_FORMAT
	  %c%-20s  %-9d  %s
CHAN_CLIST_FORMAT_STR
	  %c%-20s  %-9s  %s
CHAN_CLIST_FORMAT_STR_FOUNDER
	Grnder
CHAN_CLIST_FORMAT_STR_SUCCESSOR
	Stellvertreter
CHAN_CLIST_FOOTER
	%d Channel aufgelistet.

# INVITE responses
CHAN_INVITE_SYNTAX
	INVITE Channel

# UNBAN responses
CHAN_UNBAN_SYNTAX
	UNBAN Channel
CHAN_UNBANNED
	Dein Ban im Channel %s wurde aufgehoben.

# TOPIC responses
CHAN_TOPIC_SYNTAX
	TOPIC Channel [Topic]
CHAN_TOPIC_DISABLED
	Sorry, das Bearbeiten des Topics ist vorbergehend deaktiviert.
CHAN_TOPIC_FAILED
	Sorry, Bearbeiten des Topics fehlgeschlagen.

# CLEAR responses
CHAN_CLEAR_SYNTAX
	CLEAR Channel Was
CHAN_CLEARED_BANS
	Alle Bans im Channel %s wurden entfernt.
CHAN_CLEARED_MODES
	Alle Modi im Channel %s wurden zurckgesetzt.
CHAN_CLEARED_OPS
	Modus +o wurde vom Channel %s entfernt.
CHAN_CLEARED_VOICES
	Modus +v wurde vom Channel %s entfernt.
CHAN_CLEARED_USERS
	Alle User wurden aus dem Channel %s gekickt.

# GETPASS responses
CHAN_GETPASS_SYNTAX
	GETPASS Channel
CHAN_GETPASS_DISABLED
	Sorry, Abfrage des Channel Passworts ist vorbergehend deaktiviert.
CHAN_GETPASS_UNAVAILABLE
	Der GETPASS Befehl steht nicht zur Verfgung, da Verschlsselung verwendet wird.
CHAN_GETPASS_PASSWORD_IS
	Das Passwort fr den Channel %s ist %s.
	
# SENDPASS responses
CHAN_SENDPASS_SYNTAX
	SENDPASS Channel
CHAN_SENDPASS_UNAVAILABLE
	Der SENDPASS Befehl steht nicht zur Verfgung da Verschlsselung verwendet wird.
CHAN_SENDPASS_UNCONFIGURED
	Sorry, der SENDPASS Befehl ist dauerhaft deaktiviert.
CHAN_SENDPASS_SUBJECT
	Channel Passwort (%s)
CHAN_SENDPASS_HEAD
	Hi,
CHAN_SENDPASS_LINE_1
	Du hast das Passwort fr den Channel %s als E-Mail angefordert.
CHAN_SENDPASS_LINE_2
	Das Passwort ist %s. Aus Sicherheitsgrnden sollte das Passwort sofort nach Erhalt dieser eMail gendert werden.
CHAN_SENDPASS_LINE_3
	Wenn du nicht weit, warum dir diese eMail zugeschickt wurde, ignoriere sie bitte stillschweigend.
CHAN_SENDPASS_LINE_4
	BITTE AUF DIESE E-MAIL NICHT ANTWORTEN!
CHAN_SENDPASS_LINE_5
	%s Administratoren.
CHAN_SENDPASS_FAILURE
	Passwort des Channel %s konnte nicht gesendet werden.
CHAN_SENDPASS_FAILURE_TEMPORARY
	Passwort des Channel %s konnte nicht gesendet werden; Bitte spter noch einmal versuchen.
CHAN_SENDPASS_OK
	Passwort fr %s wurde verschickt.

###########################################################################
#
# MemoServ messages
#
###########################################################################

# Automatic messages
MEMO_HAVE_NEW_MEMO
	Du hast 1 neues Memo
MEMO_HAVE_NEW_MEMOS
	Du hast %d neue Memos.
MEMO_TYPE_READ_LAST
	Gib /msg %s READ LAST ein um es zu lesen.
MEMO_TYPE_READ_NUM
	Gib /msg %s READ %d ein um es zu lesen.
MEMO_TYPE_LIST_NEW
	Gib /msg %s LIST NEW ein um sie anzeigen zu lassen.
MEMO_AT_LIMIT
	Achtung: Du hast die maximale Anzahl an Memos erreicht (%d).  Du kannst keine neuen Memos empfangen bis du ein paar alte Memos gelscht hast.
MEMO_OVER_LIMIT
	Achtung: Du bist ber deiner maximalen Anzahl an Memos (%d).  Du kannst keine neuen Memos empfangen bis du ein paar alte Memos gelscht hast.
MEMO_NEW_MEMO_ARRIVED
	Du hast ein neues Memo von %s.
	Gib /msg %s READ %d ein um es zu lesen.

# Multi-use responses
MEMO_HAVE_NO_MEMOS
	Du hast keine Memos.
MEMO_DOES_NOT_EXIST
	Memo %d existiert nicht!
MEMO_LIST_NOT_FOUND
	Keine passenden Memos gefunden.

# SEND responses
MEMO_SEND_SYNTAX
	SEND Nick Memo-Text
MEMO_SEND_DISABLED
	Sorry, der Memo-Versand ist temporr deaktiviert.
MEMO_SEND_NOT_AUTH
	Du musst deine eMail-Adresse besttigen um ein Memo zu versenden.
MEMO_SEND_NOT_AUTH_HOWTO
	Gib /msg %s HELP AUTH ein fr weitere Informationen zum Besttigungsprozess.
MEMO_SEND_TARGET_NOT_AUTH
	%s kann keine Memos empfangen da seine/ihre eMail-Adresse nicht besttigt ist.
MEMO_SEND_PLEASE_WAIT
	Bitte warte %d Sekunden bevor du den SEND Befehl wieder benutzt.
MEMO_SEND_CHANNEL_TARGET_DISABLED
	Sorry, Memos zu einem Channel senden ist deaktiviert.
MEMO_X_GETS_NO_MEMOS
	%s kann keine Memos empfangen.
MEMO_X_HAS_TOO_MANY_MEMOS
	%s hat momentan zu viele Memos und kann keine weiteren empfangen.
MEMO_SEND_FAILED
	Sorry, der Memo-Versand ist fehlgeschlagen.
MEMO_SENT
	Memo an %s versandt.
	
# CANCEL responses
MEMO_CANCEL_SYNTAX
	CANCEL Nick
MEMO_CANCEL_DISABLED
	Sorry, Memos zurckholen ist temporr deaktiviert.
MEMO_CANCEL_NONE
	Kein Memo war zurckholbar.
MEMO_CANCEL_FAILED
	Sorry, Memo-Zurckholen ist fehlgeschlagen.
MEMO_CANCELLED
	Letztes Memo an %s wurde zurckgeholt.

# LIST responses
MEMO_LIST_SYNTAX
	LIST [Liste | NEW]
MEMO_HAVE_NO_NEW_MEMOS
	Du hast keine neuen Memos.
MEMO_LIST_MEMOS
	Memos fr %s.  Zum Lesen gib: /msg %s READ Nummer ein.
MEMO_LIST_NEW_MEMOS
	Neue Memos fr %s.  Zum Lesen gib: /msg %s READ Nummer ein.
MEMO_LIST_HEADER
	 Nummer  Absender            Datum/Zeit
MEMO_LIST_FORMAT
	%c%3d  %-16s  %s

# READ responses
MEMO_READ_SYNTAX
	READ {Liste | LAST | NEW}
MEMO_HEADER
	Memo %d von %s (%s).  Zum Lschen gib: /msg %s DEL %d ein.
MEMO_HEADER_TARGET
	Memo %d von %s an %s (%s).  Zum Lschen gib: /msg %s DEL %d ein.
MEMO_TEXT
	%s

# DEL responses
MEMO_DEL_SYNTAX
	DEL {Nummer | Liste | ALL}
MEMO_DEL_DISABLED
	Sorry, Memo lschen ist temporr deaktiviert.
MEMO_DEL_FAILED
	Sorry, Memo lschen ist fehlgeschlagen.
MEMO_DELETED_NONE
	Keine Memos wurden gelscht.
MEMO_DELETED_ONE
	Memo %d wurde gelscht.
MEMO_DELETED_SEVERAL
	Memos %s wurden gelscht.
MEMO_DELETED_ALL
	Alle deine Memos wurden gelscht.

# SET responses
MEMO_SET_SYNTAX
	SET Option Parameter
MEMO_SET_DISABLED
	Sorry, Memo-Optionen setzen ist temporr deaktiviert.
MEMO_SET_UNKNOWN_OPTION
	Unbekannte SET Option %s.

# SET NOTIFY responses
MEMO_SET_NOTIFY_SYNTAX
	SET NOTIFY {ON | LOGON | NEW | OFF}
MEMO_SET_NOTIFY_ON
	%s wird dich ab jetzt ber Memos benachrichtigen wenn du dich einloggst und wenn sie an dich versandt werden.
MEMO_SET_NOTIFY_LOGON
	%s wird dich ab jetzt ber Memos benachrichtigen wenn du dich einloggst oder von /AWAY zurckkommst.
MEMO_SET_NOTIFY_NEW
	%s wird dich ab jetzt ber Memos benachrichtigen wenn sie an dich versandt werden.
MEMO_SET_NOTIFY_OFF
	%s wird dir keine Benachrichtigungen ber Memos schicken.

# SET LIMIT responses
MEMO_SET_LIMIT_SYNTAX
	SET LIMITLimit
MEMO_SET_LIMIT_SERVADMIN_SYNTAX
	SET LIMIT [User] {Limit | NONE} [HARD]
MEMO_SET_YOUR_LIMIT_FORBIDDEN
	Du hast keine Berechtigung dass Memo-Limit zu ndern.
MEMO_SET_YOUR_LIMIT_TOO_HIGH
	Du kannst dein Memo-Limit nicht hher als %d setzen.
MEMO_SET_LIMIT_OVERFLOW
	Memo-Limit zu hoch; wird auf %d limitiert.
MEMO_SET_YOUR_LIMIT
	Dein Memo-Limit wurde auf %d gesetzt.
MEMO_SET_YOUR_LIMIT_ZERO
	Du kannst ab sofort keine Memos mehr empfangen.
MEMO_UNSET_YOUR_LIMIT
	Dein Memo-Limit wurde deaktiviert.
MEMO_SET_LIMIT
	Memo-Limit fr %s auf %d gesetzt.
MEMO_SET_LIMIT_ZERO
	Memo-Limit fr %s auf 0 gesetzt.
MEMO_UNSET_LIMIT
	Memo-Limit deaktiviert fr %s.

# SET FORWARD responses
MEMO_SET_FORWARD_SYNTAX
	SET FORWARD {ON | OFF}
MEMO_SET_FORWARD_UNAVAILABLE
	Sorry, Memo-Weiterleitung ist deaktiviert.
MEMO_SET_FORWARD_NO_EMAIL
	Du hast keine eMail-Adresse eingestellt.
	Gib /msg %s HELP SET EMAIL ein fr weitere Informationen.
MEMO_SET_FORWARD_NOT_AUTH
	Deine eMail-Adresse muss besttigt werden.
	Gib /msg %s HELP AUTH ein fr weitere Informationen.
MEMO_SET_FORWARD_ON
	Du bekommst ab jetzt eine Kopie deiner neuen Memos per eMail.
MEMO_SET_FORWARD_OFF
	Du bekommst ab sofort keine Kopien deiner neuen Memos mehr per eMail.
MEMO_SET_FORWARD_SUBJECT
	Du hast ein neues Memo mit dem Betreff %s !
MEMO_SET_FORWARD_SUBJECT_TARGET
	Du hast eine neues %s Memo mit dem Betreff %s !

# INFO responses
MEMO_INFO_SYNTAX
	INFO
MEMO_INFO_SERVADMIN_SYNTAX
	INFO [Nick]
MEMO_INFO_NO_MEMOS
	Du hast momentan keine neuen Memos.
MEMO_INFO_MEMO
	Du hast momentan 1 Memo.
MEMO_INFO_MEMO_UNREAD
	Du hast momentan 1 ungelesenes Memo.
MEMO_INFO_MEMOS
	Du hast momentan %d Memos.
MEMO_INFO_MEMOS_ONE_UNREAD
	Du hast momentan %d Memos, davon 1 ungelesen.
MEMO_INFO_MEMOS_SOME_UNREAD
	Du hast momentan %d Memos, davon %d ungelesene.
MEMO_INFO_MEMOS_ALL_UNREAD
	Du hast momentan %d Memos; alle davon sind ungelesen.
MEMO_INFO_LIMIT
	Dein Memo-Limit liegt bei %d.
MEMO_INFO_HARD_LIMIT
	Dein Memo-Limit liegt bei %d und kann nicht gendert werden.
MEMO_INFO_LIMIT_ZERO
	Dein Memo-Limit liegt bei 0; du kannst keine neuen Memos empfangen.
MEMO_INFO_HARD_LIMIT_ZERO
	Dein Memo-Limit liegt bei 0; du kannst keine neuen Memos empfangen.  Du kannst dieses Limit nicht ndern.
MEMO_INFO_NO_LIMIT
	Du hast kein Limit wieviele Memos du aufheben kannst.
MEMO_INFO_NOTIFY_OFF
	Du wirst nicht ber neue Memos benachrichtigt werden.
MEMO_INFO_NOTIFY_ON
	Du wirst ber neue Memos beim Logon und wenn sie eingehen benachrichtigt.
MEMO_INFO_NOTIFY_RECEIVE
	Du wirst benachrichtigt wenn neue Memos eingehen.
MEMO_INFO_NOTIFY_SIGNON
	Du wirst beim Logon ber neue Memos benachrichtigt.
MEMO_INFO_FORWARD_ON
	Du bekommst eine Kopie neuer Memos per eMail.
MEMO_INFO_FORWARD_OFF
	Du bekommst keine Kopie neuer Memos per eMail.
MEMO_INFO_X_NO_MEMOS
	%s hat momentan keine Memos.
MEMO_INFO_X_MEMO
	%s hat momentan 1 Memo.
MEMO_INFO_X_MEMO_UNREAD
	%s hat momentan 1 ungelesenes Memo.
MEMO_INFO_X_MEMOS
	%s hat momentan %d Memos.
MEMO_INFO_X_MEMOS_ONE_UNREAD
	%s hat momentan %d Memos, davon 1 ungelesenes.
MEMO_INFO_X_MEMOS_SOME_UNREAD
	%s hat momentan %d Memos, davon %d ungelesene.
MEMO_INFO_X_MEMOS_ALL_UNREAD
	%s hat momentan %d Memos; alle davon sind ungelesen.
MEMO_INFO_X_LIMIT
	%s's Memo-Limit ist %d.
MEMO_INFO_X_HARD_LIMIT
	%s's Memo-Limit ist %d und kann nicht gendert werden.
MEMO_INFO_X_NO_LIMIT
	%s hat kein Memo-Limit.
MEMO_INFO_X_NOTIFY_OFF
	%s wird nicht ber neue Memos benachrichtigt.
MEMO_INFO_X_NOTIFY_ON
	%s wird ber neue Memos beim Logon und wenn sie eingehen benachrichtigt.
MEMO_INFO_X_NOTIFY_RECEIVE
	%s wird benachrichtigt wenn neue Memos eingehen.
MEMO_INFO_X_NOTIFY_SIGNON
	%s wird beim Logon ber neue Memos benachrichtigt.
MEMO_INFO_X_FORWARD_ON
	%s bekommt eine Kopie von neuen Memos per eMail.
MEMO_INFO_X_FORWARD_OFF
	%s bekommt keine Kopie von neuen Memos per eMail.
	
###########################################################################
#
# BotServ messages
#
###########################################################################
	
# Standard responses
BOT_DOES_NOT_EXIST
	Bot %s existiert nicht.
BOT_NOT_ASSIGNED
	Du musst dem Channel einen Bot zuweisen bevor du diesen Befehl benutzen kannst.
	Gib /msg %S HELP ASSIGN ein fr weitere Informationen.
BOT_NOT_ON_CHANNEL
	Bot ist nicht im Channel %s.
	
# Kick reasons (must be a single line)
BOT_REASON_BADWORD
	Benutze nicht dass Wort %s in diesem Channel!
BOT_REASON_BADWORD_GENTLE
	Pass auf deine Ausdrucksweise auf!
BOT_REASON_BOLD
	Kein fettgedruckt schreiben in diesem Channel!
BOT_REASON_CAPS
	Schalte Caps-lock AB!
BOT_REASON_COLOR
	Kein farbig schreiben in diesem Channel!
BOT_REASON_FLOOD
	Hr auf zu flooden!
BOT_REASON_REPEAT
	Hr auf dich zu wiederholen!
BOT_REASON_REVERSE
	Kein invers schreiben in diesem Channel!
BOT_REASON_UNDERLINE
	Kein unterstrichen schreiben in diesem Channel!
	
# !seen replies
BOT_SEEN_BOT
	Du hast mich gefunden, %s!
BOT_SEEN_YOU
	Auf der Suche nach dir selbst, mh %s?
BOT_SEEN_ON_CHANNEL
	%s ist gerade im Channel!
BOT_SEEN_ON_CHANNEL_AS
	%s ist gerade im Channel (als %s) ! 
BOT_SEEN_ON
	%s wurde zuletzt hier gesehen vor %s .
BOT_SEEN_NEVER
	Ich habe %s noch nicht in diesem Channel gesehen.
BOT_SEEN_UNKNOWN
	Ich weiss nicht wer %s ist.
	
# BOT responses
BOT_BOT_SYNTAX
	BOT {ADD | CHANGE | DEL | LIST} [[alter-Nick] Nick [Username [Hostname [Realname]]]]
BOT_BOT_ALREADY_EXISTS
	Bot %s existiert bereits.
BOT_BOT_CREATION_FAILED
	Sorry, Bot erstellen ist fehlgeschlagen.
BOT_BOT_READONLY
	Sorry, Bot-nderungen sind temporr deaktiviert.
BOT_BOT_ADDED
	%s!%s@%s (%s) zur Bot-Liste hinzugefgt.
BOT_BOT_ANY_CHANGES
	Die alten Informationen sind gleich mit den neuen.
BOT_BOT_CHANGED
	Bot %s wurde gendert zu %s!%s@%s (%s)
BOT_BOT_DELETION_FAILED
	Sorry, Bot lschen ist fehlgeschlagen.
BOT_BOT_DELETED
	Bot %s wurde gelscht.
	
# BOTLIST responses
BOT_BOTLIST_HEADER
	Botliste:
BOT_BOTLIST_PRIVATE_HEADER
	Bots reserviert fr IRC-Ops:
BOT_BOTLIST_FOOTER
	%d Bots verfgbar.
BOT_BOTLIST_EMPTY
	Derzeit sind keine Bots verfgbar.
	Frage einen Services Admin danach einen zu erstellen!
	
# ASSIGN responses
BOT_ASSIGN_SYNTAX
	ASSIGN Channel Nick
BOT_ASSIGN_READONLY
	Sorry, Bot zuweisen ist temporr deaktiviert.
BOT_ASSIGN_ALREADY
	Channel %s hat bereits einen Bot zugewiesen.
BOT_ASSIGN_ASSIGNED
	Bot %s wurde %s zugewiesen.
	
# UNASSIGN responses
BOT_UNASSIGN_SYNTAX
	UNASSIGN Channel
BOT_UNASSIGN_UNASSIGNED
	Es ist kein Bot mehr fr %s zugewiesen.
	
# INFO responses
BOT_INFO_SYNTAX
	INFO {Channel | Nick}
BOT_INFO_NOT_FOUND
	%s ist kein gltiger Bot oder registrierter Channel.
BOT_INFO_BOT_HEADER
	Information ber Bot %s:
BOT_INFO_BOT_MASK
	       Maske : %s@%s
BOT_INFO_BOT_REALNAME
	  Real Name : %s
BOT_INFO_BOT_CREATED
	    Erstellt : %s
BOT_INFO_BOT_USAGE
	    Benutzt in : %d Channel(s)
BOT_INFO_BOT_OPTIONS
	    Optionen : %s
BOT_INFO_OPT_PRIVATE
	Privat
BOT_INFO_CHAN_HEADER
	Information ber Channel %s:
BOT_INFO_CHAN_BOT
	           Bot Nick : %s
BOT_INFO_CHAN_BOT_NONE
	           Bot Nick : noch nicht zugewiesen.
BOT_INFO_CHAN_KICK_BADWORDS
	   Badwords-Kicker : %s
BOT_INFO_CHAN_KICK_BADWORDS_BAN
	   Badwords-Kicker : %s (%d Kick(s) vor Bann)
BOT_INFO_CHAN_KICK_BOLDS
	       Fettschrift-Kicker : %s
BOT_INFO_CHAN_KICK_BOLDS_BAN
	       Fettschrift-Kicker : %s (%d Kick(s) vor Bann)
BOT_INFO_CHAN_KICK_CAPS_ON
	        Grossschreibungs-Kicker : %s (Minimum %d/%d%%)
BOT_INFO_CHAN_KICK_CAPS_BAN
	        Grossschreibungs-Kicker : %s (%d Kick(s) vor Bann; Minimum %d/%d%%)
BOT_INFO_CHAN_KICK_CAPS_OFF
	        Grossschreibungs-Kicker : %s
BOT_INFO_CHAN_KICK_COLORS
	      Farben-Kicker : %s
BOT_INFO_CHAN_KICK_COLORS_BAN
	      Farben-Kicker : %s (%d Kick(s) vor Bann)
BOT_INFO_CHAN_KICK_FLOOD_ON
	       Flood Kicker : %s (%d Zeilen in %ds)
BOT_INFO_CHAN_KICK_FLOOD_BAN
	       Flood Kicker : %s (%d Kick(s) vor Bann; %d Zeilen in %ds)
BOT_INFO_CHAN_KICK_FLOOD_OFF
	       Flood Kicker : %s
BOT_INFO_CHAN_KICK_REPEAT_ON
	      Wiederholungs-Kicker : %s (%d mal)
BOT_INFO_CHAN_KICK_REPEAT_BAN
	      Wiederholungs-Kicker : %s (%d Kick(s) vor Bann; %d mal)
BOT_INFO_CHAN_KICK_REPEAT_OFF
	      Wiederholungs-Kicker : %s
BOT_INFO_CHAN_KICK_REVERSES
	    Invers-Kicker : %s
BOT_INFO_CHAN_KICK_REVERSES_BAN
	    Invers-Kicker : %s (%d Kick(s) vor Bann)
BOT_INFO_CHAN_KICK_UNDERLINES
	  Unterstreichen-Kicker : %s
BOT_INFO_CHAN_KICK_UNDERLINES_BAN
	  Unterstreichen-Kicker : %s (%d Kick(s) vor Bann)
BOT_INFO_ACTIVE
	eingeschalten
BOT_INFO_INACTIVE
	abgeschalten
BOT_INFO_CHAN_OPTIONS
	            Optionen : %s
BOT_INFO_OPT_DONTKICKOPS
	Ops-Schutz
BOT_INFO_OPT_DONTKICKVOICES
	Voices-Schutz
BOT_INFO_OPT_FANTASY
	Fantasy
BOT_INFO_OPT_GREET
	Begrssung
BOT_INFO_OPT_NOBOT
	Kein Bot
BOT_INFO_OPT_SYMBIOSIS
	Symbiosis
BOT_INFO_OPT_NONE
	Keine
	
# SET responses
BOT_SET_SYNTAX
	SET Channel Option Einstellung
BOT_SET_DISABLED
	Sorry, Bot-Optionen Einstellen ist temporr deaktiviert.
BOT_SET_UNKNOWN
	Unbekannte Option %s.
	Gib /msg %S HELP SET ein fr weitere Informationen.

# SET DONTKICKOPS messages
BOT_SET_DONTKICKOPS_SYNTAX
	SET Channel DONTKICKOPS {ON|OFF}
BOT_SET_DONTKICKOPS_ON
	Bot kickt keine Ops im Channel %s.
BOT_SET_DONTKICKOPS_OFF
	Bot kickt Ops im Channel %s.
	
# SET DONTKICKVOICES messages
BOT_SET_DONTKICKVOICES_SYNTAX
	SET Channel DONTKICKVOICES {ON|OFF}
BOT_SET_DONTKICKVOICES_ON
	Bot kickt keine voices im Channel %s.
BOT_SET_DONTKICKVOICES_OFF
	Bot kickt voices im Channel %s.

# SET FANTASY messages
BOT_SET_FANTASY_SYNTAX
	SET Channel FANTASY {ON|OFF}
BOT_SET_FANTASY_ON
	Fantasy-Modus ist jetzt AN im Channel %s.
BOT_SET_FANTASY_OFF
	Fantasy-Modus ist jetzt AUS im Channel %s.
	
# SET GREET messages
BOT_SET_GREET_SYNTAX
	SET Channel GREET {ON|OFF}
BOT_SET_GREET_ON
	Begrssungs-Modus ist jetzt AN im Channel %s.
BOT_SET_GREET_OFF
	Begrssungs-Modus ist jetzt AUS im Channel %s.
	
# SET NOBOT
BOT_SET_NOBOT_SYNTAX
	SET Channel NOBOT {ON|OFF}
BOT_SET_NOBOT_ON
	Kein-Bot Modus ist jetzt AN im Channel %s.
BOT_SET_NOBOT_OFF
	Kein-Bot Modus ist jetzt AUS im Channel %s.

# SET PRIVATE
BOT_SET_PRIVATE_SYNTAX
	SET Channel PRIVATE {ON|OFF}
BOT_SET_PRIVATE_ON
	Privat-Modus von Bot %s ist jetzt AN.
BOT_SET_PRIVATE_OFF
	Privat-Modus von Bot %s ist jetzt AUS.

# SET SYMBIOSIS
BOT_SET_SYMBIOSIS_SYNTAX
	SET Channel SYMBIOSIS {ON|OFF}
BOT_SET_SYMBIOSIS_ON
	Symbiose-Modus ist jetzt AN im Channel %s.
BOT_SET_SYMBIOSIS_OFF
	Symbiose-Modus ist jetzt AUS im Channel %s.
	
# KICK responses
BOT_KICK_SYNTAX
	KICK Channel Option {ON|OFF} [Einstellung]
BOT_KICK_DISABLED
	Sorry, Kicker-Konfiguration ist temporr deaktiviert.
BOT_KICK_UNKNOWN
	Unbekannte Option %s.
	Gib /msg %S HELP KICK ein fr weitere Informationen.
BOT_KICK_BAD_TTB
	%s ist keine gltige Anzahl an Kicks vor einem Bann.

BOT_KICK_BADWORDS_ON
	Bot kickt ab sofort bei Badwords. Benutze den BADWORDS Befehl
	um ein Badword hinzuzufgen oder zu lschen.
BOT_KICK_BADWORDS_ON_BAN
	Bot kickt ab sofort bei Badwords und bannt nach 
	%d Kicks des selben Users. Benutze den BADWORDS Befehl
	um Badwords hinzuzufgen oder zu lschen.
BOT_KICK_BADWORDS_OFF
	Bot kickt bei Badwords nicht mehr.

BOT_KICK_BOLDS_ON
	Bot kickt jetzt bei Fettschreiben.
BOT_KICK_BOLDS_ON_BAN
	Bot kickt ab sofort bei Fettschreiben und bannt nach 
	%d Kicks des selben Users.
BOT_KICK_BOLDS_OFF
	Bot kickt bei Fettschreiben nicht mehr.

BOT_KICK_CAPS_ON
	Bot kickt jetzt bei Grossschreiben (muss mindestens
	%d Zeichen und %d%% der gesamten Nachricht sein).
BOT_KICK_CAPS_ON_BAN
	Bot kickt jetzt bei Grossschreiben (muss mindestens
	%d Zeichen und %d%% der gesamten Nachricht sein) und 
	bannt nach %d Kicks des selben Users.
BOT_KICK_CAPS_ON_INVALID_MIN
	Die minimale Anzahl an Grossschreibung muss zwischen %d und %d liegen.
BOT_KICK_CAPS_ON_INVALID_PERCENT
	Die Prozentzahl an Grossschreibung muss zwischen %d und %d liegen.
BOT_KICK_CAPS_OFF
	Bot kickt bei Grossschreiben nicht mehr.

BOT_KICK_COLORS_ON
	Bot kickt jetzt bei Farben.
BOT_KICK_COLORS_ON_BAN
	Bot kickt jetzt bei Farben und bannt nach %d 
	Kicks des selben Users.
BOT_KICK_COLORS_OFF
	Bot kickt bei Farben nicht mehr.

BOT_KICK_FLOOD_ON
	Bot kickt jetzt bei Flood (%d Zeilen in %d Sekunden).
BOT_KICK_FLOOD_ON_BAN
	Bot kickt jetzt bei Flood (%d Zeilen in %d Sekunden) und 
	bannt nach %d Kicks des selben Users.
BOT_KICK_FLOOD_ON_INVALID_LINES
	Die Anzahl an Zeilen muss zwischen %d und %d liegen.
BOT_KICK_FLOOD_ON_INVALID_SECONDS
	Die Anzahl an Sekunden muss zwischen %d und %d liegen.
BOT_KICK_FLOOD_OFF
	Bot kickt bei Flood nicht mehr.

BOT_KICK_REPEAT_ON
	Bot kickt jetzt bei Wiederholungen (User die %d mal
	dasselbe schreiben).
BOT_KICK_REPEAT_ON_BAN
	Bot kickt jetzt bei Wiederholungen (User die %d mal
	dasselbe schreiben) und bannt nach %d Kicks des 
	selben Users.
BOT_KICK_REPEAT_ON_INVALID_TIMES
	Die Anzahl an Wiederholungen muss zwischen %d und %d liegen.
BOT_KICK_REPEAT_OFF
	Bot kickt bei Wiederholungen nicht mehr.

BOT_KICK_REVERSES_ON
	Bot kickt jetzt bei Inversschreibung.
BOT_KICK_REVERSES_ON_BAN
	Bot kickt jetzt bei Inversschreibung und bannt nach %d 
	Kicks des selben Users.
BOT_KICK_REVERSES_OFF
	Bot kickt bei Inversschreibung nicht mehr.

BOT_KICK_UNDERLINES_ON
	Bot kickt jetzt bei Unterstreichen.
BOT_KICK_UNDERLINES_ON_BAN
	Bot kickt jetzt bei Unterstreichen und bannt nach %d 
	Kicks des selben Users.
BOT_KICK_UNDERLINES_OFF
	Bot kickt bei Unterstreichen nicht mehr.

# BADWORDS responses
BOT_BADWORDS_SYNTAX
	BADWORDS Channel {ADD | DEL | LIST | CLEAR} [Ausdruck | Eintrag-Nummer] [SINGLE | START | END]
BOT_BADWORDS_ADD_SYNTAX
	BADWORDS Channel ADD Ausdruck [SINGLE | START | END]
BOT_BADWORDS_DEL_SYNTAX
	BADWORDS Channel %s {Ausdruck | Eintrag-Nummer}
BOT_BADWORDS_DISABLED
	Sorry, Badwords Listen-nderungen sind temporr deaktiviert.
BOT_BADWORDS_EMPTY
	%s Badwords-Liste ist leer.
BOT_BADWORDS_EXPR_TOO_SHORT
	%s ist zu kurz und wrde zu viele bereinstimmungen ergeben.
BOT_BADWORDS_EXPR_TOO_LONG
	Der Ausdruck darf nicht lnger als %u Zeichen sein.
BOT_BADWORDS_ALREADY_PRESENT
	Der Ausdruck %s ist bereits in der Badwords-Liste von %s .
BOT_BADWORDS_REACHED_LIMIT
	Sorry, du darfst nur %d Eintrge in der Badwords-Liste eines Channels haben.
BOT_BADWORDS_CREATION_FAILED
	Sorry, dass Eintragen eines neuen Badwords ist fehlgeschlagen.
BOT_BADWORDS_ADDED
	%s hinzugefgt zur Badwords-Liste von %s .
BOT_BADWORDS_NO_SUCH_ENTRY
	Der Eintrag (#%d) wurde in der Badwords-Liste von %s nicht gefunden.
BOT_BADWORDS_NOT_FOUND
	%s nicht vorhanden in der Badwords-Liste von %s .
BOT_BADWORDS_NO_MATCH
	Keine passenden Eintrge in der Badwords-Liste von %s gefunden.
BOT_BADWORDS_DELETED
	%s gelscht aus der Badwords-Liste von %s .
BOT_BADWORDS_DELETED_ONE
	1 Eintrag gelscht aus der Badwords-Liste von %s .
BOT_BADWORDS_DELETED_SEVERAL
	%d Eintrge gelscht aus der Badwords-Liste von %s .
BOT_BADWORDS_LIST_HEADER
	Badwords-Liste von %s:
BOT_BADWORDS_LIST_COLHEAD
	  Nummer   Ausdruck                        Typ
# mask, reason
BOT_BADWORDS_LIST_FORMAT
	  %3T   %-30s  %s
BOT_BADWORDS_LISTED_ONE
	1 Eintrag.
BOT_BADWORDS_LISTED_SEVERAL
	%d Eintrge.
BOT_BADWORDS_CLEAR_PARTIALLY
	%s Badwords-Liste wurde teilweise geleert.
BOT_BADWORDS_CLEAR
	%s Badwords-Liste wurde geleert.

# SAY responses
BOT_SAY_SYNTAX
	SAY Channel Text

# ACT responses
BOT_ACT_SYNTAX
	ACT Channel Text

###########################################################################
#
# OperServ messages
#
###########################################################################

# General messages
OPER_BOUNCY_MODES
	Die Services knnen keine Modes ndern. Sind die Server richtig konfiguriert?
OPER_BOUNCY_MODES_U_LINE
	Die Services knnen keine Modes ndern. Sind die u:lines auf allen Servern richtig konfiguriert?

# GLOBAL responses
OPER_GLOBAL_SYNTAX
	GLOBAL Nachricht

# STATS responses
OPER_STATS_UNKNOWN_OPTION
	%s is eine unbekannte STATS Option.
OPER_STATS_CURRENT_USERS
	Aktuelle Benutzer: %d (%d ops)
OPER_STATS_MAX_USERS
	Benutzerrekord: %d (%s)
# This is ugly, but at least it's language-portable...
# Note that you can include seconds in any of these--my personal preference
# is to only give resolution to the nearest minute when uptime is one hour
# or more, but just add a %d to get seconds as well.
OPER_STATS_UPTIME_DHMS
	Laufzeit: %d Tage, %02d:%02d
OPER_STATS_UPTIME_1DHMS
	Laufzeit: %d Tag, %02d:%02d
OPER_STATS_UPTIME_HMS
	Laufzeit: %d Stunden, %d Minuten
OPER_STATS_UPTIME_HM1S
	Laufzeit: %d Stunden, %d Minuten
OPER_STATS_UPTIME_H1MS
	Laufzeit: %d Stunden, %d Minute
OPER_STATS_UPTIME_H1M1S
	Laufzeit: %d Stunden, %d Minute
OPER_STATS_UPTIME_1HMS
	Laufzeit: %d Stunde, %d Minuten
OPER_STATS_UPTIME_1HM1S
	Laufzeit: %d Stunde, %d Minuten
OPER_STATS_UPTIME_1H1MS
	Laufzeit: %d Stunde, %d Minute
OPER_STATS_UPTIME_1H1M1S
	Laufzeit: %d Stunde, %d Minute
OPER_STATS_UPTIME_MS
	Laufzeit: %d Minuten, %d Sekunden
OPER_STATS_UPTIME_M1S
	Laufzeit: %d Minuten, %d Sekunde
OPER_STATS_UPTIME_1MS
	Laufzeit: %d Minute, %d Sekunden
OPER_STATS_UPTIME_1M1S
	Laufzeit: %d Minute, %d Sekunde
OPER_STATS_BYTES_READ
	Bytes gelesen           : %5d kB
OPER_STATS_BYTES_WRITTEN
	Bytes geschrieben       : %5d kB
OPER_STATS_USER_MEM
	Benutzer             : %6d Datenstze, %5d kB
OPER_STATS_CHANNEL_MEM
	Channel              : %6d Datenstze, %5d kB
OPER_STATS_SESSIONS_MEM
	Sessions             : %6d Datenstze, %5d kB
OPER_STATS_BLACKLIST_MEM
	Blacklist            : %6d Datenstze, %5d kB
OPER_STATS_MEM
	%-20s : %6d Datenstze, %5d kB
OPER_STATS_MEM_ONE
	%-20s : %6d Datensatz,  %5d kB

OPER_STATS_AKILL_COUNT
	Anzahl AKILLs: %d
OPER_STATS_AKILL_EXPIRE_DAYS
	Standard AKILL Ablaufzeit: %d Tage
OPER_STATS_AKILL_EXPIRE_DAY
	Standard AKILL Ablaufzeit: 1 TAG
OPER_STATS_AKILL_EXPIRE_HOURS
	Standard AKILL Ablaufzeit: %d Stunden
OPER_STATS_AKILL_EXPIRE_HOUR
	Standard AKILL Ablaufzeit: 1 Stunde
OPER_STATS_AKILL_EXPIRE_MINS
	Standard AKILL Ablaufzeit: %d Minuten
OPER_STATS_AKILL_EXPIRE_MIN
	Standard AKILL Ablaufzeit: 1 Minute
OPER_STATS_AKILL_EXPIRE_NONE
	Standard AKILL Ablaufzeit: Nie
OPER_STATS_SGLINE_COUNT
	Anzahl SGLINEs: %d
OPER_STATS_SGLINE_EXPIRE_DAYS
	Standard SGLINE Ablaufzeit: %d Tage
OPER_STATS_SGLINE_EXPIRE_DAY
	Standard SGLINE Ablaufzeit: 1 Tag
OPER_STATS_SGLINE_EXPIRE_HOURS
	Standard SGLINE Ablaufzeit: %d Stunden
OPER_STATS_SGLINE_EXPIRE_HOUR
	Standard SGLINE Ablaufzeit: 1 Stunde
OPER_STATS_SGLINE_EXPIRE_MINS
	Standard SGLINE Ablaufzeit: %d Minuten
OPER_STATS_SGLINE_EXPIRE_MIN
	Standard SGLINE Ablaufzeit: 1 Minute
OPER_STATS_SGLINE_EXPIRE_NONE
	Standard SGLINE Ablaufzeit: Nie
OPER_STATS_SQLINE_COUNT
	Anzahl SQLINEs: %d
OPER_STATS_SQLINE_EXPIRE_DAYS
	Standard SQLINE Ablaufzeit: %d Tage
OPER_STATS_SQLINE_EXPIRE_DAY
	Standard SQLINE Ablaufzeit: 1 Tag
OPER_STATS_SQLINE_EXPIRE_HOURS
	Standard SQLINE Ablaufzeit: %d Stunden
OPER_STATS_SQLINE_EXPIRE_HOUR
	Standard SQLINE Ablaufzeit: 1 Stunde
OPER_STATS_SQLINE_EXPIRE_MINS
	Standard SQLINE Ablaufzeit: %d Minuten
OPER_STATS_SQLINE_EXPIRE_MIN
	Standard SQLINE Ablaufzeit: 1 Minute
OPER_STATS_SQLINE_EXPIRE_NONE
	Standard SQLINE Ablaufzeit: Nie
OPER_STATS_SZLINE_COUNT
	Anzahl SZLINEs: %d
OPER_STATS_SZLINE_EXPIRE_DAYS
	Standard SZLINE Ablaufzeit: %d Tage
OPER_STATS_SZLINE_EXPIRE_DAY
	Standard SZLINE Ablaufzeit: 1 Tag
OPER_STATS_SZLINE_EXPIRE_HOURS
	Standard SZLINE Ablaufzeit: %d Stunden
OPER_STATS_SZLINE_EXPIRE_HOUR
	Standard SZLINE Ablaufzeit: 1 Stunde
OPER_STATS_SZLINE_EXPIRE_MINS
	Standard SZLINE Ablaufzeit: %d Minuten
OPER_STATS_SZLINE_EXPIRE_MIN
	Standard SZLINE Ablaufzeit: 1 Minute
OPER_STATS_SZLINE_EXPIRE_NONE
	Standard SZLINE Ablaufzeit: Nie
OPER_STATS_RESET
	Statistik zurckgesetzt.
OPER_STATS_RESET_DISABLED
	Sorry, aber das Zurcksetzen der Statistiken ist derzeitig deaktiviert.

# MODE responses
OPER_MODE_SYNTAX
	MODE Channel Modes

# CLEARMODES responses
OPER_CLEARMODES_SYNTAX
	CLEARMODES Channel [ALL]
OPER_CLEARMODES_DONE
	Binre Modes und Channelbans wurden von Channel %s entfernt.
OPER_CLEARMODES_ALL_DONE
	Alle Modes wurden vom Channel %s entfernt.


# KICK responses
OPER_KICK_SYNTAX
	KICK Channel Benutzer Grund

# ADMIN responses
OPER_ADMIN_SYNTAX
	ADMIN {ADD | DEL | LIST | VIEW | CLEAR} [Nick | Eintrag]
OPER_ADMIN_ADD_SYNTAX
	ADMIN ADD Nick
OPER_ADMIN_DEL_SYNTAX
	ADMIN %s {Nick | Eintrag}
OPER_ADMIN_DISABLED
	Sorry, aber dass Verndern der Liste der Servicesadministratoren ist im Moment deaktiviert. 
OPER_ADMIN_EMPTY
	Die Liste der Servicesadministratoren ist leer.
OPER_ADMIN_ALREADY_PRESENT
	%s ist bereits auf der Liste der Servicesadministratoren.
OPER_ADMIN_TOO_MANY
	Die Liste der Servicesadministratoren ist voll!
OPER_ADMIN_ADDED
	%s wurde zur Liste der Servicesadministratoren hinzugefgt.
OPER_ADMIN_NO_SUCH_ENTRY
	Es gibt keinen Eintrag #%d in der Liste der Servicesadministratoren.
OPER_ADMIN_NOT_FOUND
	%s wurde in der Liste der Servicesadministratoren nicht gefunden.
OPER_ADMIN_NO_MATCH
	Es gibt keinen passenden Eintrag in der Liste der Servicesadministratoren.
OPER_ADMIN_DELETED
	%s wurde von der Liste der Servicesadministratoren gelscht.
OPER_ADMIN_DELETED_ONE
	Es wurde 1 Eintrag von der Liste der Servicesadministratoren gelscht.
OPER_ADMIN_DELETED_SEVERAL
	Es wurden %d Eintrge von der Liste der Servicesadministratoren gelscht.
OPER_ADMIN_LIST_HEADER
	Liste der Servicesadministratoren:
OPER_ADMIN_LIST_COLHEAD
	  Eintrag  Nick
OPER_ADMIN_LIST_FORMAT
	  %3d      %s
OPER_ADMIN_LISTED_ONE
	1 Eintrag wurde angezeigt.
OPER_ADMIN_LISTED_SEVERAL
	%d Eintrge wurden angezeigt.
OPER_ADMIN_CLEAR_PARTIALLY
	Die Liste der Servicesadministratoren wurde teilweise geleert.
OPER_ADMIN_CLEAR
	Die Liste der Servicesadministratoren wurde geleert.

# OPER responses
OPER_OPER_SYNTAX
	OPER {ADD | DEL | LIST | VIEW | CLEAR} [Nick | Eintrag]
OPER_OPER_ADD_SYNTAX
	OPER ADD Nick
OPER_OPER_DEL_SYNTAX
	OPER %s {Nick | Eintrag}
OPER_OPER_DISABLED
	Sorry, aber das Verndern der Liste der Servicesoperatoren ist im Moment deaktiviert.
OPER_OPER_EMPTY
	Die Liste der Servicesoperatoren ist leer.
OPER_OPER_ALREADY_PRESENT
	%s befindet sich bereits in der Liste der Servicesoperatoren.
OPER_OPER_TOO_MANY
	Die Liste der Servicesoperatoren ist voll.
OPER_OPER_ADDED
	%s wurde zur Liste der Servicesoperatoren hinzugefgt.
OPER_OPER_NO_SUCH_ENTRY
	Es gibt keinen Eintrag #%d in der Liste der Servicesoperatoren.
OPER_OPER_NOT_FOUND
	%s wurde in der Liste der Servicesoperatoren nicht gefunden.
OPER_OPER_NO_MATCH
	Es gibt keinen passenden Eintrag in der Liste der Servicesoperatoren.
OPER_OPER_DELETED
	%s wurde von der Liste der Servicesoperatoren entfernt.
OPER_OPER_DELETED_ONE
	Es wurde 1 Eintrag von der Liste der Servicesoperatoren entfernt.
OPER_OPER_DELETED_SEVERAL
	Es wurden %d Eintrge von der Liste der Servicesoperatoren entfernt.
OPER_OPER_LIST_HEADER
	Liste der Servicesoperatoren:
OPER_OPER_LIST_COLHEAD
	  Eintrag   Nick
OPER_OPER_LIST_FORMAT
	  %3d       %s
OPER_OPER_LISTED_ONE
	1 Eintrag wurde angezeigt.
OPER_OPER_LISTED_SEVERAL
	%d Eintrge wurden angezeigt.
OPER_OPER_CLEAR_PARTIALLY
	Die Liste der Servicesoperatoren wurde teilweise geleert.
OPER_OPER_CLEAR
	Liste der Servicesoperatoren wurde geleert.

# AKILL responses
OPER_AKILL_SYNTAX
	AKILL {ADD | DEL | LIST | VIEW | CLEAR} [[+Ablaufzeit] {Maske | Nick[:Typ] | Eintrag} [Grund]]
OPER_AKILL_ADD_SYNTAX
	AKILL ADD [+Ablaufzeit] {Maske | Nick[:Typ]} Grund
OPER_AKILL_DEL_SYNTAX
	AKILL %s {Maske | Eintrag}
OPER_AKILL_UNSUPPORTED
	Sorry, aber der AKILL Befehl steht auf diesem Netzwerk nicht zur Verfgung.
OPER_AKILL_DISABLED
	Sorry, aber das Verndern der AKILL-Liste ist im Moment deaktiviert.
OPER_AKILL_EMPTY
	Die AKILL-Liste ist leer.
OPER_AKILL_MASK_INVALID
	%s ist keine gltige AKILL-Maske
OPER_AKILL_MASK_NO_NICK
	Erinnerung: AKILL-Masken knnen keinen Nicknamen enthalten; Bitte stelle sicher dass der Nickname nicht in der Maske vorkommt.
OPER_AKILL_MASK_TOO_LONG
	Die Maske darf eine Lnge von %u Zeichen nicht berschreiten.
OPER_AKILL_REASON_TOO_LONG
	Der Grund darf eine Lnge von %u Zeichen nicht berschreiten.
OPER_AKILL_ALREADY_PRESENT
	Die Maske %s befindet sich bereits auf der AKILL-Liste.
OPER_AKILL_ALREADY_COVERED
	Die Maske %s wird bereits durch den AKILL %s abgedeckt.
OPER_AKILL_TOO_MANY
	Die AKILL-iste ist voll!
OPER_AKILL_CREATION_FAILED
	Sorry, dass Erstellen des neuen AKILL-Eintrags ist fehlgeschlagen.
OPER_AKILL_ADDED
	%s wurde zur AKILL-Liste hinzugefgt.
OPER_AKILL_CHANGED
	Die Ablaufzeit vom AKILL %s wurde gendert.
OPER_AKILL_NO_SUCH_ENTRY
	Der Eintrag #%d existiert nicht in der Liste der AKILLs.
OPER_AKILL_NOT_FOUND
	%s wurde in der AKILL-Liste nicht gefunden.
OPER_AKILL_NO_MATCH
	Es wurde kein passender Eintrag in der AKILL-Liste gefunden.
OPER_AKILL_DELETED
	%s wurde von der AKILL-Liste entfernt.
OPER_AKILL_DELETED_ONE
	Es wurde 1 Eintrag von der AKILL-Liste entfernt.
OPER_AKILL_DELETED_SEVERAL
	Es wurden %d Eintrge von der AKILL-Liste entfernt.
OPER_AKILL_LIST_HEADER
	AKILL-Liste:
OPER_AKILL_LIST_COLHEAD
	  Eintrag   Maske                              Grund
# mask, reason
OPER_AKILL_LIST_FORMAT
	  %3d       %-32s                              %s
OPER_AKILL_LISTED_ONE
	1 Eintrag wurde angezeigt.
OPER_AKILL_LISTED_SEVERAL
	%d Eintrge wurden angezeigt.
# number, mask, set-by, set-time, expires, reason
OPER_AKILL_VIEW_FORMAT
	%3d  %s (von %s am %s; %s)
	      %s
OPER_AKILL_CLEAR_PARTIALLY
	Die AKILL-Liste wurde teilweise geleert.
OPER_AKILL_CLEAR
	Die AKILL-Liste wurde geleert.

# SGLINE responses
OPER_SGLINE_SYNTAX
	SGLINE {ADD | DEL | LIST | VIEW | CLEAR} [[+Ablaufzeit] {Maske | Eintrag}[:Grund]]
OPER_SGLINE_ADD_SYNTAX
	SGLINE ADD [+Ablaufzeit] Maske:Grund
OPER_SGLINE_DEL_SYNTAX
	SGLINE %s {Maske | Eintrag}
OPER_SGLINE_UNSUPPORTED
	Sorry, aber der SGLINE Befehl steht auf diesem Netzwerk nicht zur Verfgung.
OPER_SGLINE_DISABLED
	Sorry, aber das Verndern der SGLINE-Liste ist im Moment deaktiviert.
OPER_SGLINE_EMPTY
	Die SGLINE-Liste ist leer.
OPER_SGLINE_MASK_INVALID
	%s ist keine gltige SGLINE-Maske.
OPER_SGLINE_MASK_TOO_LONG
	Die Lnge der Maske darf %u Zeichen nicht berschreiten.
OPER_SGLINE_REASON_TOO_LONG
	Die Lnge des Grundes darf %u Zeichen nicht berschreiten.
OPER_SGLINE_ALREADY_PRESENT
	Die Maske %s befindet sich bereits auf der SGLINE-Liste.
OPER_SGLINE_ALREADY_COVERED
	Die Maske %s is wird bereits durch die SGLINE %s abgedeckt.
OPER_SGLINE_TOO_MANY
	Die SGLINE-Liste ist voll!
OPER_SGLINE_CREATION_FAILED
	Sorry, das Anlegen der SGLINE ist fehlgeschlagen.
OPER_SGLINE_ADDED
	%s wurde zur SGLINE-Liste hinzugefgt.
OPER_SGLINE_CHANGED
	Die Ablaufzeit der SGLINE %s wurde gendert.
OPER_SGLINE_NO_SUCH_ENTRY
	Es gibt keinen Eintrag #%d auf der SGLINE-Liste.
OPER_SGLINE_NOT_FOUND
	%s wurde auf der SGLINE-Liste nicht gefunden.
OPER_SGLINE_NO_MATCH
	Es gibt keinen passenden Eintrag auf der SGLINE-Liste.
OPER_SGLINE_DELETED
	%s wurde von der SGLINE-Liste entfernt.
OPER_SGLINE_DELETED_ONE
	1 Eintrag wurde von der SGLINE-Liste entfernt.
OPER_SGLINE_DELETED_SEVERAL
	%d Eintrge wurden von der SGLINE-Liste entfernt.
OPER_SGLINE_LIST_HEADER
	SGLINE-Liste:
OPER_SGLINE_LIST_COLHEAD
	  Eintrag   Maske                              Grund
# mask, reason
OPER_SGLINE_LIST_FORMAT
	  %3d       %-32s    %s
OPER_SGLINE_LISTED_ONE
	1 Eintrag wurde angezeigt.
OPER_SGLINE_LISTED_SEVERAL
	%d Eintrge wurden angezeigt.
# number, mask, set-by, set-time, expires, reason
OPER_SGLINE_VIEW_FORMAT
	%3d  %s (von %s am %s; %s)
	      %s
OPER_SGLINE_CLEAR_PARTIALLY
	Die SGLINE-Liste wurde teilweise geleert.
OPER_SGLINE_CLEAR
	Die SGLINE-Liste wurde geleert.
# SQLINE responses
OPER_SQLINE_SYNTAX
	SQLINE {ADD | DEL | LIST | VIEW | CLEAR} [[+Ablaufzeit] {Maske | Eintrag} [Grund]]
OPER_SQLINE_ADD_SYNTAX
	SQLINE ADD [+Ablaufzeit] {Maske | Nick[:Typ]} Grund
OPER_SQLINE_DEL_SYNTAX
	SQLINE %s {Maske | Eintrag}
OPER_SQLINE_DISABLED
	Sorry, aber das Verndern der SQLINE-Liste ist im Moment deaktiviert.
OPER_SQLINE_EMPTY
	Die SQLINE-Liste ist leer.
OPER_SQLINE_MASK_INVALID
	%s ist keine gltige SQLINE-Maske.
OPER_SQLINE_MASK_TOO_LONG
	Die Lnge der Maske darf %u Zeichen nicht berschreiten.
OPER_SQLINE_REASON_TOO_LONG
	Der Grund darf %u Zeichen nicht berschreiten.
OPER_SQLINE_ALREADY_PRESENT
	Die Maske %s befindet sich bereits auf der SQLINE-Liste.
OPER_SQLINE_ALREADY_COVERED
	Die Maske %s wird bereits durch die SQLINE %s abgedeckt.
OPER_SQLINE_TOO_MANY
	Die SQLINE-Liste ist voll!
OPER_SQLINE_CREATION_FAILED
	Sorry, das Anlegen der neuen SQLINE ist fehlgeschlagen.
OPER_SQLINE_ADDED
	%s wurde der SQLINE-Liste hinzugefgt.
OPER_SQLINE_CHANGED
	Die Ablaufzeit der SQLINE %s wurde gendert.
OPER_SQLINE_NO_SUCH_ENTRY
	Es gibt keinen Eintrag #%d auf der SQLINE-Liste.
OPER_SQLINE_NOT_FOUND
	%s wurde auf der SQLINE-Liste nicht gefunden.
OPER_SQLINE_NO_MATCH
	Es gibt keine passenden Eintrge auf der SQLINE-Liste.
OPER_SQLINE_DELETED
	%s wurde von der SQLINE-Liste entfernt.
OPER_SQLINE_DELETED_ONE
	Es wurde 1 Eintrag von der SQLINE-Liste entfernt.
OPER_SQLINE_DELETED_SEVERAL
	Es wurden %d Eintrge von der SQLINE-Liste entfernt.
OPER_SQLINE_LIST_HEADER
	SQLINE-Liste:
OPER_SQLINE_LIST_COLHEAD
	  Eintrag   Maske                              Reason
# mask, reason
OPER_SQLINE_LIST_FORMAT
	  %3d       %-32s  %s
OPER_SQLINE_LISTED_ONE
	1 Eintrag wurde angezeigt.
OPER_SQLINE_LISTED_SEVERAL
	%d Eintrge wurden angezeigt.
# number, mask, set-by, set-time, expires, reason
OPER_SQLINE_VIEW_FORMAT
	%3d  %s (von %s am %s; %s)
	      %s
OPER_SQLINE_CLEAR_PARTIALLY
	Die SQLINE-Liste wurde teilweise geleert.
OPER_SQLINE_CLEAR
	Die SQLINE-Liste wurde geleert.

# SZLINE responses
OPER_SZLINE_SYNTAX
	SZLINE {ADD | DEL | LIST | VIEW | CLEAR} [[+Ablaufzeit] {Maske | Eintrag} [Grund]]
OPER_SZLINE_ADD_SYNTAX
	SZLINE ADD [+Ablaufzeit] Maske Grund
OPER_SZLINE_DEL_SYNTAX
	SZLINE %s {Maske | Eintrag}
OPER_SZLINE_UNSUPPORTED
	Sorry, aber der SZLINE Befehl steht auf diesem Netzwerk nicht zur Verfgung. 
OPER_SZLINE_DISABLED
	Sorry, aber das Verndern der SZLINE-Liste ist im Moment deaktiviert.
OPER_SZLINE_EMPTY
	Die SZLINE-Liste ist leer.
OPER_SZLINE_MASK_INVALID
	%s ist keine gltige SZLINE-Maske
OPER_SZLINE_MASK_ONLY_IPS
	Erinnerung: SZLINE-Masken drfen keine Nicknamen oder Usernamen beinhalten; Bitte stelle sicher dass diese nicht in deiner Maske vorkommen.
OPER_SZLINE_MASK_TOO_LONG
	Die Lnge der Maske darf %u Zeichen nicht berschreiten.
OPER_SZLINE_REASON_TOO_LONG
	Der Lnges vom Grund darf %u Zeichen nicht berschreiten.
OPER_SZLINE_ALREADY_PRESENT
	Die Maske %s befindet sich bereits auf der SZLINE-Liste.
OPER_SZLINE_ALREADY_COVERED
	Die Maske %s wird bereits durch die SZLINE %s abgedeckt.
OPER_SZLINE_TOO_MANY
	Die SZLINE-Liste ist voll!
OPER_SZLINE_CREATION_FAILED
	Sorry, das Anlegen der neuen SZLINE ist fehlgeschlagen.
OPER_SZLINE_ADDED
	%s wurde zur SZLINE-Liste hinzugefgt.
OPER_SZLINE_CHANGED
	Die Ablaufzeit der SZLINE %s wurde gendert.
OPER_SZLINE_NO_SUCH_ENTRY
	Es gibt keinen Eintrag #%d in der SZLINE-Liste.
OPER_SZLINE_NOT_FOUND
	%s wurde auf der SZLINE-Liste nicht gefunden.
OPER_SZLINE_NO_MATCH
	Es gibt keine passenden Eintrge auf der SZLINE-Liste.
OPER_SZLINE_DELETED
	%s wurde von der SZLINE-Liste entfernt.
OPER_SZLINE_DELETED_ONE
	Es wurde 1 Eintrag von der SZLINE-Liste entfernt.
OPER_SZLINE_DELETED_SEVERAL
	Es wurden %d Eintrge von der SZLINE-Liste entfernt.
OPER_SZLINE_LIST_HEADER
	SZLINE-Liste:
OPER_SZLINE_LIST_COLHEAD
	  Eintrag   Mask                  Reason
# mask, reason
OPER_SZLINE_LIST_FORMAT
	  %3d       %-20s  %s
OPER_SZLINE_LISTED_ONE
	Es wurde 1 Eintrag angezeigt.
OPER_SZLINE_LISTED_SEVERAL
	Es wurden %d Eintrge angezeigt.
# number, mask, set-by, set-time, expires, reason
OPER_SZLINE_VIEW_FORMAT
	%3d  %s (von %s am %s; %s)
	      %s
OPER_SZLINE_CLEAR_PARTIALLY
	Die SZLINE-Liste wurde teilweise geleert.
OPER_SZLINE_CLEAR
	Die SZLINE-Liste wurde geleert.

# SET responses
OPER_SET_SYNTAX
	SET Option Einstellung
OPER_SET_IGNORE_ON
	Die Ignore Funktion ist jetzt aktiviert.
OPER_SET_IGNORE_OFF
	Die Ignore Funktion ist jetzt deaktiviert.
OPER_SET_IGNORE_ERROR
	Gltige Einstellungen fr IGNORE sind ON oder OFF.
OPER_SET_READONLY_ON
	Der Nur-Lesen Modus ist jetzt aktiviert.
OPER_SET_READONLY_OFF
	Der Nur-Lesen Modus ist jetzt deaktiviert.
OPER_SET_READONLY_ERROR
	Gltige Einstellungen fr READONLY sind ON oder OFF.
OPER_SET_DEBUG_ON
	Der DEBUG Modus ist jetzt aktiviert.
OPER_SET_DEBUG_OFF
	Der DEBUG Modus ist jetzt deaktiviert.
OPER_SET_DEBUG_LEVEL
	Die Services sind jetzt im DEBUG Modus (Level: %d).
OPER_SET_DEBUG_ERROR
	Gltige Einstellungen fr DEBUG sind ON, OFF, oder eine positive Zahl.
OPER_SET_NOEXPIRE_ON
	Der NOEXPIRE Modus ist jetzt aktiviert.
OPER_SET_NOEXPIRE_OFF
	Der NOEXPIRE Modus ist jetzt deaktiviert.
OPER_SET_NOEXPIRE_ERROR
	Gltige Einstellungen fr NOEXPIRE sind ON oder OFF.
OPER_SET_UNKNOWN_OPTION
	Unbekannte Option %s.

# NOOP responses
OPER_NOOP_SYNTAX
	NOOP {SET|REVOKE} Server
OPER_NOOP_SET
	Alle O:Lines von %s wurden entfernt.
OPER_NOOP_REVOKE
	Alle O:Lines von %s wurden zurckgesetzt.

# JUPE responses
OPER_JUPE_SYNTAX
	JUPE Servername [Grund]
OPER_JUPE_USE_SZLINE
	Benutze stattdessen den SZLINE Befehl um die IP Adresse des Servers zu bannen.

# RAW responses
OPER_RAW_SYNTAX
	RAW Text

# SYNC responses
OPER_SYNC_IN_PROGRESS
	Die Synchronisation wurde gestartet.
	
# RELOAD responses
OPER_RELOAD
	Die Konfiguration wurde neu geladen.

# LISTIGNORE responses
OPER_IGNORE_LIST
	Services Ignore-Liste:
OPER_IGNORE_LIST_EMPTY
	Die Ignore-Liste ist leer.
	
# CHANLIST responses
OPER_CHANLIST_SYNTAX
	CHANLIST [{[Muster] [Bereich] [NOLIMIT] | Nick} [SECRET]]
OPER_CHANLIST_INVALID_RANGE
	%s ist kein gltiger Ergebnisbereich
OPER_CHANLIST_NO_CHANNELS
	Im Moment gibt es keine Channel.
OPER_CHANLIST_NO_CHANNELS_MATCH
	Es gibt keine Channel die dem Muster %s entsprechen.
OPER_CHANLIST_NO_CHANNELS_USER
	%s ist in keinem Channel.
OPER_CHANLIST_HEADER
	Channel Liste:
	Name                  Benutzer  Modes    Topic
OPER_CHANLIST_HEADER_MATCH
	Channel entsprechend %s:
	Name                  Benutzer  Modes    Topic
OPER_CHANLIST_HEADER_USER
	%s Channel-Liste:
	Name                  Benutzer  Modes    Topic
OPER_CHANLIST_ENTRY
	%-20s   %4d  +%-6s  %s
OPER_CHANLIST_RESULTS
	Ende der Liste - %d/%d Ergebnisse wurden angezeigt.
OPER_CHANLIST_RESULTS_RANGE
	Ende der Liste - Ergebnisse %d bis %d wurden angezeigt.
OPER_CHANLIST_RESULTS_RANGE_ONE
	Ende der Liste - Ergebnis %d wurde angezeigt.
	
# USERLIST responses
OPER_USERLIST_SYNTAX
	USERLIST [{[Muster] [Bereich] [NOLIMIT] | Channel} [INVISIBLE]]
OPER_USERLIST_INVALID_RANGE
	%s ist kein gltiger Ergebnisbereich.
OPER_USERLIST_NO_USERS_MATCH
	Es gibt keine benutzer die %s entsprechen.
OPER_USERLIST_HEADER
	Benutzerliste:
	Nick                  Maske
OPER_USERLIST_HEADER_MATCH
	Benutzer die %s entsprechen:
	Nick                  Maske
OPER_USERLIST_HEADER_CHAN
	%s Benutzerliste:
	Nick                  Maske
OPER_USERLIST_ENTRY
	%-20s  %s@%s
OPER_USERLIST_RESULTS
	Ende der Liste - %d/%d Ergebnisse wurden angezeigt.
OPER_USERLIST_RESULTS_RANGE
	Ende der Liste - Ergebnis %d bis %d wurde angezeigt.
OPER_USERLIST_RESULTS_RANGE_ONE
	Ende der Liste - Ergebnis %d wurde angezeigt.

# BLACKLIST responses
OPER_BLACKLIST_SYNTAX
	BLACKLIST {DEL | LIST} {Hostname | Muster}
OPER_BLACKLIST_DISABLED
	Die Blackliste ist deaktiviert.
OPER_BLACKLIST_NOT_FOUND
	%s wurde auf der Blackliste nicht gefunden.
OPER_BLACKLIST_REMOVED
	%s wurde von der Blackliste entfernt.
OPER_BLACKLIST_HEADER
	Hostnamen in der Blackliste:
OPER_BLACKLIST_LIST
	%s
OPER_BLACKLIST_FOOTER
	Ende der Liste - %d/%d Ergebnisse wurden angezeigt.

# MODULES responses
OPER_MODULES_SYNTAX
	MODULES {LOAD | UNLOAD | LIST | INFO | QUERY} [Name] [Anfrage]
OPER_MODULES_QUERY_SYNTAX
	MODULES QUERY [Name] [Anfrage]
OPER_MODULES_DISABLED
	Der MODULES %s Befehl ist deaktiviert.
OPER_MODULES_NOT_LOADED
	Das Modul %s ist nicht geladen.
OPER_MODULES_LOAD_ALREADY
	Das Modul %s ist bereits geladen!
OPER_MODULES_LOAD_ERROR
	Das Modul %s kann nicht geladen werden.
OPER_MODULES_LOADED
	Das Modul %s wurde geladen.
OPER_MODULES_UNLOAD_ERROR
	Das Modul %s kann nicht entladen werden.
OPER_MODULES_UNLOADED
	Das Modul %s wurde entladen.
OPER_MODULES_HEADER
	Liste der im Moment geladenen Module:
	Name              Ref.  Beschreibung
OPER_MODULES_LIST
	%-16s  %4d  %s
OPER_MODULES_FOOTER
	%d Module sind geladen.
OPER_MODULES_INFO_HEADER
	Informationen ber Modul %s:
OPER_MODULES_INFO_VERSION
	         Version: %d.%d.%d
OPER_MODULES_INFO_DESC
	    Beschreibung: %s
OPER_MODULES_INFO_AUTHOR
	          Author: %s
OPER_MODULES_INFO_URL
	             URL: %s
OPER_MODULES_INFO_MEMORY_USAGE
	Speichernutzung: %d bytes
OPER_MODULES_INFO_MEMORY_USAGE_K
	Speichernutzung: %d kB
OPER_MODULES_QUERY_UNSUPPORTED
	Das Modul %s untersttzt diese Anfrage nicht.
OPER_MODULES_QUERY_UNANSWERED
	Das Modul %s hat die Anfrage ausgefhrt; Es wurde keine Antwort gegeben.
OPER_MODULES_QUERY_ANSWERED
	Das Modul %s hat die Anfrage ausgefhrt und folgende Antwort zurckgegeben:

###########################################################################
#
# Session Limiting and Exception messages
#
###########################################################################

# EXCEPTION responses
OPER_EXCEPTION_SYNTAX
	EXCEPTION {ADD | DEL | LIST | VIEW | CLEAR} [Hostmaske | Eintrag]
OPER_EXCEPTION_ADD_SYNTAX
	EXCEPTION ADD [+Ablaufzeit] Hostmaske Limit Grund
OPER_EXCEPTION_DEL_SYNTAX
	EXCEPTION %s {Hostmaske | Liste}
OPER_EXCEPTION_SESSIONS_DISABLED
	Session-Limitierung ist abegschaltet.
OPER_EXCEPTION_DISABLED
	Sorry, das Verndern der Session-Exceptionliste ist im Moment deaktiviert.
OPER_EXCEPTION_EMPTY
	Die Session-Exceptionliste ist leer.
OPER_EXCEPTION_INVALID_LIMIT
	Ungltiges Sessionlimit. Es muss eine Zahl ohne Nachkommastellen zwischen 0 und %d sein.
OPER_EXCEPTION_INVALID_HOSTMASK
	Ungltige Hostmaske. Du kannst hier nur echte Hostnamen verwenden, nicht aber Nick- oder Realnamen.
OPER_EXCEPTION_HOSTMASK_TOO_LONG
	Die Hostmaske darf eine Lnge von %u Zeichen nicht berschreiten.
OPER_EXCEPTION_REASON_TOO_LONG
	Der Grund darf eine Lnge von %u Zeichen nicht berschreiten.
OPER_EXCEPTION_ALREADY_PRESENT
	Die Maske %s gibt es bereits auf der Session-Exceptionliste.
OPER_EXCEPTION_TOO_MANY
	Die Session-Exceptionliste ist voll!
OPER_EXCEPTION_CREATION_FAILED
	Sorry, dass Anlegen einer neuen Exception ist fehlgeschlagen.
OPER_EXCEPTION_ADDED
	Das Sessionlimit fr %s wurde auf %d gesetzt.
OPER_EXCEPTION_NO_SUCH_ENTRY
	Der Eintrag #%d existiert nicht auf der Session-Exceptionliste.
OPER_EXCEPTION_NOT_FOUND
	%s wurde auf der Session-Exceptionliste nicht gefunden.
OPER_EXCEPTION_NO_MATCH
	Es existiert kein passender Eintrag auf der Session-Exceptionliste.
OPER_EXCEPTION_DELETED
	%s wurde von der Session-Exceptionliste entfernt.
OPER_EXCEPTION_DELETED_ONE
	Es wurde 1 Eintrag von der Session-Exceptionliste entfernt.
OPER_EXCEPTION_DELETED_SEVERAL
	Es wurden %d Eintrge von der Session-Exceptionliste entfernt.
OPER_EXCEPTION_LIST_HEADER
	Session-Exceptionliste:
OPER_EXCEPTION_LIST_COLHEAD
	Eintrag  Limit  Host
# mask, limit
OPER_EXCEPTION_LIST_FORMAT
	%3d      %4d   %s
OPER_EXCEPTION_LISTED_ONE
	Es wurde 1 Eintrag angezeigt.
OPER_EXCEPTION_LISTED_SEVERAL
	Es wurden %d Eintrge angezeigt.
# mask, set-by, set-time, expires, limit, reason
OPER_EXCEPTION_VIEW_FORMAT
	%3d.  %s  (von %s am %s; %s)
	    Limit: %-4d  - %s
OPER_EXCEPTION_CLEAR_PARTIALLY
	Die Session-Exceptionliste wurde teilweise geleert.
OPER_EXCEPTION_CLEAR
	Die Session-Exceptionliste wurde geleert.

# SESSION responses
OPER_SESSION_SYNTAX
	SESSION {LIST Limit | VIEW Host}
OPER_SESSION_LIST_SYNTAX
	SESSION LIST Limit
OPER_SESSION_VIEW_SYNTAX
	SESSION VIEW Host
OPER_SESSION_DISABLED
	Die Sessionlimitierung ist deaktiviert.
OPER_SESSION_INVALID_THRESHOLD
	Ungltiger Grenzwert. Der Wert muss eine Ganzzahl und mindestens 1 sein.
OPER_SESSION_NOT_FOUND
	%s wurde auf der Session-Exceptionliste nicht gefunden.
OPER_SESSION_LIST_HEADER
	Hosts mit mindestens %d Sessions:
OPER_SESSION_LIST_COLHEAD
	Sessions  Host
# limit, host
OPER_SESSION_LIST_FORMAT
	%6d    %s
# host, sessions, limit
OPER_SESSION_VIEW_FORMAT
	Der Host %s nutzt im Moment %d Sessions und hat ein Limit von %d Sessions.

# EXCEPTION help

OPER_HELP_EXCEPTION
	Syntax: EXCEPTION ADD [+Ablaufzeit] Maske Limit Grund
	        EXCEPTION DEL {Maske | Eintrag}
	        EXCEPTION LIST [Maske | Eintrag]
	        EXCEPTION VIEW [Maske | Eintrag]
	        EXCEPTION CLEAR
	
	Erlaubt Services Administratoren die Liste der Hosts, die spezielle
	Sessionlimits haben, zu verndern. Dies kann dazu genutzt werden, z.B.
	fr Server die Anzahl der Sessions ber den Standardwert zu erhhen.
	
	Wenn ein Host sein Sessionlimit erreicht hat, werden alle Benutzer dieses
	Hosts gekilled. Vorher wird den Benutzern aber eine NOTICE von %S geschickt,
	die Hilfestellungen gibt, wie das Problem in Zukunft verhindert werden kann.
	Der Inhalt dieser Notice lsst sich ber die Konfiguration festlegen.
	
	EXCEPTION ADD fgt die angegebene Hostmaske der Session-Exceptionliste hinzu.
	Bitte beachte dass Masken wie nick!user@host oder user@host ungltig sind!
	Es sind nur echte Hostmasken wie z.B. box.host.dom oder *.host.dom erlaubt,
	weil die Session Beschrnkungen die Nicknamen und Usernamen nicht beachtet.
	Limit muss eine Zahl grer oder gleich 0 sein. Dieser Wert legt fest,
	wieviele Sessions der Host gleichzeitig aktiv haben darf. Ein Wert von 0
	bedeutet, dass der Host unendlich viele Sessions aktiv haben darf. 
	Fr weitere Details zum Parameter Ablaufzeit, schaue dir bitte die AKILL
	Hilfe an.
	
	EXCEPTION DEL entfernt die angegebene Hostmaske von der Session-Exceptionliste.
	EXCEPTION LIST und EXCEPTION VIEW zeigen alle Exceptions an. Wenn die
	Hostmaske mit angegeben wurde, wird die Liste auf die Exceptions limitiert, die
	zur Maske passen. 
	Der Unterschied zwischen den beiden Befehlen ist, dass EXCEPTION VIEW mehr
	Details zu einer Exception anzeigt. So zeigt der Befehl an, wer die Exception
	angelegt hat, das Session Limit, den Grund, die Hostmaske und das Ablaufdatum
	sowie die Ablaufzeit.
	EXCEPTION CLEAR entfernt alle Eintrge von der Session-Exceptionliste.
	
	Hinweis:
	Die Session-Exceptionliste wird von oben nach unten durchgearbeitet. Ein Host
	"benutzt" also die Exception, die als erstes zu ihm passt. Eine sehr groe
	Session-Exceptionliste oder sehr allgemeine Hostmasken knnen die Leistung
	verringern. 
	
	Kann nur von Services Administratoren verwendet werden.

OPER_HELP_SESSION
	Syntax: SESSION LIST Schwellenwert
	        SESSION VIEW Host
	
	Erlaubt Services Administratoren die Liste der aktiven Sessions einzusehen.
	
	SESSION LIST zeigt alle Hosts an, die mindestens so viele Sessions offen
	haben, wie mit  Schwellenwert angegeben wurde.
	Der Schwellenwert muss grer als 1 sein. Dies verhindert versehentliches
	Anzeigen einer groen Anzahl von Hosts die nur eine Session nutzen.
	
	SESSION VIEW zeigt detailiertere Daten zu der Anzahl der aktuell verwendeten
	Sessions sowie zum Sessionlimit an. Der Host Wert darf keine Platzhalter
	enthalten.
	
	Weitere Informationen ber Sessionlimits und wie man diese fr einzelne und
	mehrere Hosts setzt, findest du in der EXCEPTION Hilfe.
	
	Kann nur von Services Administratoren verwendet werden.

###########################################################################
#
# News system messages
#
###########################################################################

OPER_NEWS_LOGON
	[Anmeldenachricht - %s] %s
OPER_NEWS_OPER
	[Opernachricht - %s] %s
OPER_NEWS_RANDOM
	[Zufallsnachricht - %s] %s

# NEWS responses
OPER_NEWS_SYNTAX
	NEWS {LOGON | OPER | RANDOM} {ADD | DEL | LIST | CLEAR} [Text | Nummer | Eintrag]
OPER_NEWS_ADD_SYNTAX
	NEWS {LOGON | OPER | RANDOM} ADD Text
OPER_NEWS_DEL_SYNTAX
	NEWS {LOGON | OPER | RANDOM} %s {Hostmask | Liste}
OPER_NEWS_LIST_SYNTAX
	NEWS {LOGON | OPER | RANDOM} %s {Liste}
OPER_NEWS_DISABLED
	Sorry, dass Bearbeiten der Newslisten ist im Moment deaktiviert.
OPER_NEWS_EMPTY
	Die %s Nachrichtenliste ist leer.
OPER_NEWS_TEXT_TOO_LONG
	Der Text darf %u Zeichen nicht berschreiten.
OPER_NEWS_TOO_MANY
	%s Nachrichtenliste ist voll.
OPER_NEWS_ADDED
	Nachricht wurde zur %s Nachrichtenliste hinzugefgt.
OPER_NEWS_NO_SUCH_ENTRY
	Der Eintrag #%d existiert nicht auf der %s Nachrichtenliste.
OPER_NEWS_NO_MATCH
	Es gibt keinen passenden Eintrag auf der %s Nachrichtenliste.
OPER_NEWS_DELETED_ONE
	Es wurde 1 Eintrag von der %s Nachrichtenliste entfernt.
OPER_NEWS_DELETED_SEVERAL
	Es wurden %d Eintrge von der %s Nachrichtenliste entfernt.
OPER_NEWS_LIST_HEADER
	%s Nachrichtenliste:
OPER_NEWS_LIST_COLHEAD
	Num  Text
# num, text
OPER_NEWS_LIST_FORMAT
	%3d  %s
OPER_NEWS_LISTED_ONE
	1 Eintrag wurde angezeigt.
OPER_NEWS_LISTED_SEVERAL
	%d Eintrge wurden angezeigt.
OPER_NEWS_CLEAR_PARTIALLY
	Die %s Nachrichtenliste wurde teilweise geleert.
OPER_NEWS_CLEAR
	Die %s Nachrichtenliste wurde geleert.

OPER_HELP_NEWS
	Syntax: NEWS {LOGON | OPER | RANDOM} ADD Text
	        NEWS {LOGON | OPER | RANDOM} DEL {Nummer | Liste}
	        NEWS {LOGON | OPER | RANDOM} LIST [Liste]
	        NEWS {LOGON | OPER | RANDOM} CLEAR
	
	Verndert die Liste der Anmeldenachrichten (LOGON), die Liste der
	OPER-Nachrichten (OPER) oder die Liste der Zufallsnachrichten (RANDOM) 
	oder zeigt sie an.
	Die Anmeldenachrichten werden angezeigt wenn ein Benutzer eine Verbindung
	zum Netzwerk herstellt (Bis zu 3 Stck).
	Die OPER-Nachrichten werden angezeigt sobald ein ein Benutzer sich mit Hilfe
	des /OPER Befehl als IRC-Operator anmeldet (Bis zu 3 Stck).  
	Bei den Zufallsnachrichten wird eine ausgesucht, und dem Benutzer angezeigt
	wenn er eine Verbindung zum Netzwerk herstellt.
	
	Der LIST Befehl kann von jedem IRC Operator verwendet werden, um sich die
	aktuellen Nachrichten anzusehen. Die Befehle ADD, DEL und CLEAR sind auf
	Services Administratoren beschrnkt.
	

###########################################################################
#
# HelpServ help message
#
###########################################################################

HELP_HELP
	%S ist ein Service der ber die verfgbaren Services informieren
	soll. Zugriff auf die einzelnen Hilfethemen gibt es mit dem
	HELP Befehl der anderen Service-Clients:

	/msg %s HELP
	     fr Informationen zum Registrieren eines Nicknames

	/msg %s HELP
	     fr Informationen zum Registrieren und Verwalten eines
	     Channels

	/msg %s HELP
	     fr Informationen ber den Nachrichtenversand an Offline-User

HELP_HELP_BOT
	
	/msg %s HELP
	     fr Informationen wie man einen Bot in deinem Channel einrichtet

###########################################################################
#
# NickServ help messages
#
###########################################################################

NICK_HELP
	%S erlaubt es dir, einen Nicknamen zu "registrieren"
	und verhindert, dass andere ihn verwenden knnen. Die 
	folgenden Befehle ermglichen es Nicknamen zu registrieren
	und zu Pflegen; um sie zu verwenden, tippe 
	/msg %S Befehl. Um mehr Informationen zu einem 
	Befehl zu erhalten tippe /msg %S HELP Befehl.
	
	    REGISTER   Einen Nicknamen registrieren
	    GROUP      Einer Gruppe beitreten
	    IDENTIFY   Dich selbst mit deinem Passwort 
	               identifizieren
	    ACCESS     Die Liste der zulssigen Adressen ndern
	    SET        Optionen einrichten, inklusive Kill-Schutz
	    DROP       Die Registrierung eines Nicknamen aufheben
	    RECOVER    Einen anderen User der deinen Nick hat 
	               killen
	    RELEASE    Nach RECOVER wieder ber deinen Nick 
	               verfgen
	    SENDPASS   Passwort vergessen? Versuchs hiermit
	
	Andere Befehle: AUTH, GHOST, GLIST, HOST, INFO, LIST,
	                LOGOUT, STATUS
	
	NOTICE: This service is intended to provide a way for
	IRC users to ensure their identity is not compromised.
	It is NOT intended to facilitate "stealing" of
	nicknames or other malicious actions.  Abuse of %S
	will result in, at minimum, loss of the abused
	nickname(s).
	
NICK_HELP_EXPIRES
	
	Nicknamen die nicht mehr verwendet werden, laufen 
	automatisch ab, d.h. sie werden gelscht wenn sie fr
	%d Tage nicht verwendet wurden.

NICK_HELP_REGISTER
	Syntax: REGISTER Passwort [eMail]
	
	Registriert deinen Nicknamen in der %S Datenbank. Sobald
	dein Nick registriert ist kannst du die SET und ACCESS
	Befehle verwenden um die Einstellungen fr deinen Nick so 
	zu konfigurieren wie du mchtest. Merke dir unbedingt das 
	Passwort, das du bei der Registrierung verwendest - du 
	bentigst es, um spter nderungen an deinem Nick 
	vorzunehmen. (Beachte, dass Gro- und Kleinschreibung 
	unterschieden wird! EPONA, Epona und epona sind
	drei unterschiedliche Passwrter!) 
	
	Richtlinien zur Auswahl von Passwrtern:
	
	Passwrter sollen nicht leicht zu erraten sein. Zum 
	Beispiel ist es eine schlechte Idee, deinen Realnamen
	oder dein Geburtsdatum als Passwort zu verwenden. Deinen
	Nicknamen als Passwort zu verwenden ist eine noch 
	schlechtere Idee ;) und wird im brigen auch nicht von
	%S zugelassen.
	Auerdem sind kuze Passwrter anfllig fr Versuch- und
	Irrtumsuchen, daher sollte dein Passwort mindestens 
	5 Zeichen lang sein. Und zum Abschluss, das Leerzeichen
	kann in Passwrtern nicht verwendet werden.
	
	Der Parameter eMail ist optional und setzt sofort
	die eMail-Adresse fr deinen Nick. Dennoch, in einigen
	Netzen kann er notwendig sein.
	Deine Privatsphre wird gewahrt; diese eMail wird nicht 
	an irgendeine dritte Person weitergegeben.
	
	Dieser Befehl legt auerdem eine neue Gruppe fr deinen
	Nicknamen an, die es dir spter erlaubt weitere Nicks mit
	denselben Einstellungen, denselben Memos und denselben
	Channel Privilegien zu registrieren. Fr mehr 
	Informationen zu dieser Eigenschaft, tippe 
	/msg HELP GROUP.
	
NICK_HELP_GROUP
	Syntax: GROUP Ziel Passwort
	
	Dieser Befehl lsst deinen Nicknamen der Gruppe des Ziel
	Nicknamens beitreten. Passwort ist das Passwort des Ziel
	Nicknamens.
	
	Einer Gruppe beizutreten erlaubt dir, deine Konfiguration,
	Memos und Channel Privilegien mit allen Nicknamen in der
	Gruppe zu teilen, sowie vieles mehr!
	 
	Eine Gruppe existiert, solange sie ntzlich ist. Das 
	heit, dass selbst wenn ein Nick aus der Gruppe gelscht 
	wird, du nicht die oben beschriebenen geteilten Dinge
	verlieren wirst, so lange mindestens ein Nick in der 
	Gruppe verbleibt.
	
	Du kannst den Befehl sogar verwenden, wenn du deinen Nick
	noch nicht registriert hast. Wenn dein Nick bereits 
	registriert ist musst du dich identifizieren, bevor du 
	diesen Befehl verwendest. Tippe /msg %S HELP IDENTIFY
	fr mehr Informationen. Letzteres kann unter Umstnden
	in deinem IRC Netz nicht mglich sein.
	
	Es wird empfohlen, diesen Befehl mit einem nicht 
	registrierten Nick zu verwenden, da dieser automatisch
	registriert wird, wenn dieser Befehl verwendet wird. 
	Du kannst den Befehl nur mit einem registrierten Nick
	verwenden (Um deine Gruppe zu ndern) wenn deine Netzwerk
	Administratoren es zulassen.
	
	Du kannst nur in einer Gruppe gleichzeitig sein. Das 
	zusammenfhren von Gruppen ist nicht mglich.
	
	Beachte: alle Nicknamen einer Gruppe haben dasselbe
	             Passwort.

NICK_HELP_IDENTIFY
	Syntax: IDENTIFY Passwort
	
	Besttigt %S, dass du wirklich der Eigentmer dieses Nicks
	bist. Viele Befehle setzen voraus, dass du dich mit diesem
	Befehl identifizierst, bevor du sie verwenden kannst. 
	Das Passwort ist dasselbe, dass du mit dem REGISTER
	Befehl verwendet hast. (Auer du hast das Passwort 
	nachtrglich gendert!)
	
NICK_HELP_LOGOUT
	Syntax: LOGOUT
	
	Kehrt den Effekt des IDENTIFY Befehls um, d.h. du wirst
	nicht mehr als rechtmiger Eigentmer des Nicks erkannt.
	Beachte aber dass du dich nicht erneut identifizieren musst.

NICK_HELP_AUTH
	Syntax: AUTH
	        AUTH Code
	        AUTH PASS Code neues-Passwort
	        AUTH CANCEL
	
	Ohne Parameter wird ein neuer Authentifizierungsprozess
	gestartet, der darin besteht, dass eine eMail an die mit
	deiner Gruppe verbundene E-Mail Adresse gesendet wird, die
	einen Code enthlt um die Gltigkeit deiner eMail-Adresse
	zu verifizieren.
	
	Mit einem Code Parameter wird der aktuelle 
	Authentifizierungsprozess abgeschlossen. Der Code ist 
	derjenige, der dir zu Beginn des Prozesses per E-Mail
	zugeschickt wurde. Sobald deine eMail-Adresse einmal
	vollstndig authentifiziert ist erhltst du Zugriff auf
	alle Befehle und Eigenschaften die die Administratoren
	Gruppen mit authentifizierten eMail-Adressen vorbehalten
	sind.
	
	Der AUTH PASS Befehl schliet den Authentifizierungs
	Prozess genauso ab, erlaubt allerdings zustzlich noch, 
	dass Passwort deines Nicknamen zu ndern.
	Dieser Befehl steht unter Umstnden nicht zur Verfgung.
	
	Der AUTH CANCEL Befehl bricht den laufenden 
	Authentifizierungsprozess ab.
	
	Dieser Befehl kann in einigen Netzwerken deaktiviert sein.

NICK_HELP_DROP
	Syntax: DROP [Nickname]
	
	Lscht deinen Nicknamen aus der %S Datenbank. Ein Nick der
	gelscht wurde, kann von jedem neu registriert werden.
	
	Du kannst einen Nick innerhalb deiner Gruppe lschen,
	indem du ihn als Nickname Parameter angibst.
	
	Um diesen Befehl verwenden zu knnen, musst du zuerst
	mit deinem Passwort identifiziert sein 
	(/msg %S HELP IDENTIFY fr mehr Informationen).

NICK_HELP_ACCESS
	Syntax: ACCESS ADD Maske
	        ACCESS DEL {Maske | Eintrags-Nummmer | Liste}
	        ACCESS LIST [Maske | Liste]
	        ACCESS CLEAR
	
	Bearbeitet oder ndert die Access Liste fr deine Nick-
	Gruppe. Dies ist die Liste von Adressen, die von %S
	automatisch erkannt werden als berechtigt die Nicks zu 
	verwenden. Wenn du einen Nick von einer anderen Adresse
	verwenden mchtest, musst du erst den IDENTIFY Befehl
	an %S schicken, damit du erkannt wirst.
	
	ACCESS ADD fgt die angegebene user@host Maske zur
	Access-Liste hinzu; zum Beispiel:
	
	  ACCESS ADD epona@*.epona.org
	        Erlaubt Zugriff auf den user epona von jedem
	        Rechner in der epona.org Dmne.
	
	Der ACCESS DEL Befehl entfernt die angegebene Maske von
	der ACCESS-Liste, wenn vorhanden. Wenn eine Liste von 
	Eintrags-Nummern angegeben wird, werden diese Eintrge 
	gelscht. (Siehe Beispiel fr LIST unten.)
	
	Der ACCESS LIST Befehl zeigt die Access-Liste.
	Wenn eine Platzhalter-Maske angegeben wird, werden nur die
	Eintrge angezeigt, die mit der Maske bereinstimmen.
	Wenn eine Liste von Eintragsnummern angegeben wird, werden
	nur diese Eintrge angezeigt; zum Beispiel:  

	   ACCESS LIST 2,7-9
	      Listet die Access-Listen Eintrge mit den Nummern
	      2 und 7 bis 9 auf.
	
	ACCESS CLEAR entfernt alle Eintrge von der Access-Liste.

NICK_HELP_SET
	Syntax: SET Option Parameter
	
	Setzt verschiedene Nickname Optionen. Option kann eine
	der folgenden sein:
	
	    GNAME      Setzt den Namen deiner Gruppe
	    PASSWORD   Setzt das Passwort fr deinen Nicknamen
	    LANGUAGE   Setzt die Sprache, die die Services 
	                   verwenden wenn du Mitteilungen bekommst
	    URL        Verbindet eine URL mit deinem Nicknamen
	    EMAIL      Verbindet eine E-Mail mit deinem Nicknamen
	    IM         Verbindet Instant Messenger Kontaktdaten 
	                   mit deinem Nicknamen
	    GREET      Verbindet eine Begrungsnachricht mit
	                   deinem Nicknamen
	    KILL       Schaltet den Schutz an oder aus
	    SECURE     Schaltet die Nickname Sicherheit an 
	                   oder aus
	    PRIVATE    Verhindert, dass dein Nickname mit
	                   /msg %S LIST angezeigt wird
	    HIDE       Versteckt bestimmte Teile der Nickname 
	                   Informationen
	    HOST       Passt deinen IRC Hostnamen an
	
	Um diesen Befehl zu verwenden, musst du dich zuerst mit
	deinem Passwort identifizieren 
	(siehe /msg %S HELP IDENTIFY fr mehr Informationen).
	
	Tippe /msg %S HELP SET Option fr mehr Informationen
	zu einer bestimmten Option.

NICK_HELP_SET_GNAME
	Syntax: SET GNAME neuer-Name
	
	ndert den Namen den %S fr deine Gruppe verwendet.
	neuer-Name MUSS einer der Nicks in deiner Gruppe sein.

NICK_HELP_SET_PASSWORD
	Syntax: SET PASSWORD neues-Passwort
	
	ndert das Passwort, dass dich als Nick Eigentmer
	identifiziert.

NICK_HELP_SET_LANGUAGE
	Syntax: SET LANGUAGE Nummer
	
	ndert die Sprache, die die Services verwenden um dir
	Mitteilungen zu schicken (zum Beispiel, wenn sie auf einen
	Befehl von dir antworten). Nummer muss aus der folgenden
	Liste untersttzter Sprachen ausgewhlt werden:
	

NICK_HELP_SET_URL
	Syntax: SET URL URL
	
	Verbindet die angegebene URL mit deinem Nicknamen. Diese
	URL wird angezeigt, wann immer jemand Informationen ber
	deinen Nick mit dem INFO Befehl abruft.

NICK_HELP_SET_EMAIL
	Syntax: SET EMAIL Adresse
	
	Verbindet die angegebene eMail-Adresse mit deinem 
	Nicknamen. Diese Adresse wird angezeigt, wann immer jemand
	Informationen ber deinen Nick mit dem INFO Befehl 
	abruft.

NICK_HELP_SET_IM
	Syntax: SET IM Programm Name/Nummer

	Verbindet die angegebenen Instant Messager Kontaktdaten
	mit deinem Nicknamen. Programm ist dabei das IM Programm
	und Name/Nummer ist dein IM Name oder Nummer. Dies 
	Adresse wird angezeigt, wann immer jemand Informationen 
	ber deinen Nick mit dem INFO Befehl abruft.

NICK_HELP_SET_GREET
	Syntax: SET GREET Nachricht
	
	Verbindet die angegebene Begrungsnachricht mit deinem
	Nicknamen. Sie wird angezeigt wenn du einen Channel mit
	aktivierter GREET Option betrittst, vorausgesetzt du
	hast dort den bentigten Access Level.
	
NICK_HELP_SET_KILL
	Syntax: SET KILL {ON | QUICK | IMMED | OFF}
	
	Aktiviert oder deaktiviert die automatische Schutz Option 
	fr deinen Nick. Mit aktiviertem Schutz, wird einem
	anderen User, wenn dieser versucht deinen Nick zu 
	erlangen, eine Minute gegeben, einen anderen Nick 
	anzunehmen, danach wird %S eine Nicknderung erzwingen.
	Der Schutz wird aufgehoben fr User die den Nicknamen
	annehmen, deren User Maske mit einem Eintrag in der
	Nickname Access Liste bereinstimmt; tippe
	/msg %S HELP ACCESS um mehr Informationen zu erhalten.
	
	Wenn du QUICK auswhlst, werden dem User nur 20 Sekunden
	gelassen den Nick zu ndern, anstatt der blichen 60. Wenn
	du IMMED auswhlst, wird der Nick des Users umgehend
	ohne vorherige Warnung oder Mglichkeit den Nick zu 
	wechseln gendert; Bitte verwende diese Option nur wenn es
	sich nicht vermeiden lsst und stelle sicher, dass deine
	Nickname Access Liste auf einem aktuellen Stand ist, oder
	du wirst nicht in der Lage sein, deinen Nicknamen 
	weiterhin zu verwenden! Wie auch immer, deine Netzwerk
	Administratoren knnten diese Option deaktiviert haben.

NICK_HELP_SET_SECURE
	Syntax: SET SECURE {ON | OFF}
	
	Aktiviert oder deaktiviert %S's Sicherheitsfunktionen fr
	deinen Nick. Mit aktiver SECURE Option musst du dein 
	Passwort eingeben, bevor du als Eigentmer des Nicks 
	erkannt wirst und darber Zugang zu deinen Privilegien, 
	Memos und Optionen erhltst, unabhngig davon, ob deine 
	Adresse in der Access-Liste steht oder nicht.

NICK_HELP_SET_PRIVATE
	Syntax: SET PRIVATE {ON | OFF}
	
	Aktiviert oder deaktiviert die %S Privat-Funktion fr 
	deinen Nick. Mit aktiver PRIVATE Option wird dein
	Nickname nicht in Nickname Listen auftauchen, die mit
	%Ss LIST Befehl erzeugt wurden. (Dennoch, jeder der
	deinen Nickname kennt kann weiterhin mit dem INFO
	Befehl Informationen darber bekommen.) 

NICK_HELP_SET_HIDE
	Syntax: SET HIDE {EMAIL | USERMASK | QUIT} {ON | OFF}
	
	Ermglicht dir, bestimmte Informationen auszublenden, wenn
	ein anderer Benutzer den %S INFO Befehl mit deinem Nicknamen
	verwendet. 
	
	Du kannst deine eMail-Adresse mit EMAIL, deine user@host
	Maske mit USERMASK und deine letzte Quit-Nachricht mit
	QUIT verndern. Der letzte Parameter gibt an, ob die Info
	angezeigt werden soll (OFF) oder versteckt wird (ON).

NICK_HELP_SET_HOST
	Syntax: SET HOST {ON | OFF}
	
	Erlaubt dir, den angepassten Hostnamen fr deinen Nick
	(sichtbar in /whois) zu aktivieren (ON) oder 
	deaktivieren (OFF).
	
	Beachte: Diese Option steht mglicherweise nicht zur
	         Verfgung.

NICK_HELP_RECOVER
	Syntax: RECOVER Nickname [Passwort]
	
	Erlaubt es dir, deinen Nicknamen wieder zu erlangen, wenn
	jemand ihn angenommen hat; dieser Befehl bewirkt dasselbe,
	das %S automatisch tut, sobald jemand versucht einen 
	Kill-geschtzten Nick zu verwenden.
	
	Wenn du diesen Befehl verwendest wird %S einen geflschten
	User online stellen, mit demselben Nicknamen wie der User
	von dem du deinen Nick wiedererlangen willst. Dies 
	veranlasst die IRC Server, die Verbindung zum anderen User
	zu trennen. Dieser falsche User wird fr eine Minute 
	online bleiben, um sicher zu stellen, dass der andere User
	sich nicht umgehend neu verbindet; nach dieser Minute 
	kannst du deinen Nick wieder in Anspruch nehmen. 
	Alternativ kannst du den RELEASE Befehl 
	(/msg %S HELP RELEASE) verwenden um deinen Nick frher
	wieder freizugeben.
	
	Um den RECOVER Befehl fr einen Nick verwenden zu knnen
	muss deine aktuelle Adresse so wie in /WHOIS angezeigt in 
	der Access Liste stehen, du musst identifiziert und in der
	Nickgruppe sein oder du musst das richtige Passwort fr
	den Nick angeben.

NICK_HELP_RELEASE
	Syntax: RELEASE Nickname [Passwort]
	
	Weist %S an, eine Sperre auf deinem Nicknamen, verursacht
	durch den automatischen Kill-Schutz oder Verwendung des
	RECOVER Befehls, aufzuheben. Standartmig dauern solche
	Sperren eine Minute an; Dieser Befehl lst sie frher 
	wieder auf.
	
	Um den RELEASE Befehl fr einen Nick verwenden zu knnen
	muss deine aktuelle Adresse so wie in /WHOIS angezeigt in 
	der Access-Liste stehen, du musst identifiziert und in der
	Nickgruppe sein oder du musst das richtige Passwort fr
	den Nick angeben.

NICK_HELP_GHOST
	Syntax: GHOST Nickname [Passwort]
	
	Beendet eine "Geister" IRC Verbindung die deinen Nick
	verwendet. Eine "Geisterverbindung" ist eine Verbindung
	(Session), die aktuell nicht tatschlich mit dem Server
	verbunden ist, die der IRC Server aber aus verschiedenen
	Grnden fr noch aktiv online hlt. Dies passiert
	typischer Weise, wenn dein Computer abstrzt oder deine
	Internet- oder Modemverbindung ausfllt whrend du dich
	im IRC befindest.
	
	Um den GHOST Befehl fr einen Nick verwenden zu knnen
	muss deine aktuelle Adresse so wie in /WHOIS angezeigt in 
	der Access Liste stehen, du musst identifiziert und in der
	Nickgruppe sein oder du musst das richtige Passwort fr
	den Nick angeben.

NICK_HELP_INFO
	Syntax: INFO Nickname [ALL]
	
	Zeigt Informationen ber den angegebenen Nicknamen, wie
	zum Beispiel den Eigentmer, die zuletzt gesehene Adresse
	und Zeit und Nick Optionen, an. Wenn du fr den Nick fr
	den du Informationen erhalten willst identifiziert bist 
	und ALL angegeben hast, bekommst du alle Informationen
	angezeigt; unabhngig davon, ob diese versteckt sind oder 
	nicht.

NICK_HELP_LIST
	Syntax: LIST [[Muster] [Bereich]]
	
	Listet alle registrierten Nicknamen auf. Nicks fr die
	die PRIVATE Option gesetzt ist werden nicht angezeigt.
	
	Wenn ein Muster angegeben wird, werden nur die User
	angezeigt, deren User Maske (im Format nick!user@host) 
	bereinstimmt. Die Anzahl der Ergebnisse die auf einmal
	angezeigt werden ist begrenzt; du kannst einen Bereich
	definieren um Ergebnisse ber diese Grenze hinaus 
	anzuzeigen. Zum Beispiel:
	
	   LIST 51-100
	       Zeigt die Ergebnisse 51 bis 100.
	   LIST *Bot*!* 15-20
	       Zeigt die Ergebnisse 15 bis 20, deren Nick "Bot"
	       enthlt.
	   LIST *!joeuser@foo.com
	        Listet alle registrierten Nicks auf, die zu
	        joeuser@foo.com gehren.
	
	(Beachte: Anders als bei nummerierten Listen ist es nicht 
	mglich eine erweiterte Syntax wie 51-60,75-80 zu 
	verwenden).
	
	In manchen Netzwerken ist dieser Befehl IRC Operatoren
	vorbehalten.

NICK_HELP_GLIST
	Syntax: GLIST
	
	Listet alle Nicks in deiner Gruppe mit ihrem Ablaufdatum
	auf.

NICK_HELP_STATUS
	Syntax: STATUS Nickname...
	
	Gibt aus ob der User der den angegebenen Nicknamen 
	verwendet als Eigentmer des Nicknamens erkannt wurde.
	Die Ausgabe hat das folgende Format: 
	
	    Nickname Status-Code
	
	Wobei Nickname der mit dem Befehl angegebene Nickname
	ist und Status-Code einer der folgenden:
	
	    0 - Kein solcher User online oder Nickname nicht
	        registriert
	    1 - User wurde nicht als Eigentmer des Nicknamen
	        erkannt
	    2 - User nur ber Access Liste als Eigentmer des
	        Nicknamen erkannt
	    3 - User ber Identifikation mit Passwort als 
	        Eigentmer des Nicknamen erkannt
	
	Bis zu 16 Nicknamen knnen mit jedem Befehl bergeben 
	werden; der Rest wird ignoriert. Wenn kein Nickname 
	angegeben wird, wird keine Fehlermeldung ausgegeben.
	
NICK_HELP_SENDPASS
	Syntax: SENDPASS Nickname
	
	Sendet das Passwort des angegebenen Nicknamen an die 
	eMail-Adresse die im Nickname Eintrag angegeben ist.
	Dieser Befehl ist sehr ntzlich um verlorene Passwrter
	wiederzuerlangen.
	
	Kann in einigen Netzwerken auf IRC Operatoren beschrnkt
	sein.
	
	Dieser Befehl steht nicht zur Verfgung, wenn 
	Verschlsselung verwendet wird und es nicht mglich ist
	ein Passwort mit OpenSSL zu erzeugen.

NICK_HELP_HOST
	Syntax: HOST SET [vHost]
	
	HOST SET setzt den vHost fr deinen Nickname. 
	Wird kein Parameter angegeben, wird der vHost gelscht.
	
	Hinweis: Auf einigen Netzwerken kann dieser Befehl deaktiviert,
	oder nur fr Services Operatoren verfgbar sein.

NICK_SERVADMIN_HELP

	Die folgenden Befehle stehen nur Service Admins zur
	Verfgung:
	
	    GETPASS    Ein Passwort fr einen Nicknamen 
	                   herausfinden (nur wenn keine
	                   Verschlsselung verwendet wird)
	
	Service Admins knnen auerdem jeden Nicknamen lschen
	ohne sich fr den Nick identifizieren zu mssen.

NICK_SERVADMIN_HELP_LOGOUT
	Syntax: LOGOUT [Nickname [REVALIDATE]]
	
	Ohne einen Parameter wird der Effekt des IDENTIFY
	Befehls umgekehrt, d.h. du wirst nicht mehr als der 
	tatschliche Eigentmer des Nicks erkannt. Beachte jedoch
	dass du nicht aufgefordert wirst dich erneut zu 
	identifizieren.
	
	Mit einem Nicknamen als Parameter wird dasselbe fr den
	angegeben Nick erzielt. Wenn du auerdem REVALIDATE 
	angibst, werden die Services den angegebenen Nick dazu
	auffordern, sich erneut zu identifizieren. Diese 
	Verwendung ist auf Service Admins beschrnkt.

NICK_SERVADMIN_HELP_DROP
	Syntax: DROP [Nickname]
	
	Ohne angegebenen Parameter wird dein Nickname aus der
	%S Datenbank gelscht.
	
	Mit angegebenem Nicknamen als Parameter wird der
	angegebene Nick aus der Datenbank gelscht. Du kannst
	jeden Nick innerhalb deiner Nick-Gruppe ohne spezielle
	Privilegien lschen. Jeden beliebigen Nick lschen zu
	knnen ohne dafr identifiziert zu sein ist auf Service
	Admins beschrnkt.

NICK_SERVADMIN_HELP_SET
	
	Service Admins knnen zustzlich die Option NOEXPIRE
	setzen mit der verhindert werden kann dass Nicknamen
	ablaufen. Zustzlich knnen Service Admins Optionen fr
	jeden beliebigen Nick setzen ohne ein Passwort eingeben 
	zu mssen. Hierzu muss das Format 
	SET =Nickname Option Parameter verwendet werden.

NICK_SERVADMIN_HELP_SET_NOEXPIRE
	Syntax: SET [=Nickname] NOEXPIRE {ON | OFF}
	
	Bestimmt ob der angegebene Nickname ablaufen wird oder
	nicht. Wird die Option mit ON aktiviert wird der Nick
	nicht ablaufen. Wenn kein Nickname angegeben wird, wird 
	die NOEXPIRE Markierung fr deinen Nick gesetzt.
	
	Beschrnkt auf Service Administratoren.

NICK_SERVADMIN_HELP_INFO
	
	Service Admins knnen den ALL Parameter in Verbindung
	mit jedem Nick verwenden.

NICK_SERVADMIN_HELP_LIST
	Syntax: LIST [[Muster] [Bereich] [NOLIMIT] [NOEXPIRE]]
	
	Listet alle registrierten Nicknamen auf. Nicks mit 
	aktivierter PRIVATE Option werden nur fr Service Admins
	angezeigt. Nicks mit aktivierter NOEXPIRE Option 
	bekommen in der Ansicht fr Service Admins ein ! 
	vorangestellt.
	
	Wenn ein Muster angegeben wird, werden nur User mit 
	einer bereinstimmenden User-Maske angezeigt (im Format 
	nick!user@host). Die Anzahl der auf einmal angezeigten 
	Ergebnisse ist begrenzt; du kannst einen Bereich 
	angeben um Ergebnisse ber diese Grenze hinaus anzuzeigen.
	Zum Beispiel:
	
	   LIST 51-100
	       Zeigt die Ergebnisse von 51 bis 100 an.
	   LIST *Bot*!* 15-20
	       Zeigt die Ergebnisse von 15 bis 20 an, in denen
	       im Nick "Bot" vorkommt.
	   LIST *!joeuser@foo.com
	        Listet alle registrierten Nicks auf, die zu
	        joeuser@foo.com gehren.
	
	(Beachte: Anders als bei nummerierten Listen ist es nicht 
	mglich eine erweiterte Syntax wie 51-60,75-80 zu 
	verwenden).
	
	Wenn ein Muster oder ein Bereich angegeben wird, wird mit
	der NOLIMIT Option eine unbegrenzte Anzahl Ergebnisse
	angezeigt.
	
	Du kannst auerdem die NOEXPIRE Option angeben um nur
	die User anzuzeigen die als NOEXPIRE markiert sind.
	Diese Option ist auf Service Admins beschrnkt.

NICK_SERVADMIN_HELP_GLIST
	Syntax: GLIST [Nickname]
	
	Ohne angegebenen Parameter werden alle Nicknamen in deiner
	Gruppe mit ihren Ablaufdaten aufgelistet.
	
	Mit einem Nicknamen als Parameter werden alle Nicknamen in
	der Gruppe des angegebenen Nicks aufgelistet.
	Diese Verwendung ist auf Service Admins beschrnkt.

NICK_SERVADMIN_HELP_GETPASS
	Syntax: GETPASS Nickname
	
	Gibt das Passwort fr den angegebenen Nicknamen aus.
	Beachte dass wann immer dieser Befehl verwendet wird
	eine Mitteilung, die sowohl enthlt wer den Befehl 
	ausgefhrt hat als auch auf wen der Befehl angewendet 
	wurde, geloggt wird und als WALLOPS/GLOBOPS Nachricht
	gesendet wird.
	
	Beschrnkt auf Service Administratoren.
	
	Dieser Befehl steht nicht zur Verfgung wenn 
	Verschlsselung verwendet wird und es unmglich ist 
	ein Passwort mit OpenSSL zu generieren.

NICK_SERVADMIN_HELP_HOST
	Syntax: HOST SET [Nickname] [persnlicher-Hostname]
	        HOST LIST [Maske] [Bereich]
	
	HOST SET setzt den persnlichen Hostnamen fr entweder
	deinen eigenen oder den angegebenen Nicknamen. Wenn kein
	Hostname angegeben ist wird ein eventuell vorhandener 
	entfernt.
	
	HOST LIST listet Gruppen auf die einen persnlichen
	Hostnamen gesetzt haben. Wenn eine Maske angegeben
	wird werden nur Gruppen angezeigt die einen 
	bereinstimmenden persnlichen Hostnamen haben. Die
	Anzahl der angezeigten Ergebnisse ist begrenzt; du kannst
	einen Bereich angeben um Ergebnisse ber diese Grenze 
	hinaus anzuzeigen. Zum Beispiel:
	
	   HOST LIST 51-100
	       Zeigt die Ergebnisse von 51 bis 100 an.
	
	(Beachte: Anders als bei nummerierten Listen ist es nicht
	mglich eine erweiterte Syntax wie 51-60,75-80 zu 
	verwenden).
	
	Beschrnkt auf Service Operatoren mit Ausnahme von HOST SET,
	das so konfiguriert sein kann das jeder den Befehl nutzen darf.
	
	Beachte: Diese Funktion knnte in deinem Netzwerk 
	nicht zur Verfgung stehen.



###########################################################################
#
# ChanServ help messages
#
###########################################################################

CHAN_HELP
	%S erlaubt dir einen Channel zu registrieren und
	verschiedenes zu kontrollieren.  %S kann oftmals 
	bsartige User davon abhalten, Channel zu bernehmen
	indem begrenzt wird, wer Channel Operator Privilegien
	erhlt. Verfgbare Befehle sind unten aufgelistet;
	um sie zu benutzen tippe
	/msg %S Befehl.  Um mehr Informationen zu einem
	bestimmten Befehl zu erhalten, tippe 
	/msg %S HELP Befehl.
	
	    REGISTER   Einen Channel registrieren
	    IDENTIFY   Identifiziere dich mit deinem Passwort
	    SET        Channel Optionen und Informationen setzen
	    ACCESS     Bearbeite die Liste der privilegierten User
	    LEVELS     Die Bedeutung von Access Leveln neu definieren
	    AKICK      Die Autokick-Liste pflegen
	    DROP       Die Registrierung eines Channels aufheben
	    SENDPASS   Hilft verlorene Passwrter wieder zu erlangen
	
	Andere Befehle: BAN, CLEAR, CLIST, DEOP, DEVOICE, 
	                GETKEY, INFO, INVITE, KICK, LIST,
	                LOGOUT, OP, TOPIC, UNBAN, VOICE

CHAN_HELP_UNREAL
	
	In diesem IRC Netz sind auerdem die folgenden Befehle verfgbar:
	    DEHALFOP, DEOWNER, DEPROTECT, HALFOP, OWNER, PROTECT

CHAN_HELP_ULTIMATE
	
	In diesem IRC Netz sind auerdem die folgenden Befehle verfgbar:
	    DEHALFOP, HALFOP

CHAN_HELP_EXPIRES
	
	Bitte beachte dass jeder Channel der fr %d Tage nicht
	benutzt wird (d.h. kein User aus der Channel Access Liste
	betritt den Channel in diesem Zeitraum) automatisch 
	aufgelst wird.

CHAN_HELP_REGISTER
	Syntax: REGISTER Channel Passwort Beschreibung
	
	Registriert einen Channel in der %S Datenbank. Um diesen
	Befehl benutzen zu knnen muss man zuerst Channel Operaror
	in dem Channel sein den man registrieren mchte. Das 
	Passwort wird zusammen mit dem IDENTIFY Befehl verwendet
	um zu einem spteren Zeitpunkt anderen zu ermglichen, 
	nderungen an den Channel Einstellungen vorzunehmen.
	Der letzte Parameter, der zwingend angegeben werden muss,
	ist eine allgemeine Beschreibung der Bestimmung des Channels.
	
	Wenn du einen Channel registrierst, wirst du als "Grnder"
	des Channels vermerkt. Der Grnder eines Channels darf alle
	Einstellungen des Channels ndern;
	%S wird auerdem dem Grnder automatisch Channel-Operator
	Privilegien erteilen, wenn er/sie den Channel betritt.
	Fr weitere Informationen wie man einen Teil dieser 
	Privilegien auch an andere User vergibt, schau bitte nach
	dem ACCESS Befehl (/msg %S HELP ACCESS).
	
	HINWEIS: Um einen Channel zu registrieren, muss man zuerst 
	seinen Nicknamen registriert haben. Wenn du das noch nicht hast,
	/msg %s HELP um Informationen zu erhalten wie das geht.

CHAN_HELP_IDENTIFY
	Syntax: IDENTIFY Channel Passwort
	
	Authentifiziert dich gegenber %S als Grnder des angegebenen
	Channels. Viele Befehle setzen voraus, dass du zuerst diesen 
	Befehl verwendest, bevor du sie verwenden kannst. Das Passwort
	sollte dasselbe sein dass du beim REGISTER Befehl verwendet
	hast.
	
CHAN_HELP_LOGOUT
	Syntax: LOGOUT Channel Nickname
	
	Dieser Befehl bewirkt dass der gewhlte Nickname nicht lnger
	fr den angegebenen Channel identifiziert ist.
	
	Wenn du Grnder des Channels bist kannst du jeden eingeloggten 
	User ausloggen - ansonsten kannst du nur dich selbst ausloggen.

CHAN_HELP_DROP
	Syntax: DROP Channel
	
	Lst den angegebenen Channel auf. Kann nur vom Channel Grnder
	benutzt werden.

CHAN_HELP_SET
	Syntax: SET Channel Option Parameter
	
	Erlaubt dem Channel Grnder verschiedene Channel Optionen
	und Informationen einzustellen.
	
	Verfgbare Optionen:
	
	    FOUNDER       Setzt den Grnder eines Channels
	    SUCCESSOR     Setzt den Stellvertrter eines Channels
	    PASSWORD      Setzt das Grnder Passwort
	    DESC          Setzt die Channel Beschreibung
	    URL           Verbindet eine URL mit dem Channel
	    EMAIL         Verbindet eine E-Mail Adresse mit dem Channel
	    ENTRYMSG      Setzt eine Nachricht die den Usern beim
			     Betreten des Channels angezeigt wird.
	    BANTYPE       Legt fest, wie die Services Bans im Channel 
			     anlegen
	    MLOCK         Channel Mode Sperre an oder aus
	    KEEPTOPIC     Behlt das Topic bei wenn der Channel nicht
			     benutzt wird
	    OPNOTICE      Sendet eine Notiz wenn die OP/DEOP Befehle
			     benutzt werden
	    PEACE         Reguliert die Verwendung kritischer Befehle
	    PRIVATE       Verbirgt den Channel vor dem LIST Befehl
	    RESTRICTED    Beschrnkt den Zugang zum Channel
	    SECURE        aktiviert %S Sicherheits Funktionen
	    SECUREOPS     Strengere Kontrolle des ChanOp Status
	    SECUREFOUNDER Strengere Kontrolle des Channel Grnder Status
	    SIGNKICK      Signiert Kicks die mit dem KICK Befehl 
			     ausgefhrt werden
	    TOPICLOCK     Das Topic kann nur mit dem TOPIC Befehl
			     gendert werden
	
	Tippe /msg %S HELP Option um mehr Informationen zu einer
	bestimmten Option zu bekommen.

CHAN_HELP_SET_FOUNDER
	Syntax: SET Channel FOUNDER Nick
	
	ndert den Grnder eines Channels.  Der neue Nickname muss 
	registriert sein.

CHAN_HELP_SET_SUCCESSOR
	Syntax: SET Channel SUCCESSOR Nick
	
	ndert den Stellvertreter eines Channels. Falls der Nickname
	des Grnders abluft oder gelscht wird whrend der Channel
	noch registriert ist, wird der Stellvertreter der neue Grnder
	des Channels. Trotzdem, sollte der Stellvertreter bereits zu 
	viele Channel registriert haben (%d) wird der Channel aufgelst
	so als wenn kein Stellvertreter gesetzt wre. Der neue Nickname
	muss bereits registriert sein.

CHAN_HELP_SET_PASSWORD
	Syntax: SET Channel PASSWORD Passwort
	
	Setzt das Passwort dass zum identifizieren als Channel Grnder
	benutzt wird.

CHAN_HELP_SET_DESC
	Syntax: SET Channel DESC Beschreibung
	
	Setzt die Beschreibung fr den Channel die mit den LIST und
	INFO Befehlen angezeigt werden.

CHAN_HELP_SET_URL
	Syntax: SET Channel URL [Url]
	
	Verbindet die angegebene URL mit dem Channel. Diese URL wird
	angezeigt wann immer jemand Informationen ber den Channel mit
	dem INFO Befehl abfragt.  Wenn kein Parameter angegeben wird,
	wird jede aktuell gesetzte URL zum Channel gelscht.

CHAN_HELP_SET_EMAIL
	Syntax: SET Channel EMAIL [eMail-Adresse]
	
	Verbindet die angegebene E-Mail Adresse mit dem Channel.
	Diese Adresse wird angezeigt wann immer jemand Informationen 
	ber den Channel mit dem INFO Befehl abfragt. Wenn kein
	Parameter angegeben wird, wird jede aktuell gesetzte eMail-
	Adresse zum Channel gelscht.

CHAN_HELP_SET_ENTRYMSG
	Syntax: SET Channel ENTRYMSG [Nachricht]
	
	Setzt die Nachricht die den Usern via /NOTICE geschickt
	wird wenn sie den Channel betreten. Wenn kein Parameter
	angegeben wird, wird keine Nachricht beim Betreten des
	Channels geschickt.

CHAN_HELP_SET_BANTYPE
	Syntax: SET Channel BANTYPE Bantyp
	
	Setzt den Bantyp der von den Services benutzt wird
	wann immer sie jemanden aus deinem Channel bannen.
	
	Der Bantyp ist eine Zahl zwischen 0 und 3 die folgendes
	bedeutet:
	
	0: Ban in der Form *!user@host
	1: Ban in der Form *!*user@host
	2: Ban in der Form *!*@host
	3: Ban in der Form *!*user@*.domain

CHAN_HELP_SET_KEEPTOPIC
	Syntax: SET Channel KEEPTOPIC {ON | OFF}
	
	Aktiviert oder deaktiviert die Option zum Beibehalten des
	Topics fr einen Channel. Wenn das Beibehalten des 
	Topics aktiviert ist wird das Topic auch dann von %S 
	behalten wenn der letzte User den Channel verlassen hat 
	und wird auch wieder hergestellt wenn der Channel das nchste
	mal wieder betreten wird.

CHAN_HELP_SET_TOPICLOCK
	Syntax: SET Channel TOPICLOCK {ON | OFF}
	
	Aktiviert oder deaktiviert die Topic Sperre Option fr
	einen Channel. Wenn die Topic Sperre aktiviert ist
	wird %S eine nderung des Topics nicht zulassen, auer
	durch den TOPIC Befehl.

CHAN_HELP_SET_MLOCK
	Syntax: SET Channel MLOCK Modi
	
	Setzt die Parameter fr die Modus-Sperre des Channel.
	%S erlaubt es verschiedene Channel-Modi zu definieren, die
	immer an, aus oder frei whlbar entweder an oder aus sind.
	
	Der Modi Parameter ist genauso aufgebaut wie ein 
	/MODE Befehl; das heit, Modi nach einem + sind
	gesperrt aktiv und Modi nach einem - sind gesperrt
	deaktiviert. Beachte bitte, dass anders als beim /MODE
	Befehl jede Verwendung von SET MLOCK alle gesperrten 
	Modi entfernt werden bevor die neuen gesetzt werden!
	
	Warnung:  Wenn du einen Modus-gesperrten Key verwendest,
	so wie im zweiten Beispiel unten, sollte auch die RESTRICTED
	Option fr den Channel aktiviert werden 
	(siehe HELP SET RESTRICTED), oder jeder der den Channel 
	betritt wenn er leer ist, ist in der Lage den Key zu sehen.
	
	Beispiele:
	
	    SET #channel MLOCK +nt-iklps
	        Erzwingt die Modi n und t aktiv und die Modi i, k,
	        l, p und s inaktiv. Der Modus m is frei gelassen und
	        kann wahlweise an oder aus genutzt werden.
	
	    SET #channel MLOCK +knst-ilmp mein-key
	        Erzwingt die Modi k, n, s und t aktiv und die Modi
		i, l, m und p inaktiv. Erzwingt auerdem den Channel-
		Key "mein-key".
	
	    SET #channel MLOCK +
	        Entfernt die Modus-Sperre; alle Channel Modi knnen
		entweder an oder aus sein.

CHAN_HELP_SET_PEACE
	Syntax: SET Channel PEACE {ON | OFF}
	
	Aktiviert oder deaktiviert die Peace Option fr einen
	Channel. Wenn die Peace Option aktiviert ist kann ein 
	User keinen anderen User im Channel mehr ber %S Befehle
	kicken, bannen oder seinen Channel Status entfernen wenn
	dieser einen hheren oder gleichen Level hat.

CHAN_HELP_SET_PRIVATE
	Syntax: SET Channel PRIVATE {ON | OFF}
	
	Aktiviert oder deaktiviert die Private Option fr einen
	Channel. Wenn die Private Option genutzt wird, wird der
	Channel durch ein /msg %S LIST nicht aufgezeigt werden.

CHAN_HELP_SET_RESTRICTED
	Syntax: SET Channel RESTRICTED {ON | OFF}
	
	Aktiviert oder deaktiviert die Option fr eingeschrnkten
	Zugang fr einen Channel. Wenn die Option aktiviert ist
	werden User die sonst keine Channel Operator Privilegien 
	bekommen knnen (User mit negativen Zugriffs Leveln und,
	wenn Ops Sicherheit gesetzt ist, User die nicht auf der 
	Access Liste stehen) stattdessen aus dem Channel gekickt und
	gebannt.

CHAN_HELP_SET_SECURE
	Syntax: SET Channel SECURE {ON | OFF}
	
	Aktiviert oder deaktiviert %S Sicherheitsfunktionen
	fr einen Channel. Wenn SECURE gesetzt ist bekommen
	nur User die ihre Nicknamen bei %s registriert und sich
	mit ihrem Passwort identifiziert haben (IDENTIFY Befehl)
	Zugang zum Channel so wie in der Access Liste definiert.

CHAN_HELP_SET_SECUREOPS
	Syntax: SET Channel SECUREOPS {ON | OFF}
	
	Aktiviert oder deaktiviert die Ops Sicherheit fr einen 
	Channel. Wenn Ops Sicherheit aktiv ist wird Usern die 
	nicht auf der Userliste stehen kein Channel Operator Status 
	gewhrt.
	
CHAN_HELP_SET_SECUREFOUNDER
	Syntax: SET Channel SECUREFOUNDER {ON | OFF}
	
	Aktiviert oder deaktiviert die sicherer Grnder Option fr einen
	Channel. Wenn sicherer Grnder aktiv ist kann nur der tatschliche
	Grnder einen Channel auflsen, sein Passwort, den Grnder oder den
	Stellvertreter ndern und nicht jeder der durch %S identifiziert
	wurde (mit dem IDENTIFY Befehl).
	
CHAN_HELP_SET_SIGNKICK
	Syntax: SET Channel SIGNKICK {ON | LEVEL | OFF}
	
	Aktiviert oder deaktiviert signierte Kicks fr einen Channel.
	Wenn SIGNKICK gesetzt ist wird bei Kicks die mit dem
	%S KICK Befehl ausgefhrt werden der Nick des Ausfhrenden
	in die Begrndung eingefgt.
	
	Wenn LEVEL benutzt wird werden Kicks von Usern die einen 
	Level gleich oder grer dem angegebenen SIGNKICK Level haben 
	nicht signiert. Siehe auch /msg %S HELP LEVELS um mehr 
	Informationen zu erhalten.

CHAN_HELP_SET_OPNOTICE
	Syntax: SET Channel OPNOTICE {ON | OFF}
	
	Aktiviert oder deaktiviert die Op-Notiz Option fr einen
	Channel. Wenn Op-Notiz aktiv ist wird %S jedes mal eine
	Notiz in den Channel gesendet, wann immer der OP oder 
	DEOP Befehl fr einen User im Channel verwendet werden.

CHAN_HELP_ACCESS
	Syntax: ACCESS Channel ADD Nick Level
	        ACCESS Channel DEL {Nick | Eintrag-Nummer | List}
	        ACCESS Channel LIST [Maske | List]
	        ACCESS Channel CLEAR
	
	Verwaltet die Access Liste fr einen Channel. Die
	Accesss Liste legt fest welchen Usern ChanOp Status erlaubt 
	wird oder Zugang zu %S Befehlen im Channel. Verschiedene 
	User Level erlauben Zugriff zu unterschiedlichen Abstufungen
	von Privilegien; genauere Informationen erhlt man mit
	/msg %S HELP ACCESS LEVELS.
	Jeder Nick der nicht in der Access Liste steht hat automatisch 
	einen User Level von 0.
	
	Der ACCESS ADD Befehl fgt den angegebenen Nicknamen mit
	dem gegebenen User Level zur Access Liste hinzu. Sollte der
	Nick bereits in der Liste vorhanden sein wird sein Access
	Level auf den neuen angegebenen Level gendert. Der angegebene
	Level muss kleiner sein als der Level des Users der den
	Befehl verwendet. Falls der Nick bereits in der Liste steht
	muss der neue Level kleiner sein als der Level des Users der 
	den Befehl verwendet.

	Der ACCESS DEL Befehl entfernt den angegebenen Nick von der
	Access Liste. Wenn eine Liste von Eintrags Nummern angegeben wird,
	werden diese Eintrge entfernt. (Siehe Beispiel fr LIST unten.)
	
	Der ACCESS LIST Befehl zeigt die Access Liste. Wenn eine
	Maske mit Platzhaltern angegeben wird, werden nur die Eintrge
	angezeigt die mit der Maske bereinstimmen. Wenn eine Liste von 
	Eintrags Nummern angegeben wird, werden nur diese angezeigt;
	zum Beispiel:

	   ACCESS #channel LIST 2-5,7-9
	      Listet die Listeneintrge mit den Nummern 2 bis 5 und
	      7 bis 9 auf.
	      
	Der ACCESS CLEAR Befehl entfernt alle Eintrge von der
	Access Liste.

CHAN_HELP_ACCESS_LEVELS
	User Access Level
	
	Standartmig sind folgende Access Level definiert:
	
	   Founder   Voller Zugriff auf %S Funktionen;
	                     wird beim Betreten des Channels automatisch
	                     Op. Beachte dass nur eine Person auf der 
	                     Liste Grnder Status haben kann (kann nicht 
	                     mit dem ACCESS Befehl vergeben werden).
	        10   Zugriff auf den AKICK Befehl; automatisch Op
	                     beim Betreten.
	         5   Automatisch Op beim Betreten.
	         3   Automatisch Voice beim Betreten.
	         0   Keine speziellen Privilegien; kann durch andere
	                     Ops zum Op gemacht werden 
			     (auer Ops Sicherheit is aktiv).
	        <0   Darf nicht Op werden.
	
	Diese Level knnen gendert oder neue hinzugefgt werden durch
	Verwendung des LEVELS Befehl; tippe /msg %S HELP LEVELS 
	fr weitere Informationen.

CHAN_HELP_AKICK
	Syntax: AKICK Channel ADD [+Ablauf] {Maske | Nick} [Begrndung]
	        AKICK Channel STICK Maske
	        AKICK Channel UNSTICK Maske
	        AKICK Channel DEL {Maske| Eintrag-Nummer | Liste}
	        AKICK Channel LIST [Maske | liste]
	        AKICK Channel VIEW [Maske | liste]
	        AKICK Channel ENFORCE
	        AKICK CNhannel CLEAR
	
	Verwaltet die Autokick-Liste fr einen Channel.
	Wenn ein User auf der Autokick-Liste versucht den Channel
	zu betreten wird %S den User aus dem Channel bannen und
	kicken.
	
	Der AKICK ADD Befehl fgt den angegebenen Nick oder die
	User-Maske zur Autokick-Liste hinzu. Ablauf ist als 
	ganze Zahl spezifiziert, gefolgt von entweder w (Wochen),
	d (Tage), h (Stunden) oder m (Minuten).
	Kombinationen (wie z.B. 1h30m) sind erlaubt. Fr einen
	AutoKick der nicht Abluft diesen Parameter weglassen.
	Wenn eine Begrndung mit dem Befehl angegeben wird, wird 
	diese angezeigt wenn der User gekickt wird; Wenn nicht wird eine
	Standartnachricht angezeigt.
	
	Der AKICK STICK Befehl bannt die angegebene Maske dauerhaft 
	im Channel. Wenn jemand versucht denn Ban zu entfernen wird %S
	ihn automatisch neu anlegen. Auf diese Weise knnen nur User-Masken
	dauerhaft gebannt werden, keine registrierten Nicknamen.
	
	Der AKICK UNSTICK Befehl hebt den AKICK STICK Befehl 
	wieder auf, so dass der Ban von jedem Operator im Channel 
	entfernt werden kann.
	
	Der AKICK DEL Befehl entfernt den angegebenen Nick oder die
	Maske von der Autokick-Liste. Es entfernt allerdings keine Bans
	die durch einen AutoKick verhngt wurden; Diese mssen manuell
	entfernt werden. Wenn eine Liste von Eintragsnummern angegeben 
	wird, werden diese entfernt (siehe Beispiele fr LIST unten)
	
	Der AKICK LIST Befehl zeigt die Autokick-Liste an. Wenn 
	eine Platzhalter Maske angegeben wird werden nur die Eintrge
	angezeigt die mit der Maske bereinstimmen. Wenn eine Liste
	von Eintragsnummern angegeben wird, werden nur diese Eintrge 
	angezeigt; zum Beispiel:

	   AKICK #channel LIST 2-5,7-9
	      Listet AutoKick Eintrge mit den Nummern 2 bis 5 und
	      7 bis 9 auf.
	
	Der AKICK VIEW Befehl ist eine ausfhrlichere Version des
	AKICK LIST Befehls.
	
	Der AKICK ENFORCE Befehl veranlasst %S die aktuelle AKICK 
	Liste durchzusetzen, indem alle User die mit einer AKICK Maske
	bereinstimmen aus dem Channel entfernt werden.
	
	Der AKICK CLEAR Befehl entfernt alle Eintrge von der
	Akick Liste.

CHAN_HELP_LEVELS
	Syntax: LEVELS Channel SET typ Level
	        LEVELS Channel {DIS | DISABLE} Typ
	        LEVELS Channel LIST
	        LEVELS Channel RESET
	
	Der LEVELS Befehl erlaubt eine feinere Kontrolle ber die 
	Bedeutung numerischer Access Level die fr Channel verwendet 
	werden. Mit diesem Befehl kann man die Access Level definieren
	die fr die meisten %S Funktionen bentigt werden. 
	(Die SET FOUNDER und SET PASSWORD Befehle, genau wie
	dieser Befehl, sind immer auf den Channel Grnder beschrnkt.)
	
	LEVELS SET erlaubt es den Access Level fr eine Funktion oder
	eine Gruppe von Funktionen zu ndern. LEVELS DISABLE 
	(oder in Kurzfom DIS) deaktiviert eine automatische Eigenschaft
	oder verbietet Zugriff auf eine Funktion fr andere als den
	Channel Grnder. LEVELS LIST zeigt die aktuellen Level fr jede
	Funktion oder Funktionsgruppe. LEVELS RESET setzt alle Level auf
	die Standard-Level eines neu erzeugten Channel zurck (siehe
	HELP ACCESS LEVELS).
	
	Um eine Liste der Eigenschaften und Funktionen deren Level angepasst
	werden knnen, siehe HELP LEVELS DESC.

CHAN_HELP_LEVELS_DESC
	Die folgenden Eigenschafts-/Funktionsnamen werden verstanden.
	Beachte, dass die Level fr AUTODEOP und NOJOIN Maximal-Level
	sind, whrend alle anderen Minimal-Level sind.

CHAN_HELP_LEVELS_DESC_FORMAT
	    %-*s  %s

CHAN_HELP_INFO
	Syntax: INFO Channel [ALL]
	
	Listet Informationen ber den genannten registrierten
	Channel auf, inklusive seinem Grnder, Zeitpunkt der
	Registrierung, Zeitpunkt der letzten Nutzung, 
	Beschreibung und Modi-Sperren, wenn vorhanden. 
	Wenn ALL angegeben wird werden auerdem die 
	Begrungsnachricht und der Stellvertreter angezeigt. 
	
	Standartmig ist die ALL Option auf User beschrnkt,
	die Grnder Zugriff auf den Channel haben.	

CHAN_HELP_LIST
	Syntax: LIST [[Muster] [Bereich]]
	
	Listet alle registrierten Channel auf. Channel mit gesetzter
	PRIVATE Option werden nicht angezeigt.
	
	Wenn Muster angegeben wird, werden nur die Channel mit
	bereinstimmender Maske angezeigt. Die Anzahl der gleichzeitig
	angezeigten Ergebnisse ist begrenzt; man kann einen Bereich
	angeben um Ergebnisse ber diese Grenzen hinaus anzuzeigen.
	Zum Beispiel:
	
	   LIST 51-100
	       Zeigt die Ergebnisse 51 bis 100.
	   LIST *help* 15-20
	       Zeigt Ergebnisse 15 bis 20 die "help" im Namen haben.
	
	(Beachte: Anders als bei nummerierten Listen ist es nicht mglich 
	eine erweiterte Syntax wie 51-60,75-80 zu benutzen).
	
	In manchen Netzwerken ist dieser Befehl IRC Operatoren vorbehalten.

CHAN_HELP_CLIST
	Syntax: CLIST [Privileg]
	
	Listet Channel auf wo du die angegebenen Privilegien hast.
	
	Verwendungs Beispiele:
	
	  CLIST
	  
	    Listet alle Channel auf in denen du Privilegien hast.
	  
	  CLIST FOUNDER
	  
	    Listet alle Channel auf in denen du Grnder bist.
	    
	  CLIST SUCCESSOR
	  
	    Listet alle Channel auf in denen du Stellvertreter bist. 
	
	  CLIST 3
	  
	    Listet alle Channel auf in denen du Access Level 3
	    oder hher hast.
	  
	  CLIST -1
	  
	    Listet alle Channel auf in denen du Access Level -1
	    oder weniger hast.

CHAN_HELP_OP
	Syntax: OP [#channel [Nick]]
	
	Gibt einem ausgewhlten Nick im Channel Op Status.
	Wenn kein Nick angegeben ist, wirst du Operator. Wenn
	weder Channel noch Nick angegeben sind wirst du Op in 
	allen Channeln in denen du dich gerade befindest, 
	vorausgesetzt du hast die Berechtigung dazu.
	
	Standartmig beschrnkt auf User mit Level 5 oder hher
	im Channel.

CHAN_HELP_DEOP
	Syntax: DEOP [#channel [Nick]]
	
	Entzieht einem ausgewhlten Nick im Channel den Op Status.
	Wenn kein Nick angegeben ist, wirst du 'deoped'. Wenn weder
	Channel noch Nick angegeben sind wirst du in allen Channeln
	in denen du dich gerade befindest 'deoped', vorausgesetzt
	du hast die Berechtigung dazu.
	
	Standartmig beschrnkt auf User mit Level 5 oder hher
	im Channel.
	
CHAN_HELP_VOICE
	Syntax: VOICE [#channel [Nick]]
	
	Gibt einem ausgewhlten Nick im Channel Voice Status.
	Wenn kein Nick angegeben ist, wirst du Voice. Wenn
	weder Channel noch Nick angegeben sind wirst du Voice
	in allen Channeln in denen du dich gerade befindest, 
	vorausgesetzt du hast die Berechtigung dazu.
	
	Standartmig beschrnkt auf User mit Level 5 oder hher
	im Channel oder User mit Level 3 und hher um sich selbst
	Voice Status zu geben.

CHAN_HELP_DEVOICE
	Syntax: DEVOICE [#channel [Nick]]
	
	Entzieht einem ausgewhlten Nick im Channel den Voice
	Status. Wenn kein Nick angegeben ist, wirst du 'devoiced'.
	Wenn weder Channel noch Nick angegeben sind wirst du in 
	allen Channeln in denen du dich gerade befindest 'devoiced',
	vorausgesetzt du hast die Berechtigung dazu.
	
	Standartmig beschrnkt auf User mit Level 5 oder hher
	im Channel oder User mit Level 3 und hher um sich selbst
	den Voice Status zu entziehen.
	
CHAN_HELP_HALFOP
	Syntax: HALFOP [#channel [Nick]]
	
	Gibt einem ausgewhlten Nick im Channel HalfOp Status.
	Wenn kein Nick angegeben ist, wirst du HalfOp. Wenn
	weder Channel noch Nick angegeben sind wirst du HalfOp
	in allen Channeln in denen du dich gerade befindest, 
	vorausgesetzt du hast die Berechtigung dazu.
	
	Standartmig beschrnkt auf User mit Level 5 oder hher
	im Channel oder User mit Level 4 und hher um sich selbst
	HalfOp Status zu geben.

CHAN_HELP_DEHALFOP
	Syntax: DEHALFOP [#channel [nick]]
	
	Entzieht einem ausgewhlten Nick im Channel den HalfOp
	Status. Wenn kein Nick angegeben ist, wird der der
	HalfOp Status entzogen. Wenn weder Channel noch Nick 
	angegeben sind wird dir in allen Channeln in denen du 
	dich gerade befindest der HalfOp Status entzogen,
	vorausgesetzt du hast die Berechtigung dazu.
	
	Standartmig beschrnkt auf User mit Level 5 oder hher
	im Channel oder User mit Level 4 und hher um sich selbst
	den HalfOp Status zu entziehen.
	
CHAN_HELP_PROTECT
	Syntax: PROTECT [#channel [Nick]]
	
	Schtzt einen ausgewhlten Nick in einem Channel. Wenn kein
	Nick angegeben wurde wirst du geschtzt. Wenn weder Channel
	noch Nick angegeben wurden wirst du in allen Channeln 
	gschtzt in denen du dich gerade befindest, vorausgesetzt
	du hast die Berechtigung dazu.
	
	Standartmig beschrnkt auf den Grnder oder User mit Level
	10 und hher um sich selbst zu schtzen.

CHAN_HELP_DEPROTECT
	Syntax: DEPROTECT [#channel [Nick]]
	
	Hebt den Schutz fr einen ausgewhlten Nick in einem Channel
	auf. Wenn kein Nick angegeben wird, wird der Schutz fr dich 
	aufgehoben. Wenn weder Channel noch Nick angegeben werden, 
	wird der Schutz fr dich in allen Channeln aufgehoben in 
	denen du dich gerade befindest, vorausgesetzt du hast die 
	Berechtigung dazu.
	
	Standartmig beschrnkt auf den Grnder oder User mit Level
	10 oder hher um ihren eigenen Schutz aufzuheben.

CHAN_HELP_OWNER
	Syntax: OWNER [#channel]
	
	Gibt dir Grnder Status im Channel. Wenn kein Channel
	angegeben wird, wirst du in allen Channeln Grnder Status
	bekommen in denen du dich befindest, vorausgesetzt du hast
	die Berechtigung dazu.

	Beschrnkt auf User mit Grnder Level im Channel.

CHAN_HELP_DEOWNER
	Syntax: DEOWNER [#channel]
	
	Hebt deinen Grnder Status im Channel auf. Wenn kein
	Channel angegeben wird, wird dein Grnder Status in allen
	Channeln in denen du dich gerade befindest aufgehoben,
	vorausgesetzt du hast die Berechtigung dazu
	
	Beschrnkt auf User mit Grnder Level im Channel.

CHAN_HELP_INVITE
	Syntax: INVITE Channel
	
	Befiehlt %S dich in den angegebenen Channel einzuladen.  
	
	Standartmig beschrnkt auf User mit Level 5 oder hher
	im Channel.

CHAN_HELP_UNBAN
	Syntax: UNBAN Channel
	
	Befiehlt %S alle Bans aufzuheben die dich am betreten
	des angegebenen Channel hindern.
	
	Standartmig beschrnkt auf User mit Level 5 oder hher
	im Channel.
	
CHAN_HELP_KICK
	Syntax: KICK [#channel [Nick [Begrndung]]]
	
	Kickt den ausgewhlten Nick aus dem Channel. Wenn kein 
	Nick angegeben wird, wirst du gekickt. Wenn weder Channel
	noch Nick angegeben werden, wirst du aus allen Channeln
	gekickt in denen du dich gerade befindest, vorausgesetzt
	du hast die Berechtigung dazu.
	
	Standartmig beschrnkt auf User mit Level 5 oder hher
	im Channel.

CHAN_HELP_BAN
	Syntax: BAN [#channel [Nick [Begrndung]]]
	
	Bannt den ausgewhlten Nick aus dem Channel. Wenn kein 
	Nick angegeben wird, wirst du gebannt. Wenn weder Channel
	noch Nick angegeben werden, wirst du aus allen Channeln
	gebannt in denen du dich gerade befindest, vorausgesetzt
	du hast die Berechtigung dazu.
	
	Standartmig beschrnkt auf User mit Level 5 oder hher
	im Channel.

CHAN_HELP_TOPIC
	Syntax: TOPIC Channel [Topic]
	
	Veranlasst %S das Channel Topic auf das angegebene zu 
	setzen. Wenn kein Topic angegeben wird, wird ein 
	leeres Topic gesetzt. Dieser Befehl ist am ntzlichsten 
	in Kombination mit SET TOPICLOCK. 
	Siehe /msg %S HELP SET TOPICLOCK fr mehr Informationen.
	
	Standartmig beschrnkt auf User mit Grnder Level 
	im Channel. 

CHAN_HELP_CLEAR
	Syntax: CLEAR Channel Was
	
	Veranlasst %S bestimmte Einstellungen fr einen Channel zu
	entfernen. Was kann eines der folgenden Wrter sein:
	
	     MODES    Setzt alle Modi fr den Channel zurck (entfernt
	                  z.B. die Modi i,k,l,m,n,p,s,t).
	     BANS     Entfernt alle Bans fr den Channel.
	     OPS      Entfernt den Channel-Operator status (Modus +o) 
	                  von allen Channel Operatoren.
	     VOICES   Entfernt den "Voice" Status (mode +v) von jedem
	                  fr den dieser Modus gesetzt ist.
	     USERS    Entfernt (kickt) alle User aus dem Channel.
	
	Standartmig beschrnkt auf User mit Grnder Level 
	im Channel.
	
CHAN_HELP_GETKEY
	Syntax: GETKEY Channel
	
	Gibt den Schlssel zum angegebenen Channel aus. Dieser Befehl
	ist hauptschlich fr die Verwendung durch Bots und/oder Scripte
	vorgesehen, daher ist die Ausgabe folgendermaen aufgebaut:
	
	KEY <Channel> <Schlssel>
	
	Der Schlssel ist "NO KEY" wenn kein Schlssel festgelegt wurde.
	
CHAN_HELP_SENDPASS
	Syntax: SENDPASS Channel
	
	Sendet das Passwort des angegebenen Channel zu der eMail- 
	Adresse die im Nickname Eintrag des Grnders hinterlegt ist.
	Dieser Befehl ist sehr ntzlich um verlorene Passwrter 
	wieder zu erlangen.
	
	Kann in einigen Netzwerken zur Verwendung durch IRC 
	Operatoren beschrnkt sein.
	
	Dieser Befehl ist nicht verfgbar wenn Verschlsselung
	aktiviert ist und es unmglich ist ein Passwort mit
	OpenSSL zu erzeugen.

CHAN_SERVADMIN_HELP
	
	Die fogenden Befehle sind fr Service Admins verfgbar:
	
	    GETPASS    Zeigt dass Grnder-Passwort eines Channel an
	                   (nur mgl. wenn die Verschlsselung
	                   deaktiviert ist)
	    STATUS     Zeigt den momentanen Access-Level eines
	                   Users in einem Channel an
	
	Service Admins knnen auerdem jeden Channel auflsen ohne
	sich mit einem Passwort identifizieren zu mssen und knnen
	fr jeden Channel die Access, AKICK und Level Einstellungen
	sowie die Liste der Privilegien fr jeden Nick ansehen.
	
CHAN_SERVADMIN_HELP_LOGOUT
	Syntax: LOGOUT Channel [Nickname]
	
	Dieser Befehl loggt den ausgewhlten Nicknamen aus dem
	gewhlten Channel aus.
	
	Wenn du Grnder des Channels bist kannst du jeden User
	ausloggen, ansonsten nur dich selbst.
	
	Wenn du Service Admin bist, kannst du jeden aus jedem
	Channel ausloggen ohne Grnder des Channels sein zu 
	mssen. Du kannst auerdem den Nickname Parameter weg-
	lassen; damit werden alle identifizierten User aus dem 
	Channel ausgeloggt.

CHAN_SERVADMIN_HELP_DROP
	Syntax: DROP Channel
	
	Hebt die Registrierung des genannten Channels auf.
	Nur Service Admins knnen Channel auflsen fr die
	sie nicht als Grnder identifiziert sind.

CHAN_SERVADMIN_HELP_SET
	
	Service Admins knnen die Option NOEXPIRE setzen,
	mit der Channel nicht ablaufen knnen.
	Zustzlich knnen Service Admins Optionen fr jeden Channel
	setzen, ohne mit einem Passwort (als Grnder) fr den 
	Channel identifiziert zu sein.

CHAN_SERVADMIN_HELP_SET_NOEXPIRE
	Syntax: SET Channel NOEXPIRE {ON | OFF}
	
	Bestimmt ob der angegebene Channel ablaufen kann oder nicht.
	Wird die Option auf ON gesetzt luft der Channel nicht ab.
	
	Beschrnkt auf Service Administratoren.

CHAN_SERVADMIN_HELP_INFO
	
	Service Admins knnen den ALL Parameter in Verbindung mit 
	jedem beliebigen Channel anwenden.

CHAN_SERVADMIN_HELP_LIST
	Syntax: LIST [[Muster] [Bereich] [NOLIMIT] [NOEXPIRE]]
	
	Listet alle registrierten Channel auf. Channel die als PRIVATE
	eingerichtet sind werden nur Service Admins angezeigt. Channel
	mit der NOEXPIRE Option haben fr Service Admins ein !
	dem Channel Namen vorangestellt.
	
	Wenn ein Muster angegeben wird, werden nur Channel mit einer
	bereinstimmenden Maske angezeigt. Die Anzahl der gleichzeitig 
	angezeigten Ergebnisse ist begrenzt; du kannst einen Bereich
	angeben um Ergebnisse ber diese Grenze hinaus zu sehen.
	Zum Beispiel:
	
	   LIST 51-100
	       Zeigt die Ergebnisse 51 bis 100 an.
	   LIST *help* 15-20
	       Zeigt die Ergebnisse 15 bis 20 an, in deren Name "help"
	       vorkommt.
	
	(Beachte: Anders als bei nummerierten Listen ist es nicht mglich 
	eine erweiterte Syntax wie 51-60,75-80 zu benutzen).
	
	Wenn ein Muster oder Bereich angegeben wurde zeigt die NOLIMIT
	Option eine unbegrenzte Anzahl von Ergebnissen an.
	
	Du kannst ausserdem die NOEXPIRE Option verwenden um nur
	Channel anzuzeigen die als NOEXPIRE Channel markiert sind.
	Diese Option ist beschrnkt auf Service Admins.

CHAN_SERVADMIN_HELP_CLIST
	Syntax: CLIST [Nickname] [Privilegien]
	
	Listet Channel auf in denen du die angegebenen 
	Privilegien hast. Wenn ein Nickname angegeben ist 
	werden stattdessen die Privilegien fr diesen User 
	angezeigt (Diese Verwendung ist auf Service Admins
	beschrnkt). Channel die auf NOEXPIRE gesetzt sind 
	bekommen ein Ausrufezeichen vorangestellt.
	
	Verwendungs Beispiele:
	
	  CLIST Epona
	  
	    Listet alle Channel auf in denen Epona 
	    Privilegien hat.
	  
	  CLIST Pegasus FOUNDER
	  
	    Listet alle Channel auf in denen Pegasus 
	    Grnder ist.
	    
	  CLIST SUCCESSOR
	  
	    Listet alle Channel auf in denen du 
	    Stellvertreter bist. 
	
	  CLIST 3
	  
	    Listet alle Channel auf in denen du Access
	    Level 3 oder hher hast.
	  
	  CLIST Unicorn-Lover -1
	  
	    Listet alle Channel auf in denen Unicorn-Lover
	    Access Level -1 oder niedriger hat.

CHAN_SERVADMIN_HELP_GETPASS
	Syntax: GETPASS Channel
	
	Gibt das Passwort fr den angegebenen Channel aus.
	Beachte dass wann immer dieser Befehl verwendet wird
	eine Nachricht mit dem Namen des Users der den Befehl
	verwendet hat und den Channel auf den der Befehl angewendet
	wurde mitgeloggt und als WALLOPS/GLOBOPS Nachricht 
	gesendet	wird.
	
	Beschrnkt auf Service Administratoren.
	
	Dieser Befehl steht nicht zur Verfgung wenn Verschlsselung
	verwendet wird und es unmglich ist das Passwort mit OpenSSL
	zu erzeugen.

CHAN_SERVADMIN_HELP_STATUS
	Syntax: STATUS Channel Nickname
	
	Gibt den aktuellen Access Level des angegebenen Nick im
	angegebenen Channel aus. Die Ausgabe ist in der Form:
	
	    STATUS Channel Nickname Access Level
	
	Wenn ein Fehler auftritt hat die Ausgabe die Form:
	
	    STATUS ERROR Fehlermeldung
	
	Beschrnkt auf Service Administratoren.


###########################################################################
#
# MemoServ help messages
#
###########################################################################

MEMO_HELP
	%S ermglicht es IRC-Usern Kurznachrichten an andere
	IRC-User zu versenden, egal ob diese zu dem Zeitpunkt online
	sind oder nicht. Sowohl der Absender- als auch der Empfnger-
	nickname mssen registriert sein um ein Memo zu versenden.
	
	%S's Befehle:
	
	    SEND   Versende ein Memo an einen Nick oder Channel
	    CANCEL Letztes versandtes Memo zurckholen
	    LIST   Deine Memos auflisten
	    READ   Lesen eines oder mehrerer Memos
	    DEL    Lschen eines oder mehrerer Memos
	    SET    Optionen bezglich Memos einstellen
	
	Gib /msg %S HELP Befehl ein um Hilfe zu einem der
	obenstehenden Befehle zu erhalten.

MEMO_HELP_SEND
	Syntax: SEND {Nick | Channel} Memotext
	
	Schickt dem angegebenen Nick ein Memo mit Memotext.
	Wenn ein Channel anstatt eines Nicks eingegeben wurde, wird
	dass Memo an alle User auf der Access-Liste (min. Level 10) des
	Channels versandt (Standartmssig; dies kann mit dem %s
	LEVELS Befehl gendert werden.)
	
	Die Empfnger bekommen eine Notice dass sie ein neues Memo haben.
	Der Ziel-Nick/Channel muss registriert sein.
	
MEMO_HELP_CANCEL
	Syntax: CANCEL Nick
	
	Bricht den Versand des letzten Memos an Nick ab falls
	dass Memo bis dahin noch nicht gelesen wurde.

MEMO_HELP_LIST
	Syntax: LIST [Liste | NEW]
	
	Zeigt alle Memos die du momentan hast. Mit NEW werden
	nur neue (ungelesene) Memos angezeigt. Ungelesene Memos sind
	mit einem "*" links neben der Nummer gekennzeichnet. Du
	kannst auch eine Liste mit Zahlen eingeben wie im Beispiel
	unten:
	
	   LIST 2-5,7-9
	      Zeigt eine Liste der Memos von 2 bis 5 und 7 bis 9 an.

MEMO_HELP_READ
	Syntax: READ {Nummer | Liste | LAST | NEW}
	
	Zeigt dir den Text der angegebenen Memos. Wenn LAST eingegeben
	wurde wird dass zuletzt eingegangene Memo angezeigt. Wenn du
	NEW eingegeben hast bekommst du alle neuen Memos angezeigt.
	Anderenfalls bekommst du Memo Nummer angezeigt. Du kannst
	auch eine Liste von Zahlen eingeben wie im Beispiel unten:
	
	   READ 2-5,7-9
	      Zeigt die Memos 2 bis 5 und 7 bis 9 an.

MEMO_HELP_DEL
	Syntax: DEL {Nummer | Liste | ALL}
	
	Lscht die angegebenen Memo(s).  Du kannst mehrere Memo-
	Nummern oder Nummern-Bereiche anstatt einer Nummer angeben
	wie im 2. Beispiel unten.
	
	Wenn ALL eingegeben wurde, werden alle deine Memo
	gelscht.
	
	Beispiele:
	
	   DEL 1
	      Lscht dass erste Memo.
	
	   DEL 2-5,7-9
	      Lscht die Memos 2 bis 5 und 7 bis 9.

MEMO_HELP_SET
	Syntax: SET Option Parameter
	
	Stellt diverse Memo-Optionen ein.  Option kann eine der
	folgenden sein:
	
	    NOTIFY      ndert wann du ber neue Memos benachrichtigt
	                   wirst.
	    LIMIT       Stellt die maximale Anzahl an Memos ein die du
	                   empfangen kannst.
	    FORWARD     Stellt ein ob du eine Kopie der neuen Memos
	                   an deine e-mail Adresse geschickt bekommst.
	
	Gib /msg %S HELP SET Option ein um weitere Informationen
	zu einer bestimmten Option zu erhalten.

MEMO_HELP_SET_NOTIFY
	Syntax: SET NOTIFY {ON | LOGON | NEW | OFF}
	
	ndert wann du ber neue Memos benachrichtigt wirst.
	
	    ON      Du wirst ber neue Memos beim einloggen, wenn du 
	               von /AWAY zurckkommst und wenn sie an dich
	               versandt werden, benachrichtigt.
	    LOGON   Du wirst nur beim einloggen oder beim zurckkehren
	               von /AWAY benachrichtigt.
	    NEW     Du wirst nur nach dem Versand von Memos an dich
	               benachrichtigt.
	    OFF     Du erhltst keine Benachrichtigung ber neue Memos.
	
	ON ist im Prinzip LOGON und NEW zusammen.

MEMO_HELP_SET_LIMIT
	Syntax: SET LIMIT Limit
	
	Stellt die maximale Anzahl an Memos die du gespeichert haben darfst ein.
	Wenn du diesen Wert auf 0 setzt kann dir keiner mehr Memos an
	dich schicken.  Du kannst diesen Wert jedoch nicht hher als %d
	einstellen.

MEMO_HELP_SET_FORWARD
	Syntax: SET FORWARD {ON | OFF}
	
	Stellt ein ob du eine Kopie der neuen Memos per e-mail erhltst
	(ON) oder nicht (OFF).
	
	Du kannst diese Option nur aktivieren wenn du deinem Nick eine
	authentifizierte e-mail Adresse zugewiesen hast.
	Gib /msg %s HELP SET EMAIL und /msg %s HELP AUTH ein
	fr weitere Informationen.
	
	Diese Option kann auf manchen Netzwerken deaktiviert sein.

MEMO_HELP_INFO
	Syntax: INFO
	
	Zeigt Informationen ber die Anzahl an Memos, wieviele davon
	ungelesen sind und wieviele Memos du insgesamt empfangen kannst
	an.

MEMO_SERVADMIN_HELP_SET_LIMIT
	Syntax: SET LIMIT [Nick] {Limit | NONE} [HARD]
	
	Stellt die maximale Anzahl an Memos die ein User haben darf ein.
	Wenn dass Limit auf 0 gesetzt wird kann der User keine Memos
	mehr empfangen; es auf NONE zu setzen erlaubt dem User
	soviele Memos zu empfangen und zu speichern wie er mchte. 
	Wird kein Nickname angegeben wird dein eigenes Limit gesetzt.
	
	Hinzufgen von HARD hindert den User daran sein eigenes Limit
	zu ndern. Wird HARD weggelassen hat es den umgekehrten
	Effekt - dem User wird erlaubt sein Limit zu ndern (auch
	wenn ein vorheriges Limit mit HARD gesetzt war).
	
	Die Benutzung des SET LIMIT Befehls ist auf 
	Services-Admins beschrnkt. Andere Benutzer knnen
	nur ein Limit fr sich selbst setzen, knnen ihr Limit nicht
	entfernen, knnen kein Limit ber %d setzen und drfen kein
	hard-limit setzen.
	
MEMO_SERVADMIN_HELP_INFO
	Syntax: INFO [Nick]
	
	Ohne Parameter werden Informationen ber die Anzahl an Memos
	die du hast, wieviele davon ungelesen sind und wieviele
	Memos du insgesamt empfangen kannst, angezeigt.
	
	Mit einem Channel als Parameter werden die gleichen Infos
	fr den angegebenen Channel angezeigt.
	
	Mit einem Nickname als Parameter werden dieselben Informationen
	fr den angegebenen Nick angezeigt.  Diese Verwendung ist auf
	Services-Admins beschrnkt.

###########################################################################
#
# OperServ help messages
#
###########################################################################

OPER_HELP
	%S Befehle:
	    GLOBAL      Sendet eine Nachricht an alle Benutzer.
	    STATS       Zeigt den Status der Services und des Netzwerks
	    OPER LIST   Zeigt die Services Operatoren an
	    ADMIN LIST  Zeigt die Services Administratoren an
	
	Befehle fr Services Operatoren:
	    MODE        ndert die Modes in einem Channel
	    KICK        Kickt einen Benutzer von einem Channel
	    CLEARMODES  Entfernt alle Modes von einem Channel
	    AKILL       Verndert die AKILL Liste
	    SGLINE      Verndert die SGLINE Liste
	    SQLINE      Verndert die SQLINE Liste
	    SZLINE      Verndert die SZLINE Liste
	
	Befehle fr Services Administratoren:
	    OPER        Verndert die Liste der Services Operatoren
	    CHANLIST    Zeigt alle Channel des Netzwerkes
	    USERLIST    Zeigt alle Nicks des Netzwerkes
	    NEWS        Nachrichten zu verschiedenen Ereignissen festlegen
	    SESSION     Zeigt die Liste der Sessions pro Host an.
	    EXCEPTION   Verndert die Liste der Sessionlimit-Exceptions
	    BLACKLIST   Verndert die Liste der geblacklisteten Hosts.
	    NOOP        Entfernt temporr alle O:lines von einem Server.
	    JUPE        "Jupitert" einen Server
	    SET         Verndert globale Epona Optionen
	    RELOAD      Ldt die Epona Konfigurationsdateien neu ein.
	    SYNC        Synchronisiert die Module
	    RESTART     Startet Epona neu.
	    STOP        Beendet Epona.
	    FATAL       Bricht die Ausfhrug von Epona ab, ohne Daten zu speichern.
	
	Befehle fr Root-Administratoren:
	    ADMIN       Verndert die Liste der Services Administratoren.
	    MODULES     Managed nachladbare Epona Module.
	
	Hinweis: Alle Befehle an %S werden protokolliert!

OPER_HELP_GLOBAL
	Syntax: GLOBAL Nachricht
	
	Mit diesem Befehl knnen IRCOPs eine Nachricht an alle Benutzer
	des Netzwerks senden. Die Nachricht wird dann vom Nick %s
	zugestellt.

OPER_HELP_STATS
	Syntax: STATS [AKILL | ALL | RESET]
	
	Wird dieser Befehl ohne weitere Optionen aufgerufen zeigt er die Anzahl
	der Benutzer an die gerade bei den Services angemeldet sind. Auerdem wird
	die Anzahl der IRCOPs, der Benutzerrekord seit die Services dass erste mal
	gestartet wurden und die Zeit wie lange die Services bereits laufen angezeigt.
	
	Mit der AKILL Option wird die aktuelle Gre der AKILL, SGLINE, SQLINE und
	SZLINE Listen sowie deren Standardablaufzeit angezeigt.   
	
	Die ALL ist nur fr Services Administratoren verfgbar. Sie zeigt
	Informationen ber den Speicherverbrauch der Services an.
	DIESE OPTION KANN DIE SERVICES FR EINEN MOMENT EINFRIEREN LASSEN. DAHER
	BENUTZE SIE NICHT ZU HUFIG!
		
	Mit der RESET Option wird der Benutzerrekord auf die Anzahl der im Moment
	mit dem Netzwerk verbundenen Benutzer gesetzt.
	
	UPTIME kann als Synonym fr STATS verwendet werden.

OPER_HELP_OPER
	Syntax: OPER ADD Nick
	        OPER DEL {Nick | Eintrag | Liste}
	        OPER LIST [Maske | Liste]
	        OPER CLEAR
	
	Mit diesem Befehl lassen sich Nicknamen zur Liste der Services Operatoren
	hinzufgen oder entfernen. Ein Benutzer dessen Nickname auf dieser Liste
	steht, kann sobald er sich bei %s identifiziert hat alle Befehle ausfhren
	die fr Services Operatoren zur Verfgung stehen.  
	
	Der OPER ADD Befehl fgt den angegebenen Nicknamen zur Liste der
	Services Operatoren hinzu.
	
	Der OPER DEL Befehl entfernt den angegebenen Nicknamen von der Liste
	der Services Operatoren. Wenn eine Liste mit Nummern von Eintrgen bergeben
	wird, werden alle diese Eintrge entfernt. (Ein Beispiel folgt im nchsten
	Abschnitt.) 
	
	Mit dem OPER LIST Befehl wird die Liste der Services Operatoren angezeigt.
	Wird eine Maske mit einem Platzhalter bergeben, wird jeder Eintrag angezeigt,
	der der Maske entspricht. Wird eine Liste mit Nummern von Eintrgen bergeben,
	werden nur diese Eintrge angezeigt. 
	
	Ein Beispiel:
	
	   OPER LIST 2-5,7-9
	      Zeigt die Services Operatoren 2 bis 5 und 7 bis 9 an.
	      
	Der OPER CLEAR Befehl leert die Liste der Services Operatoren.
	
	Jeder IRC Operator darf den OPER LIST Befehl verwenden.
	Alle anderen Befehle stehen nur den Services Administratoren zur
	Verfgung.

OPER_HELP_ADMIN
	Syntax: ADMIN ADD Nick
	        ADMIN DEL {Nick | Eintrag | Liste}
	        ADMIN LIST [Maske | Liste]
	        ADMIN CLEAR
	
	Mit diesem Befehl sind Services Root Administratoren in der Lage Nicknamen
	der Liste Services Administratoren hinzuzufgen oder sie von der Liste zu
	entfernen. Ein Benutzer dessen Nickname auf der Liste ist kann, sobald er bei
	%s identifiziert ist, alle Befehle ausfhren die den Services Administratoren
	zur Verfgung stehen. (Dies beinhaltet auch alle Befehle fr Services Operatoren.)
	
	
	Der Befehl ADMIN ADD fgt den angegebenen Nicknamen zur Liste der
	Services Administratoren hinzu.
	
	Der ADMIN DEL Befehl entfernt den angegebenen Nicknamen von der Liste der
	Services Administratoren. Wenn eine Liste von Eintrgen bergeben wird, werden
	alle diese Eintrge entfernt. (Ein Beispiel folgt im nchsten Abschnitt.) 
	
	Der Befehl ADMIN LIST zeigt die Liste der Services Administratoren an.  
	Wird eine Maske mit einem Platzhalter bergeben, wird jeder Eintrag angezeigt,
	der der Maske entspricht. Wird eine Liste mit Nummern von Eintrgen bergeben,
	werden nur diese Eintrge angezeigt.
	
	   ADMIN LIST 2-5,7-9
	      Zeigt die Admins 2 bis 5 und 7 bis 9 an.
	      
	Mit dem Befehl ADMIN CLEAR wird die Liste geleert.
	
	Jeder IRC Operator kann den Befehl ADMIN LIST verwenden.
	Alle anderen Befehle sind auf Services Root Administratoren beschrnkt.

OPER_HELP_MODE
	Syntax: MODE Channel Modes
	
	Dieser Befehl erlaubt es einem Services Operator die Channelmodes fr jeden
	Channel zu ndern. Die Parameter sind hierbei die selben wie beim /MODE
	Befehl.
	
	Beschrnkt auf Services Operatoren.

OPER_HELP_CLEARMODES
	Syntax: CLEARMODES Channel [ALL]
	
	Entfernt alle binren Modes (wie z.B. i,k,l,m,n,p,s,t) und alle
	Channelbans von einem Channel. Wird der Parameter ALL angeben,
	werden weiterhin die Channel Usermodes (z.B. +v oder +o) entfernt.
	
	Kann nur von Services Operators verwendet werden.

OPER_HELP_KICK
	Syntax: KICK Channel Nickname Grund
	
	Mit diesem Befehl knnen IRCOPs einen Benutzer aus jedem
	Channel kicken. Die Parameter sind dieselben wie beim Standart
	/KICK Befehl. Die Kicknachricht wird den Nicknamen des IRCOPs
	enthalten der den Befehl verwendet hat.
	
	Beispiel:
	
	*** SpamMan has been kicked off channel #my_channel by %S (Alcan (Flood))
	
	Kann nur von Services Operatoren verwendet werden.

OPER_HELP_AKILL
	Syntax: AKILL ADD [+Ablaufzeit] {Maske | Nick[:Typ]} Grund
	        AKILL DEL {Maske | Eintrag | Liste}
	        AKILL LIST [Maske | Liste]
	        AKILL VIEW [Maske | Liste]
	        AKILL CLEAR
	
	Erlaubt Services Operatoren die AKILL Liste zu verndern. Wenn
	ein Benutzer, der einer Maske auf der Liste entspricht, versucht
	eine Verbindung zum	Netzwerk aufzubauen, wird ein KILL ausgefhrt.
	Auerdem wird, sofern dies von den IRC Servern untersttzt wird,
	ein Netzwerkban (K-Line) fr die Maske, auf die der Benutzer
	passt, angelegt. 
	
	AKILL ADD fgt die angegebene user@host Maske mit der
	angegebenen Begrndung (die angegeben werden muss) zu der
	AKILL Liste hinzu. Wenn anstatt einer Hostmaske ein Nickname
	angegeben wird, wird dieser automatisch zu einer entsprechenden
	Hostmaske umgesetzt. (Optional kann noch der Typ der Maske
	mit bergeben werden, um den Standardtyp zu ndern.) 
	Die Ablaufzeit muss als Ganzzahl gefolgt von einem w fr
	Wochen, einem d fr Tage, einem h fr Stunden oder einem m
	fr Minuten angegeben werden. Um einen AKILL hinzuzufgen der
	nicht abluft, gib eine Ablaufzeit von +0 an.
	Wenn die Benutzermaske mit einem + beginnt, muss eine
	Ablaufzeit mit angegeben werden. Auch dann wenn es die selbe
	wie die Standardablaufzeit sein soll. 
	Die aktuelle Standardablaufzeit fr AKILLS kann mit dem Befehl
	STATS AKILL nachgesehen werden.
	
	
	Der AKILL DEL Befehl entfernt die entsprechende Maske von der
	AKILL Liste, sofern sie vorhanden ist. Wenn eine Liste von
	Eintrgen angegeben wird, werden diese Eintrge alle entfernt.
	(Ein Beispiel folgt im nchsten Abschnitt.)
	
	
	Der AKILL LIST Befehl zeigt die AKILL Liste an.
	Wenn eine Maske mit einem Platzhalter angegeben wurde, werden
	nur Eintrge angezeigt, die dieser Maske entsprechen. Wenn die
	Maske mit einer Raute (#) beginnt, dann wird der Eintrag zu
	der Tracking ID angezeigt. (Die Tracking ID wird einem AKILL
	Grund automatisch angehngt, sodass ein Benutzer sich direkt
	darauf beziehen kann). Wird eine Liste von Eintrgen bergeben,
	so werden nur diese Eintrge angezeigt.
	
	Beispiel:
	   AKILL LIST 2-5,7-9
	      Zeigt die AKILL Eintrge 2 bis 5 und 7 bis 9 an.
	      
	
	AKILL VIEW zeigt mehr Details an als AKILL LIST. Es zeigt
	an, wer den AKILL hinzugefgt hat, wann das war, wann er
	abluft, die user@host Maske und den Grund. 
	
	
	AKILL CLEAR leert die AKILL Liste.
	
	Beschrnkt auf Service Operatoren.


OPER_HELP_SGLINE
	Syntax: SGLINE ADD [+Ablaufzeit] Maske:Grund
	    	SGLINE DEL {Maske | Eintrag | Liste}
	        SGLINE LIST [Maske | Liste]
	        SGLINE VIEW [Maske | Liste]
	        SGLINE CLEAR
	
	Erlaubt Services Operatoren die SGLINE Liste zu verndern. Ist
	der Realname eines Benutzers auf der SGLINE Liste, werden die
	Services eine weitere Nutzung des Netzwerkes unterbinden.
	
	
	SGLINE ADD fgt die angegebene Realname Maske mit der
	angegebenen Begrndung (die angegeben werden muss) zu der
	SGLINE Liste hinzu.  
	Die Ablaufzeit muss als Ganzzahl gefolgt von einem w fr
	Wochen, einem d fr Tage, einem h fr Stunden oder einem m
	fr Minuten angegeben werden. Um einen SGLINE hinzuzufgen der
	nicht abluft, gib eine Ablaufzeit von +0 an.
	Wenn die Benutzermaske mit einem + beginnt, muss eine
	Ablaufzeit mit angegeben werden. Auch dann wenn es die selbe
	wie die Standardablaufzeit sein soll. 
	Die aktuelle Standardablaufzeit fr SGLINEs kann mit dem Befehl
	STATS AKILL nachgesehen werden.
	
	HINWEIS:
	Da ein Realname Leerzeichen beinhalten kann, ist das Trennzeichen
	zwischen dem Realnamen und dem Grund ein Doppelpunkt. 	
	
	
	Der SGLINE DEL Befehl entfernt die entsprechende Maske von der
	SGLINE Liste, sofern sie vorhanden ist. Wenn eine Liste von
	Eintrgen angegeben wird, werden diese Eintrge alle entfernt.
	(Ein Beispiel folgt im nchsten Abschnitt.)
	
	
	Der SGLINE LIST Befehl zeigt die SGLINE Liste an.
	Wenn eine Maske mit einem Platzhalter angegeben wurde, werden
	nur Eintrge angezeigt, die dieser Maske entsprechen. Wenn die
	Maske mit einer Raute (#) beginnt, dann wird der Eintrag zu
	der Tracking ID angezeigt. (Die Tracking ID wird einem SGLINE
	Grund automatisch angehngt, sodass ein Benutzer sich direkt
	darauf beziehen kann.) Wird eine Liste von Eintrgen bergeben,
	so werden nur diese Eintrge angezeigt.
	
	Beispiel:
	   SGLINE LIST 2-5,7-9
	      Zeigt die SGLINE Eintrge 2 bis 5 und 7 bis 9 an.
	
	
	SGLINE VIEW zeigt mehr Details an als SGLINE LIST. Es zeigt
	an, wer die SGLINE hinzugefgt hat, wann dass war, wann sie
	abluft, die Maske und den Grund. 
	
	
	SGLINE CLEAR leert die SGLINE Liste.
	
	Dieser Befehl bentigt spezielle Funktionen der IRC-Server.
	Aus diesem Grund kann er auf einigen Netzwerken deaktiviert sein.
	
	Beschrnkt auf Service Operatoren.

OPER_HELP_SQLINE
	Syntax: SQLINE ADD [+Ablaufzeit] Maske Grund
	    	SQLINE DEL {Maske | Eintrag | Liste}
	        SQLINE LIST [Maske | Liste]
	        SQLINE VIEW [Maske | Liste]
	        SQLINE CLEAR
	
	Erlaubt Services Operatoren die SQLINE Liste zu verndern. Ist
	der Nickname eines Benutzers auf der SQLINE Liste, werden die
	Services eine weitere Nutzung des Netzwerkes unterbinden.
	
	Wenn das erste Zeichen der Maske eine Raute (#) ist, werden
	die Channel die Nutzung der Maske entsprechender Channel
	unterbinden.
	
	
	SQLINE ADD fgt die angegebene Realname Maske mit der
	angegebenen Begrndung (die angegeben werden muss) zu der
	SQLINE Liste hinzu.  
	Die Ablaufzeit muss als Ganzzahl gefolgt von einem w fr
	Wochen, einem d fr Tage, einem h fr Stunden oder einem m
	fr Minuten angegeben werden. Um einen SQLINE hinzuzufgen der
	nicht abluft, gib eine Ablaufzeit von +0 an.
	Wenn die Benutzermaske mit einem + beginnt, muss eine
	Ablaufzeit mit angegeben werden. Auch dann wenn es die selbe
	wie die Standardablaufzeit sein soll. 
	Die aktuelle Standardablaufzeit fr SQLINEs kann mit dem Befehl
	STATS AKILL nachgesehen werden.
	
	Der SQLINE DEL Befehl entfernt die entsprechende Maske von der
	SQLINE Liste, sofern sie vorhanden ist. Wenn eine Liste von
	Eintrgen angegeben wird, werden diese Eintrge alle entfernt.
	(Ein Beispiel folgt im nchsten Abschnitt.)  
	
	
	Der SQLINE LIST Befehl zeigt die SQLINE Liste an.
	Wenn eine Maske mit einem Platzhalter angegeben wurde, werden
	nur Eintrge angezeigt, die dieser Maske entsprechen. Wenn die
	Maske mit einer Raute (#) beginnt, dann wird der Eintrag zu
	der Tracking ID angezeigt. (Die Tracking ID wird einem SQLINE
	Grund automatisch angehngt, sodass ein Benutzer sich direkt
	darauf beziehen kann.) Wird eine Liste von Eintrgen bergeben,
	so werden nur diese Eintrge angezeigt.
	
	Beispiel:
	   SQLINE LIST 2-5,7-9
	      Zeigt die SQLINE Eintrge 2 bis 5 und 7 bis 9 an.
	      
	      
	SQLINE VIEW zeigt mehr Details an als SQLINE LIST. Es zeigt
	an, wer die SQLINE hinzugefgt hat, wann dass war, wann sie
	abluft, die Maske und den Grund. 
	
	
	SQLINE CLEAR leert die SGLINE Liste.
	
	
	Beschrnkt auf Service Operatoren.

OPER_HELP_SZLINE
	Syntax: SZLINE ADD [+Ablaufzeit] Maske Grund
	    	SZLINE DEL {Maske | Eintrag | Liste}
	        SZLINE LIST [Maske | Liste]
	        SZLINE VIEW [Maske | Liste]
	        SZLINE CLEAR
	
	
	Erlaubt Services Operatoren die SZLINE Liste zu verndern. 
	Versucht ein Benutzer von einer IP, die auf der SZLINE Liste
	steht, eine Verbindung herzustellen, wird diese Verbindung
	unterbunden. (Dies gilt sowohl fr IPs mit als auch ohne
	einen PTR RR)
	
	PTR RR = Reverse DNS Eintrag
	
	
	SZLINE ADD fgt die angegebene IP Maske mit der angegebenen
	Begrndung (die angegeben werden muss) zu der SZLINE Liste
	hinzu. (Einige IRC Server untersttzen das CIDR Format.) 
	Die Ablaufzeit muss als Ganzzahl gefolgt von einem w fr
	Wochen, einem d fr Tage, einem h fr Stunden oder einem m
	fr Minuten angegeben werden. Um einen SZLINE hinzuzufgen der
	nicht abluft, gib eine Ablaufzeit von +0 an.
	Wenn die Benutzermaske mit einem + beginnt, muss eine
	Ablaufzeit mit angegeben werden. Auch dann wenn es die selbe
	wie die Standardablaufzeit sein soll. 
	Die aktuelle Standardablaufzeit fr SZLINEs kann mit dem Befehl
	STATS AKILL nachgesehen werden.
	
	
	Der SZLINE DEL Befehl entfernt die entsprechende Maske von der
	SZLINE Liste sofern sie vorhanden ist. Wenn eine Liste von
	Eintrgen angegeben wird, werden diese Eintrge alle entfernt.
	(Ein Beispiel folgt im nchsten Abschnitt.)
	
	
	Der SZLINE LIST Befehl zeigt die SZLINE Liste an.
	Wenn eine Maske mit einem Platzhalter angegeben wurde, werden
	nur Eintrge angezeigt, die dieser Maske entsprechen. Wenn die
	Maske mit einer Raute (#) beginnt, dann wird der Eintrag zu
	der Tracking ID angezeigt. (Die Tracking ID wird einem SGLINE
	Grund automatisch angehngt, sodass ein Benutzer sich direkt
	darauf beziehen kann). Wird eine Liste von Eintrgen bergeben,
	so werden nur diese Eintrge angezeigt.
	
	Beispiel:
	   SZLINE LIST 2-5,7-9
	      Zeigt die SZLINE Eintrge 2 bis 5 und 7 bis 9 an.
	
	
	SZLINE VIEW zeigt mehr Details an als SZLINE LIST. Es zeigt
	an, wer die SZLINE hinzugefgt hat, wann das war, wann sie
	abluft, die Maske und den Grund. 
	
	
	SZLINE CLEAR leert die SZLINE Liste.
	
	
	Dieser Befehl bentigt spezielle Funktionen der IRC-Server.
	Aus diesem Grund kann er auf einigen Netzwerken deaktiviert
	sein.
	
	
	Beschrnkt auf Service Operatoren.
	
OPER_HELP_SET
	Syntax: SET Option Einstellung
	
	Hiermit lassen sich Globale Epona Optionen verndern.
	
	Die derzeitg Verfgbaren Optionen sind:
	    READONLY   Schaltet den Nur-Lesen Modus ein oder aus. 
	    DEBUG      Schaltet den Debug Modus ein oder aus.
	    NOEXPIRE   Schaltet den Nicht-Ablaufen Modus ein oder aus.
	    IGNORE     Schaltet den Ignore-Code ein oder aus.
	
	Beschrnkt auf Service Administratoren.

OPER_HELP_SET_READONLY
	Syntax: SET READONLY {ON | OFF}
	
	Schaltet den Nur-Lesen Modus ein oder aus. Wenn sich die
	Services im Nur-Lesen Modus befinden, ist es weder Benutzern
	noch IRC Operatoren mglich irgendwelche Einstellungen zu
	ndern.
	
	Diese Option entspricht der Kommandozeilenoption --readonly.
	
	
OPER_HELP_SET_DEBUG
	Syntax: SET DEBUG {ON | OFF | Level}
	
	Schaltet den Debug Modus ein oder aus. Im Debug Modus werden
	alle Daten, die von den Services empfangen und gesendet werden
	sowie weitere fr die Fehlersuche wichtige Nachrichten 
	protokolliert. Wird ein Level mit angegeben, wird der Umfang
	der Protokollierung auf Level eingestellt.
	
	Diese Option entspricht der Kommandozeilenoption --debug.
	
OPER_HELP_SET_NOEXPIRE
	Syntax: SET NOEXPIRE {ON | OFF}
	
	Schaltet den Nicht-Ablaufen Modus ein oder aus. In diesem
	Modus wird nichts ablaufen, bis diese Option wieder
	deaktiviert wurde.
	
	Diese Option entspricht der Kommandozeilenoption --noexpire.
OPER_HELP_SET_IGNORE
	Syntax: SET IGNORE {ON | OFF}
	
	Schaltet den IGNORE Code ein oder aus.
	
	Der Ignore-Code versucht Benutzer davon abzuhalten die
	Services zu missbrauchen, indem das stndig wiederholte
	verwenden von rechenintensiven Befehlen (Mehr als 1 Sekunde
	Ausfhrungszeit) unterbunden wird. Dies geschieht, da whrend
	der Laufzeit dieser Befehle auch kein anderer Benutzer die
	Services verwenden kann.
	
	Diese Option ist Standardmig eingeschaltet, was wir auch
	empfehlen. IRC Operatoren sind hiervon nicht betroffen.
OPER_HELP_NOOP
	Syntax: NOOP SET Server
	        NOOP REVOKE Server
	
	NOOP SET entfernt alle O:Lines vom angegebenen Server
	und killed alle IRCOps die darauf angemeldet sind, um sie
	daran zu hindern den Server zu rehashen, da dies den Effekt
	sofort rckgngig machen wrde.  
	
	NOOP REVOKE stellt alle entfernten O:Lines auf dem
	angegebenen Server wieder her.
	
	HINWEIS:
	Der Server Parameter wird von den Services nicht auf
	Gltigkeit geprft.
		
	Beschrnkt auf Service Administratoren.

OPER_HELP_JUPE
	Syntax: JUPE Server [Grund]
	
	Mit diesem Befehl kann ein Server gejupitert werden. Dies
	Bedeutet soviel wie, dass ein knstlicher Server ber die
	Services mit dem Netzwerk verbunden wird. Dies verhindert
	dass ein echter und vielleicht defekter Server die Verbindung
	herstellt.
	Der knstliche Server kann jederzeit mit einem einfachen
	SQUIT Befehl vom Netz getrennt werden.
	Wird ein Grund mit angegeben, so wird dieser im Server
	Informationsfeld hinterlegt. Wird er nicht angegeben, so
	erscheint dort der Text "Juped by <nick>" der anzeigt, wer
	den Server gejupitert hat.
	
	Beschrnkt auf Service Administratoren.

OPER_HELP_RAW
	Syntax: RAW Text
	
	Sendet den angegebenen Text direkt zu dem Server, mit dem
	die Services verbunden sind. Dieser Befehl stellt auf der einen
	Seite nur sehr zweifelhafte Vorteile zur Verfgung, kann aber
	auf der anderen Seite schwere Strungen nach sich ziehen.
	
	WARNUNG: BENUTZE DIESEN BEFEHL AUF KEINEN FALL!
	Dieser Befehl ist fr Entwickler im IRC Umfeld gedacht, die
	sich gut mit den Serverinternen Funktionen auskennen, und
	diese in der Entwicklungsphase testen wollen. Auf einem
	produktiven Netzwerk kann die Benutzung zu kleinen Strungen
	oder gar zum totalen Ausfall von Servern und Services fhren.
	
	Beschrnkt auf Service Administratoren.

OPER_HELP_SYNC
	Syntax: SYNC
	
	Veranlasst %S eine Synchronisationsanforderung an die Module
	zu schicken. Die Module interpretieren diese Nachricht auf
	jede mgliche Weise die ihnen sinnvoll erscheint. (Was auch
	bedeuten kann das sie sie ignorieren.)
	
	Datenbankmodule schreiben, bzw. importieren ihre Daten wenn
	sie diesen Befehl erhalten, und es fr sie wichtig ist.

	Beschrnkt auf Service Administratoren.
	
OPER_HELP_RELOAD
	Syntax: RELOAD
	
	Veranlasst Epona seine Konfiguration neu einzulesen.
	
	Hinweis:
	Einige Einstellungen erfordern einen kompletten Neustart der
	Services, damit sie in Kraft treten.
		
	Beschrnkt auf Service Administratoren.

OPER_HELP_RESTART
	Syntax: RESTART
	
	Veranlasst Epona dazu, alle Module zu beenden und dann
	neuzustarten.(Dies kommt dem gleich als wenn du das Programm
	beendest und direkt wieder startest.)
	
	Beschrnkt auf Service Administratoren.

OPER_HELP_STOP
	Syntax: STOP
	
	Veranlasst Epona dazu, alle Module und danach sich selbst
	zu beenden.
	
	Beschrnkt auf Service Administratoren.

OPER_HELP_FATAL
	Syntax: FATAL
	
	Veranlasst Epona dazu, alle Operationen sofort einzustellen
	und sich zu beenden. Dies fhrt dazu das Module wahrscheinlich
	nicht richtig beendet wurden.
	
	WARNUNG:
	Das abrupte Beenden von Epona kann nicht reparable Schden an
	den Datenbanken hervorrufen. Daher sollte dieser Befehl auf
	keinen Fall verwendet werden, wenn der mglicherweise
	entstehende Datenverlust ein Problem darstellt.
	
	Um Epona normal zu beenden, benutze den STOP Befehl.
	
	Beschrnkt auf Service Administratoren.

OPER_HELP_CHANLIST
	Syntax: CHANLIST [{[Muster] [Bereich] [NOLIMIT] | Nick} [SECRET]]
	
	Zeigt alle Channel die im Moment auf dem IRC Netzwerk in
	Benutzung sind. Und zwar sowohl die, die registriert sind,
	als auch die nicht registrierten.
	
	Wenn Muster mit angegeben wird, dann werden nur Channel
	angezeigt, deren Name dem Suchmuster entspricht. Die Anzahl
	der Ergebnisse die angezeigt werden ist begrenzt. Du kannst
	aber einen Bereich angeben, um die Ergebnisse die ber dieses
	Limit hinausgehen zu betrachten. 
	
	Ein Beispiel:
	   CHANLIST 51-100
	       Zeigt die Ergebnisse 51 bis 100.
	   CHANLIST *epona* 15-20
	       Zeigt die Ergebnisse 15 bis 20 deren Name "epona" enthlt.
	
	(Hinweis: Im Gegensatz zu den Nummernlisten ist es hier nicht
	 mglich die erweiterte Schreibweise wie z.B. 51-60,75-80 zu
	 benutzen.)
		
	Wird ein Suchmuster oder Bereich angegeben, und die NOLIMIT
	Option verwendet, dann wird die Anzahl der Ergebnisse, die
	angezeigt werden, nicht begrenzt.
	
	Wird anstatt eines Suchmusters ein Nickname angegeben, werden
	alle Channel angezeigt, in denen sich ber Benutzer gerade aufhlt. 
	
	In beiden Fllen kann die Suche durch angeben der SECRET
	Option auf +s und +p Channel beschrnkt werden.
		
	Beschrnkt auf Service Administratoren.

OPER_HELP_USERLIST
	Syntax: USERLIST [{[Muster] [Bereich] [NOLIMIT] | Channel} [INVISIBLE]]
	
	Zeigt alle Benutzer die im Moment mit dem IRC Netzwerk 
	verbunden sind. Und zwar sowohl die, die registriert sind,
	als auch die nicht registrierten.
	
	Wird ein Muster angegeben, so werden nur Benutzer, deren
	Usermaske (Im Format nick!user@host) dem Suchmuster entspricht,
	angezeigt. Die Anzahl der Ergebnisse die angezeigt werden ist
	begrenzt. Du kannst aber einen Bereich angeben, um die
	Ergebnisse die ber dieses Limit hinausgehen zu betrachten. 
	
	Ein Beispiel:
	   USERLIST 51-100
	       Zeigt die Ergebnisse 51 bis 100.
	   USERLIST *epona* 15-20
	       Zeigt die Ergebnisse 15 bis 20 deren Nickname "epona"
	       enthlt.
	
	(Hinweis: Im Gegensatz zu den Nummernlisten ist es hier nicht
	 mglich die erweiterte Schreibweise wie z.B. 51-60,75-80 zu
	 benutzen.)
	
	Wird ein Suchmuster oder Bereich angegeben, und die NOLIMIT
	Option verwendet, dann wird die Anzahl der Ergebnisse, die
	angezeigt werden, nicht begrenzt.
	
	Wird anstatt eines Suchmusters ein Channel angegeben, werden
	nur Benutzer angezeigt, die sich im angegebenen Channel befinden.
		
	In beiden Fllen kann die Suche durch angeben der INVISIBLE
	Option auf +s und +p Channel beschrnkt werden.
		
	Beschrnkt auf Service Administratoren. 
	
OPER_HELP_BLACKLIST
	Syntax: BLACKLIST DEL Hostname
	        BLACKLIST LIST [Muster]
	
	Der BLACKLIST DEL Befehl entfernt den angegebenen Hostnamen
	von der Blacklist. Bitte beachte das diese nderung nur
	temporr ist, da die Blacklist Datei nicht verndert wird.
	
	Mit dem BLACKLIST LIST Befehl kann man sich die Hosts auf der
	Liste ansehen. Gibt man ein Muster mit an, werden nur die
	Hosts angezeigt, die dem Suchmuster entsprechen.

	Beschrnkt auf Service Administratoren.

OPER_HELP_MODULES
	Syntax: MODULES LOAD Name
	        MODULES UNLOAD Name
	        MODULES LIST
	        MODULES INFO Name
	        MODULES QUERY Name Anfrage
	
	Der MODULES LOAD Befehl, ldt das Modul mit dem angegebenen
	Namen direkt zur Laufzeit.
	
	Hinweis:
	Das Laden eines Modules, das fr eine andere Version von Epona
	oder fr andere Versionen der anderen Module compiliert wurde, 
	kann zum kompletten Absturz der Services fhren.
	Aus diesem Grund empfehlen wir diesen Befehl nicht zu
	verwenden, auer du bist dir sicher, dass du weist was du tust.
	
	Mit dem MODULES UNLOAD Befehl knnen Module whrend der
	Laufzeit entladen werden. Du kannst allerdings keine Module
	entladen, deren Referenzzhler nicht 0 ist.
	
	Der MODULES LIST Befehl zeigt alle derzeitig geladenen Module
	inklusive ihrer Beschreibung und dem Referenzzhler an.
	
	Mit MODULES INFO lassen sich detailierte Informationen ber
	das Modul dessen Name bergeben wurde anzeigen.
	
	Der MODULES QUERY Befehl sendet die angegebene Anfrage
	zu dem Modul dessen Name bergeben wurde. Falls das Modul
	eine Antwort darauf hat, wird diese angezeigt.
	
	Kann von Services Root Administratoren verwendet werden.

###########################################################################
#
# BotServ help messages
#
###########################################################################
	
BOT_HELP
	%S ermglicht es dir einen Bot in deinem Channel zu haben.
	BotServ wurde erstellt fr User die keinen eigenen Bot hosten
	oder konfigurieren knnen oder zur Benutzung auf Netzwerken die
	keine User-Bots erlauben. Verfgbare Befehle sind unten aufge-
	listet; um sie zu benutzen gib /msg %S Befehl ein. 
	Fr weitere Informationen zu einem bestimmten Befehl gib /msg 
	%S HELP Befehl ein.
	
	BOTLIST            Zeigt verfgbare Bots an.
	ASSIGN             Weist einem Channel einen Bot zu.
	SET                Stellt Bot-Optionen ein.
	KICK               Stellt Kick-Optionen ein.
	BADWORDS           Badwords-Verwaltung.
	
	Weitere Befehle: ACT INFO SAY UNASSIGN
	
	Bot joined einen Channel wenn mindestens %d User in ihm sind.
	
BOT_HELP_BOTLIST
	Syntax: BOTLIST
	
	Zeigt alle verfgbaren Bots auf diesem Netzwerk an.
	
BOT_HELP_ASSIGN
	Syntax: ASSIGN Channel Bot
	
	Weist Bot dem Channel zu. Du kannst den Bot
	dann entsprechend dem Channel konfigurieren.
	
BOT_HELP_UNASSIGN
	Syntax: UNASSIGN Channel
	
	Entfernt den Bot aus dem Channel. Wenn du diesen Befehl
	benutzt wird der Bot den Channel nicht mehr betreten.
	Die Bot-Optionen fr diesen Channel bleiben jedoch ge-
	speichert so dass du jederzeit den Bot wieder dem Channel
	zuweisen kannst ohne ihn neu konfigurieren zu mssen.
	
BOT_HELP_INFO
	Syntax: INFO {Channel | Bot}
	
	Ermglicht dir %S Informationen ber den Channel oder Bot
	anzeigen zu lassen. Wenn der Parameter ein Channel ist,
	wirst du Informationen ber die Bot-Optionen und einge-
	schaltene Kicker erhalten. Wenn der Parameter ein Nickname
	ist bekommst du Informationen ber den Bot - wie zum
	Beispiel sein Erstellungsdatum oder die Anzahl der 
	Channels in denen sich der Bot befindet.
	
BOT_HELP_SET
	Syntax: SET Channel Option Parameter
	
	Stellt Bot-Optionen ein.  Option kann eine der folgenden sein:
	
	    DONTKICKOPS      Ops vor Kicks des Bots schtzen.
	    DONTKICKVOICES   Voices vor Kicks des Bots schtzen.
	    GREET            Begrssungsnachricht-Optionen einstellen.
	    FANTASY          FANTASY-Befehle einstellen.
	    SYMBIOSIS        Bot handelt wie ein richtiger Bot.
	
	Gib /msg %S HELP SET Option ein fr weitere 
	Informationen einer bestimmten Option.
	
	Achtung: Zugriff auf diesen Befehl ist abhngig vom mit "SET"
	eingestellten Level.
	
BOT_HELP_SET_DONTKICKOPS
	Syntax: SET Channel DONTKICKOPS {ON|OFF}
	
	Schaltet den Ops-Schutz ein oder aus in einem Channel.
	Wenn eingeschalten werden Ops nicht vom Bot gekickt auch 
	wenn sie nicht dem NOKICK-Level entsprechen.
	
BOT_HELP_SET_DONTKICKVOICES
	Syntax: SET Channel DONTKICKVOICES {ON|OFF}
	
	Schaltet den Voices-Schutz ein oder aus in einem Channel.
	Wenn eingeschalten werden Voices nicht vom Bot gekickt auch 
	wenn sie nicht dem NOKICK-Level entsprechen.
	
BOT_HELP_SET_FANTASY
	Syntax: SET Channel FANTASY {ON|OFF}
	
	Schaltet den Fantasy-Modus ein oder aus in einem Channel
	Wenn er aktiviert ist knnen User Befehle wie !op, !deop,
	!voice, !devoice,	!kick, !kb, !unban, !seen in einem
	Channel benutzen. (Manche knnen mit Nick und Grund
	als Parameter benutzt werden).
	
	Beachte dass User die Fantasy-Befehle benutzen wollen
	ausreichende Rechte, sowohl fr den Fantasy-Modus als
	auch den Befehl den sie ausfhren wollen, haben mssen.
	(um zum Beispiel !op zu nutzen muss der Benutzer Zugriff
	auf dass OPDEOP-Level haben).
	
BOT_HELP_SET_GREET
	Syntax: SET Channel GREET {ON|OFF}
	
	Schaltet den Begrssungsmodus an oder aus in einem
	Channel. Wenn er aktiviert ist, zeigt der Bot Begrssungs-
	nachrichten an wenn User den Channel betreten und sie
	ausreichend Zugriffsrechte in diesem Channel haben. 
	
BOT_HELP_SET_SYMBIOSIS
	Syntax: SET Channel SYMBIOSIS {ON|OFF}
	
	Schaltet den Symbiose-Modus an oder aus in einem
	Channel. Wenn er aktiviert ist bernimmt der Bot alle
	Aufgaben von %s in einem Channel wie z.B. MODEs, KICKs
	und die Begrssungsnachricht.
	
BOT_HELP_KICK
	Syntax: KICK Channel Option Parameter
	
	Stellt Bot-Kickeroptionen ein.  Option kann eine der folgenden sein:
	
	    BOLDS         Stellt ein ob der Bot bei Fettschrift kickt.
	    BADWORDS      Stellt ein ob der Bot bei Badwords kickt.
	    CAPS          Stellt ein ob der Bot bei Grosschreibung kickt.
	    COLORS        Stellt ein ob der Bot bei Farben kickt.
	    FLOOD         Stellt ein ob der Bot bei Floodern kickt.
	    REPEAT        Stellt ein ob der Bot User kickt die sich
	    	                       wiederholen.
	    REVERSES      Stellt ein ob der Bot bei Inversschreiben kickt.
	    UNDERLINES    Stellt ein ob der Bot bei Unterstreichen kickt.
	
	Gib /msg %S HELP KICK Option ein fr weitere Informationen
	zu einer bestimmten Option
	
	Achtung: Zugriff auf diesen Befehl ist abhngig vom mit "SET"
	eingestellten Level.
	
BOT_HELP_KICK_BOLDS
	Syntax: KICK Channel BOLDS {ON | OFF} [kbb]

	Schaltet den Fettschrift-Kicker an oder aus. Wenn er aktiviert
	ist werden User die Fett schreiben vom Bot gekickt.

	kbb ist die Anzahl wie oft ein User gekickt wird bevor er
	gebannt wird. Weglassen dieses Parameters schaltet Bannen aus.

BOT_HELP_KICK_COLORS
	Syntax: KICK Channel COLORS {ON | OFF} [kbb]

	Schaltet den Farben-Kicker an oder aus. Wenn er aktiviert ist
	werden User die Farbig schreiben vom Bot gekickt.

	kbb ist die Anzahl wie oft ein User gekickt wird bevor er
	gebannt wird. Weglassen dieses Parameters schaltet Bannen aus.

BOT_HELP_KICK_REVERSES
	Syntax: KICK Channel REVERSES {ON | OFF} [kbb]

	Schaltet den Inversschrift-Kicker an oder aus. Wenn er aktiviert
	ist werden User die Invers schreiben vom Bot gekickt.

	kbb ist die Anzahl wie oft ein User gekickt wird bevor er
	gebannt wird. Weglassen dieses Parameters schaltet Bannen aus.

BOT_HELP_KICK_UNDERLINES
	Syntax: KICK Channel UNDERLINES {ON | OFF} [kbb]

	Schaltet den Unterstreichen-Kicker an oder aus. Wenn er aktiviert
	ist werden User die Unterstrichen schreiben vom Bot gekickt.

	kbb ist die Anzahl wie oft ein User gekickt wird bevor er
	gebannt wird. Weglassen dieses Parameters schaltet Bannen aus.

BOT_HELP_KICK_CAPS
	Syntax: KICK Channel CAPS {ON | OFF} [kbb [min [Prozent]]]

	Schaltet den Grossschreibungs-Kicker an oder aus. Wenn er aktiviert
	ist werden User die Grossschreiben vom Bot gekickt.

	Der Bot kickt nur wenn mindestens min Zeichen Gross ge-
	schrieben worden sind und sie mindestens Prozent%% der
	gesamten Nachricht sind (Standartmssig 10 Zeichen und 25%%).

	kbb ist die Anzahl wie oft ein User gekickt wird bevor er
	gebannt wird. Weglassen dieses Parameters schaltet Bannen aus.

BOT_HELP_KICK_FLOOD
	Syntax: KICK Channel FLOOD {ON | OFF} [kbb [Zeilen [Sek]]]

	Schaltet den Flood-Kicker an oder aus. Wenn er aktiviert ist
	werden User die den Channel mit mindestens Zeilen Zeilen
	in Sek Sekunden Flooden, gekickt. (Standartmssig 6
	Zeilen in 10 Sekunden).
	
	kbb ist die Anzahl wie oft ein User gekickt wird bevor er
	gebannt wird. Weglassen dieses Parameters schaltet Bannen aus.

BOT_HELP_KICK_REPEAT
	Syntax: KICK Channel REPEAT {ON | OFF} [kbb [num]]

	Schaltet den Wiederholungs-Kicker an oder aus. Wenn er aktiviert
	ist werden User vom Bot gekickt die sich num mal wieder-
	holen (Standartmssig 3 mal).

	kbb ist die Anzahl wie oft ein User gekickt wird bevor er
	gebannt wird. Weglassen dieses Parameters schaltet Bannen aus.
	
BOT_HELP_KICK_BADWORDS
	Syntax: KICK Channel BADWORDS {ON | OFF} [kbb]

	Schaltet den Badwords-Kicker an oder aus. Wenn er aktiviert ist
	kickt der Bot User die bestimmte Wrter im Channel sagen.

	Du kannst Badwords fr deinen Channel mit dem BADWORDS 
	Befehl einstellen. Gib /msg %S HELP BADWORDS ein fr
	weitere Informationen.

	kbb ist die Anzahl wie oft ein User gekickt wird bevor er
	gebannt wird. Weglassen dieses Parameters schaltet Bannen aus.

BOT_HELP_BADWORDS
	Syntax: BADWORDS Channel ADD Ausdruck [SINGLE | START | END]
	        BADWORDS Channel DEL {Ausdruck | Eintrag-Nummer | Liste}
	        BADWORDS Channel LIST [Maske | Liste]
	        BADWORDS Channel CLEAR
	
	ndert oder zeigt die Badwords-Liste eines Channels an die
	festlegt welche Wrter den Badwords-Kicker auslsen wenn er
	aktiviert ist. Fr weitere Informationen gib
	/msg %S HELP KICK BADWORDS ein.
	
	BADWORDS ADD fgt den angegebenen Ausdruck zur Badwords-
	Liste hinzu. Die SINGLE Option, wenn angegeben, stellt sicher
	dass der Ausdruck ein ganzes Wort ist bevor der Kicker ausgelst wird.
	Die START Option stellt sicher dass der Ausdruck am Anfang
	eines Wortes steht und die END Option stellt sicher dass der
	Ausdruck am Ende eines Wortes steht. Wenn keine Option angegeben
	wurde, wird der Kicker jedesmal ausgelst wenn der Ausdruck teil
	eines Wortes ist.
	
	Zum Beispiel:
	
	  BADWORDS ADD tick
	        Fgt den Ausdruck tick zur Badwords-Liste hinzu. Der
	        Kicker wrde durch die Worte "tick", "stick", "ticks"
	        oder "sticks" ausgelst.
	  BADWORDS ADD tick SINGLE
	        Fgt den Ausdruck tick zur Badwords-Liste mit der
	        SINGLE Option hinzu. Der Kicker wrde nur 
	        durch dass Wort "tick" ausgelst.
	  BADWORDS ADD tick START
	        Fgt den Ausdruck tick zur Badwords-Liste mit der
	        START Option hinzu. Der Kicker wrde bei
	        den Wrtern "tick" oder "ticks" ausgelst werden.
	  BADWORDS ADD tick END
	        Fgt den Ausdruck tick zur Badwords-Liste mit der
	        END Option hinzu. Der Kicker wrde bei
	        den Wrtern "tick" oder "stick" ausgelst werden.
	
	Bitte beachte dass der Ausdruck KEINE Wildcards untersttzt!
	
	Der BADWORDS DEL Befehl entfernt den angegebenen Ausdruck
	von der Badwords-Liste wenn er vorhanden ist. Wenn eine Liste
	mit Eintrag-Nummern angegeben wurde, werden diese Eintrge ge-
	lscht. (Siehe Beispiel fr LIST unterhalb).
	
	Der BADWORDS LIST Befehl zeigt eine Liste der Badwords an.  
	Wenn eine Maske mit Wildcards angegeben wurde, werden nur die
	Eintrge die der Maske entsprechen angezeigt. Wenn eine Liste
	mit Eintrag-Nummern angegeben wurde, werden nur diese Eintrge
	angezeigt, zum Beispiel:
	
	   BADWORDS LIST 2,7-9
	      Zeigt eine Liste der Badwords 2 und 7 
	      bis 9 an.
	
	BADWORDS CLEAR lscht alle Eintrge auf der Badwords-Liste.

BOT_HELP_SAY
	Syntax: SAY Channel Text
	
	Lsst den Bot den angegebenen Text in Channel "sagen".

BOT_HELP_ACT
	Syntax: ACT Channel Text
	
	Lsst den Bot den angegebenen Text als "/me" Befehl im
	Channel "sagen".

BOT_SERVADMIN_HELP
	
	Der folgende Befehl ist fr Services-Admins verfgbar:
	
	    BOT              Verwaltet die Bot-Liste des Netzwerks.

BOT_SERVADMIN_HELP_BOT
	Syntax: BOT ADD Nick Username Hostname Realname
	        BOT CHANGE Alternick Nick [Username [Hostname [Realname]]]
	        BOT DEL Nick
	        BOT LIST
	
	Ermglicht es Services-Admins Bots zu erstellen, zu ndern und zu lschen,
	die User dann in ihren Channels benutzen knnen.
	
	BOT ADD fgt einen Bot mit dem angegebenen Nickname, Username,
	Hostname und Realname hinzu. Da keinerlei Validierung dieser Ein-
	stellungen vorgenommen wird ist Vorsicht geboten.
	BOT CHANGE ermglicht es den Nickname, Username, Hostname oder
	Realname eines Bots zu ndern ohne ihn zu lschen (und demzufolge
	bleibt der Bot in allen Channels denen er aktuell zugewiesen ist).
	BOT DEL lscht den angegebenen Bot aus der Botliste.  
	BOT LIST ist ein Alias fr BOTLIST und gibt nur eine
	Liste der verfgbaren Bots auf diesem Netzwerk aus.
	
	Achtung: Wenn du einen Bot erstellst der einem derzeit
	registrierten Nick gleicht, wird dieser gedropped und falls 
	dieser gerade in Benutzung ist wird der betreffende User
	gekilled.
	
BOT_SERVADMIN_HELP_SET
	
	Diese Optionen sind auf Services-Admins beschrnkt:
	
	    NOBOT            Verhindert dass ein Bot einem Channel 
	                        zugewiesen wird.
	    PRIVATE          Verhindert dass der Bot von einem
	                        nicht-IRCOp zugewiesen wird.

BOT_SERVADMIN_HELP_SET_NOBOT
	Syntax: SET Channel NOBOT {ON | OFF}
	
	Diese Option verhindert dass einem Channel ein Bot zu-
	gewiesen werden kann. Wenn bereits ein Bot zugewiesen ist,
	wird dieser automatisch entfernt sobald die Option
	aktiviert wurde.
	
	Beschrnkt auf Services-Admins.

BOT_SERVADMIN_HELP_SET_PRIVATE
	Syntax: SET Bot-Nick PRIVATE {ON | OFF}
	
	Diese Option aktivert oder deaktiviert dass dieser
	Bot nur noch von IRC-Ops einem Channel zugewiesen 
	werden kann.
	
	Beschrnkt auf Services-Admins.
